/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DiversityNavigatorProperties.java
 *
 * Created on 16. Mai 2002, 15:16
 */

package net.metadiversity.diversity.navigator;

import javax.swing.ImageIcon;

import org.apache.log4j.Logger;
/**
 *
 * @author  didi
 */
public class DiversityNavigatorProperties 
{
    static Logger logger = Logger.getLogger( DiversityNavigatorProperties.class );
    
    private static java.util.ResourceBundle bundle;
    private static String iconPath;
    private static String userHomePath;
    private static String iconDiversity;
    private static String iconExportXml;
    private static String iconImportXml;
    private static String iconExportTab;
    private static String iconImportTab;
    private static String iconSave;
    private static String iconOpen;
    private static String iconExecute;
    private static String iconNew;
    private static String iconDelete;
    private static String iconCheckboxTrue;
    private static String iconCheckboxNull;
    private static String iconCheckboxFalse;
    private static String iconDbTreeRoot;
    private static String iconDbTreeProject;
    private static String iconDbTreeDBGroup;
    private static String iconDbTreeDatabase;
    private static String iconDbTreeTable;
    private static String iconDbTreeField;
    
    private static String iconAboutDiversity;
    
    private static String diversityNavigatorVersion;
    private static String diversityNavigatorBuild;
    
    private static ImageIcon    diversityImageIcon;
    private static ImageIcon    exportXmlImageIcon;
    private static ImageIcon    importXmlImageIcon;
    private static ImageIcon    exportTabImageIcon;
    private static ImageIcon    importTabImageIcon;
    private static ImageIcon    saveImageIcon;
    private static ImageIcon    openImageIcon;
    private static ImageIcon    executeImageIcon;
    private static ImageIcon    newImageIcon;
    private static ImageIcon    deleteImageIcon;

    private static ImageIcon    checkboxTrueImageIcon;
    private static ImageIcon    checkboxNullImageIcon;
    private static ImageIcon    checkboxFalseImageIcon;
    
    private static ImageIcon    aboutDiversityImageIcon;
    
    private static ImageIcon    dbTreeRootImageIcon;
    private static ImageIcon    dbTreeProjectImageIcon;
    private static ImageIcon    dbTreeDBGroupImageIcon;
    private static ImageIcon    dbTreeDatabaseImageIcon;
    private static ImageIcon    dbTreeTableImageIcon;
    private static ImageIcon    dbTreeFieldImageIcon;
    
    // Menu Icons
    //--------------------------------------------------------------------------
    private static ImageIcon    menuIconExit;
    private static ImageIcon    menuIconConnection;
    
    private static ImageIcon    menuIconAddConnection;
    private static ImageIcon    menuIconEditConnection;
    private static ImageIcon    menuIconDelConnection;
    
    /** Creates a new instance of DiversityNavigatorProperties */
    public DiversityNavigatorProperties()
    {
        init();
    }
    public void init()
    {
        logger.info( "init" );
        // get bundle
        bundle          = java.util.ResourceBundle.getBundle( "net/metadiversity/diversity/navigator/DiversityNavigatorGlobalProperties" );
        // get Diversity Navigator properties
        
        diversityNavigatorVersion = bundle.getString( "diversity.navigator.version" );
        diversityNavigatorBuild   = bundle.getString( "diversity.navigator.build" );
        
        iconDiversity   = bundle.getString( "icon.diversity" );
        iconExportXml   = bundle.getString( "icon.exportXml" );
        iconImportXml   = bundle.getString( "icon.importXml" );
        iconExportTab   = bundle.getString( "icon.exportTab" );
        iconImportTab   = bundle.getString( "icon.importTab" );
        iconSave        = bundle.getString( "icon.save" );
        iconOpen        = bundle.getString( "icon.open" );
        iconExecute     = bundle.getString( "icon.execute" );
        iconNew         = bundle.getString( "icon.new" );
        iconDelete      = bundle.getString( "icon.delete" );

        iconCheckboxTrue    = bundle.getString( "icon.checkboxTrue" );
        iconCheckboxNull    = bundle.getString( "icon.checkboxNull" );
        iconCheckboxFalse   = bundle.getString( "icon.checkboxFalse" );
        
        iconAboutDiversity  = bundle.getString( "icon.diversity.about" );
        
        iconDbTreeRoot      = bundle.getString( "icon.db.tree.root" );
        iconDbTreeProject   = bundle.getString( "icon.db.tree.project" );
        iconDbTreeDBGroup   = bundle.getString( "icon.db.tree.dbgroup" );
        iconDbTreeDatabase  = bundle.getString( "icon.db.tree.database" );
        iconDbTreeTable     = bundle.getString( "icon.db.tree.table" );
        iconDbTreeField     = bundle.getString( "icon.db.tree.field" );
        
        userHomePath    = System.getProperty( "user.home" );
        
        iconPath = "/net/metadiversity/diversity/navigator/images/";
        
        diversityImageIcon = new ImageIcon( getClass().getResource( iconPath + iconDiversity ));
        exportXmlImageIcon = new ImageIcon( getClass().getResource( iconPath + iconExportXml ));
        importXmlImageIcon = new ImageIcon( getClass().getResource( iconPath + iconImportXml ));
        exportTabImageIcon = new ImageIcon( getClass().getResource( iconPath + iconExportTab ));
        importTabImageIcon = new ImageIcon( getClass().getResource( iconPath + iconImportTab ));
        openImageIcon      = new ImageIcon( getClass().getResource( iconPath + iconOpen      ));
        saveImageIcon      = new ImageIcon( getClass().getResource( iconPath + iconSave      ));
        executeImageIcon   = new ImageIcon( getClass().getResource( iconPath + iconExecute   ));
        newImageIcon       = new ImageIcon( getClass().getResource( iconPath + iconNew       ));
        deleteImageIcon    = new ImageIcon( getClass().getResource( iconPath + iconDelete    ));
        
        checkboxTrueImageIcon   = new ImageIcon( getClass().getResource( iconPath + iconCheckboxTrue  ));
        checkboxNullImageIcon   = new ImageIcon( getClass().getResource( iconPath + iconCheckboxNull  ));
        checkboxFalseImageIcon  = new ImageIcon( getClass().getResource( iconPath + iconCheckboxFalse ));
        
        aboutDiversityImageIcon     = new ImageIcon( getClass().getResource( iconPath + iconAboutDiversity ));
        
        menuIconExit            = new ImageIcon( getClass().getResource( iconPath + bundle.getString( "menu.icon.exit"              ) ) );
        menuIconConnection      = new ImageIcon( getClass().getResource( iconPath + bundle.getString( "menu.icon.connection"        ) ) );
        menuIconAddConnection   = new ImageIcon( getClass().getResource( iconPath + bundle.getString( "menu.icon.connection.add"    ) ) );
        menuIconEditConnection  = new ImageIcon( getClass().getResource( iconPath + bundle.getString( "menu.icon.connection.edit"   ) ) );
        menuIconDelConnection   = new ImageIcon( getClass().getResource( iconPath + bundle.getString( "menu.icon.connection.del"    ) ) );
        // DB Tree icons
        // dbTreeRootImageIcon     = new ImageIcon( getClass().getResource( iconPath + iconDbTreeRoot      ));
        dbTreeRootImageIcon     = getDnImageIcon( iconDbTreeRoot    );
        // dbTreeProjectImageIcon  = new ImageIcon( getClass().getResource( iconPath + iconDbTreeProject   ));
        dbTreeProjectImageIcon  = getDnImageIcon( iconDbTreeProject );
        // dbTreeDBGroupImageIcon  = new ImageIcon( getClass().getResource( iconPath + iconDbTreeDBGroup   ));
        dbTreeDBGroupImageIcon  = getDnImageIcon( iconDbTreeDBGroup );
        dbTreeDatabaseImageIcon = new ImageIcon( getClass().getResource( iconPath + iconDbTreeDatabase  ));
        dbTreeTableImageIcon    = new ImageIcon( getClass().getResource( iconPath + iconDbTreeTable     ));
        dbTreeFieldImageIcon    = new ImageIcon( getClass().getResource( iconPath + iconDbTreeField     ));
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private ImageIcon getDnImageIcon( String iconName )
    {
        try
        {
            return new ImageIcon( getClass().getResource( iconPath + iconName ) );
        }
        catch( Exception ex )
        {
            logger.error( ex );
            logger.error( "Can't load icon: " + iconPath + iconName );
            // ??? return default icon
            return null;
        }
    }
    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) 
    {
        // init();
        DiversityNavigatorProperties p = new DiversityNavigatorProperties();
        logger.debug( "Icon path : " + DiversityNavigatorProperties.getIconPath() );
        logger.debug( "User home : " + DiversityNavigatorProperties.getUserHomePath() );
        // System.out.println( "Icon path : " + DiversityNavigatorProperties.getIconPath() );
        // System.out.println( "User home : " + DiversityNavigatorProperties.getUserHomePath() );
    }
    // diversity navigator infos
    
    public static String getDiversityNavigatorVersion()
    {
        return diversityNavigatorVersion;
    }
    public static String getDiversityNavigatorBuild()
    {
        return diversityNavigatorBuild;
    }
    
    // Icons    
    public static String getIconPath() 
    {
        return iconPath;
    }
    public static String getUserHomePath() 
    {
        return userHomePath;
    }
    public static ImageIcon getDiversityIcon()
    {
        return diversityImageIcon;
    }
    public static ImageIcon getExportXmlIcon()
    {
        return exportXmlImageIcon;
    }
    public static ImageIcon getImportXmlIcon()
    {
        return importXmlImageIcon;
    }
    public static ImageIcon getExportTabIcon()
    {
        return exportTabImageIcon;
    }
    public static ImageIcon getImportTabIcon()
    {
        return importTabImageIcon;
    }
    public static ImageIcon getSaveIcon()
    {
        return saveImageIcon;
    }
    public static ImageIcon getOpenIcon()
    {
        return openImageIcon;
    }
    public static ImageIcon getExecuteIcon()
    {
        return executeImageIcon;
    }
    public static ImageIcon getNewIcon()
    {
        return newImageIcon;
    }
    public static ImageIcon getDeleteIcon()
    {
        return deleteImageIcon;
    }
    public static ImageIcon getAboutDiversityIcon()
    {
        return aboutDiversityImageIcon;
    }
    //--------------------------------------------------------------------------
    // menu icons
    //--------------------------------------------------------------------------
    public static ImageIcon getMenuIconExit()
    {
        return menuIconExit;
    }
    public static ImageIcon getMenuIconConnection()
    {
        return menuIconConnection;
    }
    public static ImageIcon getMenuIconAddConnection()
    {
        return menuIconAddConnection;
    }
    public static ImageIcon getMenuIconEditConnection()
    {
        return menuIconEditConnection;
    }
    public static ImageIcon getMenuIconDelConnection()
    {
        return menuIconDelConnection;
    }
    //--------------------------------------------------------------------------
    // Checkbox icons
    //--------------------------------------------------------------------------
    public static ImageIcon getCheckboxTrueIcon()
    {
        return checkboxTrueImageIcon;
    }
    public static ImageIcon getCheckboxNullIcon()
    {
        return checkboxNullImageIcon;
    }
    public static ImageIcon getCheckboxFalseIcon()
    {
        return checkboxFalseImageIcon;
    }    
    //--------------------------------------------------------------------------
    // DB Conection Tree icons
    //--------------------------------------------------------------------------
    public static ImageIcon getDbTreeRootIcon()
    {
        return dbTreeRootImageIcon;
    }
    public static ImageIcon getDbTreeProjectIcon()
    {
        return dbTreeProjectImageIcon;
    }
    public static ImageIcon getDbTreeDBGroupIcon()
    {
        return dbTreeDBGroupImageIcon;
    }
    public static ImageIcon getDbTreeDatabaseIcon()
    {
        return dbTreeDatabaseImageIcon;
    }
    public static ImageIcon getDbTreeTableIcon()
    {
        return dbTreeTableImageIcon;
    }
    public static ImageIcon getDbTreeFieldIcon()
    {
        return dbTreeFieldImageIcon;
    }
    
}
