/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.checklists.dataimport;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.*;

import java.util.*;
import org.jdom.*;
// import org.jdom.input.*;
// import org.jdom.output.*;

import net.metadiversity.diversity.navigator.checklists.database.*;
import net.metadiversity.diversity.navigator.gui.DnOptionPane;

import org.apache.log4j.Logger;

/**
 * Describe class <code>XmlConfigurationImpl</code> here.
 *
 * @author <a href="mailto:didi@china.didi.dn"></a>
 * @version 1.0
 */
public class XmlConfigurationImpl implements XmlConfiguration
{
    static Logger logger = Logger.getLogger( XmlConfigurationImpl.class.getName() );
    private boolean debugFlag = false;  

    final static boolean setAutoCommit = false;  // AutoCommit not posible whis SuSE 9.1 and Postgresql Version: 7.4
    
    private static java.lang.String filename;

    private static Document             doc = null;
    private static Element              root = null;

    private java.lang.String  HeaderChecklist;
    private java.lang.String  HeaderChecklistName;
    private java.lang.String  HeaderChecklistSourceID; 
    private java.lang.String  HeaderChecklistAuthors; 
    private java.lang.String  HeaderChecklistVersion; 
    private java.lang.String  HeaderChecklistOriginalURL; 
    private java.lang.String  HeaderChecklistInstitution;

    private java.lang.String  HeaderGeographyOriArea; 
    private java.lang.String  HeaderGeographyEdtAreaID;

    private java.lang.String  HeaderAcknowledgementTitle; 
    private java.lang.String  HeaderAcknowledgementText;
    private java.lang.String  HeaderAcknowledgementDisplay;
    private java.lang.String  HeaderAcknowledgementLinkURL; 
    private java.lang.String  HeaderAcknowledgementLinkHidden;

    private java.lang.String  HeaderAcknowledgementIconHeight;
    private java.lang.String  HeaderAcknowledgementIconWidth;
    private java.lang.String  HeaderAcknowledgementStyleSheetURL;
    private java.lang.String  HeaderAcknowledgementBackgroundGIF;

    private java.lang.String  HeaderAcknowledgementNotes;

    private java.lang.String  HeaderCopyrightText; 
    private java.lang.String  HeaderCopyrightDisplay; 
    private java.lang.String  HeaderCopyrightLinkURL; 
    private java.lang.String  HeaderCopyrightLinkHidden;
    private java.lang.String  HeaderCopyrightNotes;

    private java.lang.String  HeaderIconURL;
    private java.lang.String  HeaderIconDisplay; 
    private java.lang.String  HeaderIconLinkURL; 
    private java.lang.String  HeaderIconLinkHidden;
    private java.lang.String  HeaderIconDescription; 
    private java.lang.String  HeaderIconInlineWithText; 
    private java.lang.String  HeaderIconWidth; 
    private java.lang.String  HeaderIconHeight;

    private java.lang.String  HeaderInternNotesImportNotes;
    private java.lang.String  HeaderInternNotesResponsible;  
    private java.lang.String  HeaderInternNotesLogCreated_User; 
    private java.lang.String  HeaderInternNotesProjectMarker; 
    private java.lang.String  HeaderInternNotesInternetPassword;

    private java.lang.String  HeaderOGU_InformationText; 
    private java.lang.String  HeaderOGU_InformationLinks; 
    private java.lang.String  CheckListData; 

      /**
       * Creates a new <code>XmlConfigurationImpl</code> instance.
       *
       * @param file a <code>String</code> value
       */
      public XmlConfigurationImpl( String file )
      {
            org.jdom.input.SAXBuilder builder = new org.jdom.input.SAXBuilder();
            try 
            {
                /*
                if( true )
                {    
                    java.lang.Runtime rt = Runtime.getRuntime();
                    rt.gc();
                    logger.debug( "Mem free : " + rt.freeMemory() + " max : " + rt.maxMemory() + "total : " + rt.totalMemory() );
                }
                 */
                doc = builder.build( new File( file ) );
                filename = file;
            } 
            catch ( JDOMException ex ) 
            {
                ex.printStackTrace();
            } // end of try-catch
            catch ( Exception ex )
            {
                ex.printStackTrace();                
            }
            root = doc.getRootElement();
            /*
            if( true )
            {    
                java.lang.Runtime rt = Runtime.getRuntime();
                rt.gc();
                logger.debug( "Mem free : " + rt.freeMemory() + " max : " + rt.maxMemory() + "total : " + rt.totalMemory() );
            }
             */
      }
      /**
       * Describe <code>main</code> method here.
       *
       * @param desc a <code>String</code> value
       * @return a <code>String</code> value
       */
      public String getValue( String desc )
      {
        String token = "";
        String returnValue = "";
        StringTokenizer st = new StringTokenizer( desc, "." );
        Element elem = root;

          if( debugFlag )
          {    
            logger.debug( "getValue( " + desc + " )"  );
          }  

        while( st.hasMoreTokens() ) 
        {
          elem = elem.getChild( st.nextToken() );
          /*
          if( debugFlag )
          {    
            System.out.println( elem.getText() );
          } 
           */ 
          if ( !st.hasMoreTokens()) 
          {
            returnValue = elem.getText();
          } // end of if ( !st.hasMoreTokens())

        } // end of while (st.hasMoreTokens() )
        return returnValue;
      }
      //----------------------------------------------------------------------------
      //    Checklist Taxon Data
      //----------------------------------------------------------------------------  
      public boolean getData( java.sql.Connection con, DBChecklist db, long checklistId ) throws java.sql.SQLException
      {
        long unitXmlIndex = 0;
        long unitXmlIdIndex;
        // try to get all Taxon informations
        //  List elements = root.getChildren( "ChecklistData.TAXON" );
        List elements = root.getChild( "CheckListData" ).getChildren( "Unit" );

        try
        {    
            for( int i = 0; i < elements.size(); i++ )
            {
                org.jdom.Element e =  (Element) elements.get( i );
                unitXmlIndex++;      
                unitXmlIdIndex = 0;
                List taxonElements = e.getChildren( "Taxon" );

                for( int j = 0; j < taxonElements.size(); j++ )
                {
                    unitXmlIdIndex++;
                    org.jdom.Element t = (Element) taxonElements.get( j );
                    String str;
                    StringBuffer line = new StringBuffer();
                    try
                    {

                        String [] fields = { "Code","SynLevel","Genus","Species","Rank","InfraspecificEpithet",
                                             "First","Author","Suffix","Status","ConceptNote","IdQual", 
                                             "TaxonRef","FlorRef","Typus","GeoUnit","Notes" };

                        Vector data = new Vector();

                        int dataIndex = 0;

                        data.add( dataIndex++, "" );        //  Serial
                        data.add( dataIndex++, String.valueOf( checklistId ));        //  Checklist ID
                        data.add( dataIndex++, String.valueOf( unitXmlIndex ));       //  Unit Number
                        data.add( dataIndex++, String.valueOf( unitXmlIdIndex ));     //  Entry Number

                        for( int index = 0; index < fields.length; index++ )
                        {
                            str = t.getChild( fields[ index ]  ).getTextTrim();
                            if( str != null ) 
                            {
                                line.append( str );line.append( "<" + fields[ index ] + ">" );
                                data.add( dataIndex++, str );
                            }    
                        }                                            
                        db.insertXmlDataLine( con, data );                    
                    }
                    catch( java.lang.NullPointerException ex )
                    {   
                        logger.error( ex.getMessage(), ex.fillInStackTrace() );
                        DnOptionPane.showMessageDialog( null, "Can't read XML-TaxonData\n" + line.toString(), "Error" , DnOptionPane.ERROR_MESSAGE );                             
                    }                
                    if( debugFlag ) logger.debug( line.toString() );
                }    
            } // end of for ( int i)
        }
        catch( java.lang.NullPointerException ex )
        {   
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
            DnOptionPane.showMessageDialog( null, "Can't read XML-TaxonData", "Error" , DnOptionPane.ERROR_MESSAGE );                             
            return false;
       }
       return true;
      } 
      //----------------------------------------------------------------------------
      //    Checklist header Data
      //----------------------------------------------------------------------------  

      public java.lang.String getHeaderChecklist()                  { return HeaderChecklist; }
      public java.lang.String getHeaderChecklistName()              { return HeaderChecklistName; }
      public java.lang.String getHeaderChecklistSourceID()          { return HeaderChecklistSourceID; }
      public java.lang.String getHeaderChecklistAuthors()           { return HeaderChecklistAuthors; }
      public java.lang.String getHeaderChecklistVersion()           { return HeaderChecklistVersion; }      

      public java.lang.String getHeaderChecklistOriginalURL()       { return HeaderChecklistOriginalURL; }
      public java.lang.String getHeaderChecklistInstitution()       { return HeaderChecklistInstitution; }

      public java.lang.String getHeaderGeographyOriArea()           { return  HeaderGeographyOriArea; };
      public java.lang.String getHeaderGeographyEdtAreaID()         { return  HeaderGeographyEdtAreaID; }

      public java.lang.String getHeaderAcknowledgementTitle()       { return HeaderAcknowledgementTitle; }
      public java.lang.String getHeaderAcknowledgementText()        { return HeaderAcknowledgementText; }
      public java.lang.String getHeaderAcknowledgementDisplay()     { return HeaderAcknowledgementDisplay; }
      public java.lang.String getHeaderAcknowledgementLinkURL()     { return HeaderAcknowledgementLinkURL; }
      public java.lang.String getHeaderAcknowledgementLinkHidden()  { return HeaderAcknowledgementLinkHidden; }
      public java.lang.String getHeaderAcknowledgementIconHeight()  { return HeaderAcknowledgementIconHeight; }
      public java.lang.String getHeaderAcknowledgementIconWidth()   { return HeaderAcknowledgementIconWidth; }
      public java.lang.String getHeaderAcknowledgementStyleSheetURL() { return HeaderAcknowledgementStyleSheetURL; }
      public java.lang.String getHeaderAcknowledgementBackgroundGIF() { return HeaderAcknowledgementBackgroundGIF; }

      public java.lang.String getHeaderAcknowledgementNotes()       { return HeaderAcknowledgementNotes; }

      public java.lang.String getHeaderCopyrightText()              { return HeaderCopyrightText; }
      public java.lang.String getHeaderCopyrightDisplay()           { return HeaderCopyrightDisplay; }
      public java.lang.String getHeaderCopyrightLinkURL()           { return HeaderCopyrightLinkURL; }
      public java.lang.String getHeaderCopyrightLinkHidden()        { return HeaderCopyrightLinkHidden; }
      public java.lang.String getHeaderCopyrightNotes()             { return HeaderCopyrightNotes; }

      public java.lang.String getHeaderIconURL()                    { return HeaderIconURL; }
      public java.lang.String getHeaderIconDisplay()                { return HeaderIconDisplay; }
      public java.lang.String getHeaderIconLinkURL()                { return HeaderIconLinkURL; }
      public java.lang.String getHeaderIconLinkHidden()             { return HeaderIconLinkHidden; }
      public java.lang.String getHeaderIconDescription()            { return HeaderIconDescription; }
      public java.lang.String getHeaderIconInlineWithText()         { return HeaderIconInlineWithText; }
      public java.lang.String getHeaderIconWidth()                  { return HeaderIconWidth; }
      public java.lang.String getHeaderIconHeight()                 { return HeaderIconHeight; }

      public java.lang.String getHeaderInternNotesImportNotes()     { return HeaderInternNotesImportNotes; }
      public java.lang.String getHeaderInternNotesResponsible()     { return HeaderInternNotesResponsible; }
      public java.lang.String getHeaderInternNotesLogCreated_User() { return HeaderInternNotesLogCreated_User; }
      public java.lang.String getHeaderInternNotesProjectMarker()   { return HeaderInternNotesProjectMarker; }
      public java.lang.String getHeaderInternNotesInternetPassword(){ return HeaderInternNotesInternetPassword; }

      public java.lang.String getHeaderOGU_InformationText()        { return HeaderOGU_InformationText; }
      public java.lang.String getHeaderOGU_InformationLinks()       { return HeaderOGU_InformationLinks; }
      public java.lang.String getCheckListData()                    { return CheckListData; }
      //----------------------------------------------------------------------------
      //----------------------------------------------------------------------------  
      private Vector getHeaderVector()
      {
          Vector v = new Vector();

    // id --> ChecklistSourceId      v.add( "SERIAL ID" );
          v.add( HeaderChecklistName );
          v.add( HeaderChecklistSourceID );
          v.add( HeaderChecklistAuthors );
          v.add( HeaderChecklistVersion );

          v.add( HeaderChecklistOriginalURL );
          v.add( HeaderChecklistInstitution );

          v.add( HeaderGeographyOriArea );
          v.add( HeaderGeographyEdtAreaID );

          v.add( HeaderAcknowledgementTitle );
          v.add( HeaderAcknowledgementText );
          v.add( HeaderAcknowledgementDisplay );
          v.add( HeaderAcknowledgementLinkURL );
          v.add( HeaderAcknowledgementLinkHidden );
          v.add( HeaderAcknowledgementIconWidth );
          v.add( HeaderAcknowledgementIconHeight );
          v.add( HeaderAcknowledgementStyleSheetURL );
          v.add( HeaderAcknowledgementBackgroundGIF );

          v.add( HeaderAcknowledgementNotes );

          v.add( HeaderCopyrightText );
          v.add( HeaderCopyrightDisplay );
          v.add( HeaderCopyrightLinkURL );
          v.add( HeaderCopyrightLinkHidden );
          v.add( HeaderCopyrightNotes );

          v.add( HeaderIconURL );
          v.add( HeaderIconDisplay );
          v.add( HeaderIconLinkURL );
          v.add( HeaderIconLinkHidden );
          v.add( HeaderIconDescription );
          v.add( HeaderIconInlineWithText );
          v.add( HeaderIconWidth );
          v.add( HeaderIconHeight );

          v.add( HeaderInternNotesImportNotes );
          v.add( HeaderInternNotesResponsible );
          v.add( HeaderInternNotesLogCreated_User );
          v.add( HeaderInternNotesProjectMarker );
          v.add( HeaderInternNotesInternetPassword );

          v.add( HeaderOGU_InformationText );
          v.add( HeaderOGU_InformationLinks );

          return v;
      }


      public void readChecklistHeader()
      {
        HeaderChecklist                     = getValue( "Header.Checklist" );
        HeaderChecklistName                 = getValue( "Header.Checklist.Name" );
        HeaderChecklistSourceID             = getValue( "Header.Checklist.SourceID" );
        HeaderChecklistAuthors              = getValue( "Header.Checklist.Authors" ); 
        HeaderChecklistVersion              = getValue( "Header.Checklist.Version" ); 
        HeaderChecklistOriginalURL          = getValue( "Header.Checklist.OriginalURL" ); 
        HeaderChecklistInstitution          = getValue( "Header.Checklist.Institution" );

        HeaderGeographyOriArea              = getValue( "Header.Geography.OriArea" );
        HeaderGeographyEdtAreaID            = getValue( "Header.Geography.EdtAreaID" );

        HeaderAcknowledgementTitle          = getValue( "Header.Acknowledgement.Title" );
        HeaderAcknowledgementText           = getValue( "Header.Acknowledgement.Text" );
        HeaderAcknowledgementDisplay        = getValue( "Header.Acknowledgement.Display" );
        HeaderAcknowledgementLinkURL        = getValue( "Header.Acknowledgement.LinkURL" ); 
        HeaderAcknowledgementLinkHidden     = getValue( "Header.Acknowledgement.LinkHidden" );
        HeaderAcknowledgementIconHeight     = getValue( "Header.Acknowledgement.IconHeight" );
        HeaderAcknowledgementIconWidth      = getValue( "Header.Acknowledgement.IconWidth" );
        HeaderAcknowledgementStyleSheetURL  = getValue( "Header.Acknowledgement.StyleSheetURL" );
        HeaderAcknowledgementBackgroundGIF  = getValue( "Header.Acknowledgement.BackgroundGIF" );

        HeaderAcknowledgementNotes          = getValue( "Header.Acknowledgement.Notes" );

        HeaderCopyrightText                 = getValue( "Header.Copyright.Text" ); 
        HeaderCopyrightDisplay              = getValue( "Header.Copyright.Display" ); 
        HeaderCopyrightLinkURL              = getValue( "Header.Copyright.LinkURL" );
        HeaderCopyrightLinkHidden           = getValue( "Header.Copyright.LinkHidden" );
        HeaderCopyrightNotes                = getValue( "Header.Copyright.Notes" );

        HeaderIconURL                       = getValue( "Header.Icon.URL" );
        HeaderIconDisplay                   = getValue( "Header.Icon.Display" ); 
        HeaderIconLinkURL                   = getValue( "Header.Icon.LinkURL" );
        HeaderIconLinkHidden                = getValue( "Header.Icon.LinkHidden" );
        HeaderIconDescription               = getValue( "Header.Icon.Description" );
        HeaderIconInlineWithText            = getValue( "Header.Icon.InlineWithText" );
        HeaderIconWidth                     = getValue( "Header.Icon.Width" );
        HeaderIconHeight                    = getValue( "Header.Icon.Height" );

        HeaderInternNotesImportNotes        = getValue( "Header.InternNotes.ImportNotes" );
        HeaderInternNotesResponsible        = getValue( "Header.InternNotes.Responsible" );
        HeaderInternNotesLogCreated_User    = getValue( "Header.InternNotes.LogCreated_User" );
        HeaderInternNotesProjectMarker      = getValue( "Header.InternNotes.ProjectMarker" );
        HeaderInternNotesInternetPassword   = getValue( "Header.InternNotes.InternetPassword" );

        HeaderOGU_InformationText           = getValue( "Header.OGU_Information.Text" );
        HeaderOGU_InformationLinks          = getValue( "Header.OGU_Information.Links" );
        CheckListData                       = getValue( "CheckListData" );

        return;
      }
    //------------------------------------------------------------------------
    // import a xml-checklist into the database
    //------------------------------------------------------------------------
    public void importChecklist( DBChecklist db )
    {
        logger.info( "Import Checklist XML-file: " + filename );
        logger.info( "read xml checklist header" );          
          
        readChecklistHeader();
        
        java.sql.Connection con = db.connect();
        try
        {
            // ??? Start transaction
            if( setAutoCommit )
            {
                con.setAutoCommit( false );
            }
	    java.sql.Statement s = con.createStatement();            
            s.execute( "BEGIN TRANSACTION" );
            logger.info( "insert checklist header into database" );
            insertHeaderIntoDB( con, db );
          
            String title = getHeaderAcknowledgementTitle() ;
            long checklistId = db.getChecklistHeaderId( con, title );
          
            if( checklistId < 0 )
            {
                System.out.println(  "Error: can't get checklist id" );
                return;
            }
            // System.out.println(  getHeaderChecklistName() );
            if( false )
            {
              System.out.println(  getHeaderChecklist() );
              System.out.println(  getHeaderChecklistName() );
              System.out.println(  getHeaderChecklistSourceID() );
              System.out.println(  getHeaderChecklistAuthors() );
              System.out.println(  getHeaderChecklistVersion() );
              System.out.println(  getHeaderChecklistOriginalURL() );
              System.out.println(  getHeaderChecklistInstitution() );
              
              System.out.println(  getHeaderGeographyOriArea() );
              System.out.println(  getHeaderGeographyEdtAreaID() );
              
              System.out.println(  getHeaderAcknowledgementTitle() );
              System.out.println(  getHeaderAcknowledgementText() );
              System.out.println(  getHeaderAcknowledgementDisplay() );
              System.out.println(  getHeaderAcknowledgementLinkURL() );
              System.out.println(  getHeaderAcknowledgementLinkHidden() );
              System.out.println(  getHeaderAcknowledgementIconHeight() );
              System.out.println(  getHeaderAcknowledgementIconWidth() );
              System.out.println(  getHeaderAcknowledgementStyleSheetURL() );
              System.out.println(  getHeaderAcknowledgementBackgroundGIF() );
              System.out.println(  getHeaderAcknowledgementNotes() );
              
              System.out.println(  getHeaderCopyrightText() );
              System.out.println(  getHeaderCopyrightDisplay() );
              System.out.println(  getHeaderCopyrightLinkURL() );
              System.out.println(  getHeaderCopyrightLinkHidden() );
              System.out.println(  getHeaderCopyrightNotes() );
              
              System.out.println(  getHeaderIconURL() );
              System.out.println(  getHeaderIconDisplay() );
              System.out.println(  getHeaderIconLinkURL() );
              System.out.println(  getHeaderIconLinkHidden() );
              System.out.println(  getHeaderIconDescription() );
              System.out.println(  getHeaderIconInlineWithText() );
              System.out.println(  getHeaderIconWidth() );
              System.out.println(  getHeaderIconHeight() );
              
              System.out.println(  getHeaderInternNotesImportNotes() );
              System.out.println(  getHeaderInternNotesResponsible() );
              System.out.println(  getHeaderInternNotesLogCreated_User() );
              System.out.println(  getHeaderInternNotesProjectMarker() );
              System.out.println(  getHeaderInternNotesInternetPassword() );
              
              System.out.println(  getHeaderOGU_InformationText() );
              System.out.println(  getHeaderOGU_InformationLinks() );
            }
            logger.info( "insert checklist data into database" );
            getData( con, db, checklistId );
            logger.info( "commit" );            
            con.commit();
        }
        catch( java.sql.SQLException ex )
        {   
            try
            {
                logger.error( "Error while insert checklist into database" );
                logger.error( ex.getMessage(), ex.fillInStackTrace() );
                logger.error( "rollback" );
                con.rollback();
            }
            catch( java.sql.SQLException sqlex )
            {   
                logger.fatal( sqlex.getLocalizedMessage() );            
            }
            logger.fatal( ex.getLocalizedMessage() );
        }
        finally
        {
            if( con != null )
            {
                try
                {
                    con.close();
                }
                catch( java.sql.SQLException ex )
                {   
                    logger.fatal( ex.getLocalizedMessage() );            
                }
            }
        }
    }
    //----------------------------------------------------------------------------
    //    XML Taxon Data
    //----------------------------------------------------------------------------
    public void xmlTaxon()
    {
        String taxonEntries [] = { 
            "Taxon.Unit" ,
            "Taxon.Unit.Code",
            "Taxon.Unit.SynLevel",
            "Taxon.Unit.Genus",
            "Taxon.Unit.Species",
            "Taxon.Unit.Rank",
            "Taxon.Unit.InfraspecificEpithet",
            "Taxon.Unit.First",
            "Taxon.Unit.Author",
            "Taxon.Unit.Prefix",
            "Taxon.Unit.Suffix",
            "Taxon.Unit.TaxonRef",
            "Taxon.Unit.FlorRef",
            "Taxon.Unit.Comment",
            "Taxon.Unit.Typus",  
            "Taxon.Unit.GeoUnit",
            "Taxon.Unit.ConceptNote"
        };
        return;
    }
    //------------------------------------------------------------------------------
    // Insert Checklist Header into DB
    //------------------------------------------------------------------------------  
    public boolean insertHeaderIntoDB( java.sql.Connection con, DBChecklist db ) throws java.sql.SQLException
    {
/* ???        
        try
        {
 */
            Vector data = getHeaderVector();
            db.insertXmlHeader( con, data );
/* ???            
        }
        catch( Exception ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
            return false;
        }
 */
        return true;
    }
}
