/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * TaxonomyName.java
 *
 * Created on 2. Juni 2004, 17:49
 */

package net.metadiversity.diversity.navigator.db.diversity_names_lias;

import java.util.Date;

/**
 *
 * @author  didi
 */
public class TaxonomyName
{
    private long    NameID;             // Unique ID code for the nomenclatural name (primary key).
    private long    ParentID;           // ID of the superior taxonomic group.
                                        // Default value: 0
    private String  NameCache;          //
    private byte    TaxonomicRankID;    // Taxonomic rank of the taxon (var., subsp., species, genus, family, order, etc.). The rank must be selected from the associated list of ranks (= TaxonomyRank).
    private String  HigherTaxonName;    // If rank is above species: Name of taxon above species level (currently accepted spelling). Includes infrageneric taxon names, genera, families, etc.
    private String  Genus;              // 
    private String  SpecificEpithet;    // If rank is species or below: Species epithet, for example 'alba' in 'Abies alba Miller' (currently accepted spelling).
    private String  InfraspecificRank;  //
    private String  InfraspecificEpithet; // If rank is infraspecific: Infraspecific epithet (currently accepted spelling). Note: the rank is known from required attribute TaxonomicRank in TaxonomyName (= the supertype entity).
    private String  BasionymAuthors;    // For all taxonomic ranks, only for 'comb. nov.' or 'nom. nov.': Author(s) of the basionym (will be displayed in in '()', do not enter the parentheses), abbreviated according to authors standard.
    private String  CombiningAuthors;
    private String  PublishingAuthors;
    private String  SanctioningAuthor;
    private String  LiteratureTitle;
    private String  Volume;             // The volume (for periodicals or journals, excluding the issue number), report number, etc.
    private String  Issue;              // The issue, if any. Useful also to enter a special designation for a supplement, for example for 'xxx 45 (Suppl.)' enter volume = 45 and issue = 'Suppl.'. Do not put '()' around the issue number.
    private String  Page;               // The page, table, or figure numbers for the reference, e.g. '23-41', '341 pp.', or '20, 22-24, 32' (for non-consecutive pages).
    private String  YearOfPubl;         //
    private String  YearOnPubl;
    private String  IndexingReference;  // Optional: A secondary reference indexing this taxon, e.g. Saccardo, Index of Fungi, etc. Entered as text, not as reference ID!
    private String  OriginalOrthography;
    private String  NomenclaturalComment;
    private String  TypificationDetails;
    private String  TypeSubstratum;
    private String  TypeLocality;
    private String  AnamorphTeleomorph;
    private long    BasionymNomID;      // Basionym: If CreationType is 'comb. nov.' or replacement ('nom. nov.'), of another name based on the same type material. Refers to ID code of corresponding TaxonomyName (= foreign key).
    private String  ReferenceID;        // Reference ID number for a citiation as defined in an external database (foreign key to separate module).
    private int     ReferenceDatabaseID; // The ID of an external reference collection.
                                         // Default value: 0
    private long    LogUpdatedBy;       // Name of user who last updated the data. This is the operator (or typist) name, which may be different from the person responsible.
    private Date    LogUpdatedWhen;    // Date and time when record was last updated.
                                        // Default value: Now()
    /*
    Index name:
    Attributes & index properties
    PrimaryKey:
    NameID (Primary key; Unique values)
    Relation type:
    Fields involved
    Updates cascade
    ExternalReferenceDatabase.ReferenceDatabaseID  TaxonomyName.ReferenceDatabaseID
    Updates & deletions cascade
    TaxonomyName.NameID  ExternalNameID.NameID
    Referential integrity
    TaxonomyName.NameID  TaxonomySynonymy.TaxonID
    Referential integrity
    TaxonomyName.NameID  TaxonomySynonymy.AcceptedTaxonID
    Updates cascade
    TaxonomyRank.TaxonomicRankID  TaxonomyName.TaxonomicRankID
    */    
    /** Creates a new instance of TaxonomyName */
    public TaxonomyName()
    {
    }
    
}
