/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * CollectionTabIndentification.java
 *
 * Created on 15. September 2004, 11:39
 */

package net.metadiversity.diversity.navigator.gui;

import com.jgoodies.forms.layout.*;
import com.jgoodies.forms.layout.ColumnSpec;

import net.metadiversity.diversity.navigator.db.ub.DnDataRecordSelector;

/**
 *
 * @author  didi
 */
public class CollectionTabIndentification extends com.jgoodies.forms.builder.PanelBuilder
{
    // form format strings
    String columnFormatString   = "";
    String rowFormatString      = "";
    
    com.jgoodies.forms.builder.PanelBuilder     builder;
    // default format values
    static final String DEFAULT_COLUMNE_FORMAT = "fill:d:grow";
    static final String PAD_COLUMNE_FORMAT     = "fill:3dlu:nogrow";
    static final String DEFAULT_ROW_FORMAT     = "fill:d:nogrow";
    static final String PAD_ROW_FORMAT         = "fill:3dlu:nogrow";    
    // Form parameter
    int xMaxFormPos;
    int yMaxFormPos;
    // debug
    boolean DEBUG_ADD_COMPONENT = false;
    boolean DEBUG_LINE_AND_ROW_NUMBERS = false;
    //
    CellConstraints cc;
    
    public DnDataRecordSelector        identificationRecords;
    public DnDataRecordSelector        identificationUnitRecords;
    
    public void showLineNumbers( boolean b )
    {
        DEBUG_LINE_AND_ROW_NUMBERS = b;
    }
    
    /** Creates new form CollectionTabIndentification */
    public CollectionTabIndentification()
    {
        super( new com.jgoodies.forms.layout.FormLayout( "", "" ) );
        showLineNumbers( false );
        cc = new CellConstraints();
        xMaxFormPos = 13;
        yMaxFormPos = 7;
                
        ColumnSpec colPad = new com.jgoodies.forms.layout.ColumnSpec( PAD_COLUMNE_FORMAT );              
        ColumnSpec colDef = new com.jgoodies.forms.layout.ColumnSpec( DEFAULT_COLUMNE_FORMAT );              
        
        RowSpec rowPad = new com.jgoodies.forms.layout.RowSpec( PAD_ROW_FORMAT );              
        RowSpec rowDef = new com.jgoodies.forms.layout.RowSpec( DEFAULT_ROW_FORMAT );              

        
        if( DEBUG_LINE_AND_ROW_NUMBERS )
        {
            appendColumn( colDef );
            appendRow( rowDef );
        }
        else
        {
            appendColumn( colPad );
            appendRow( rowPad );                
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            appendColumn( colDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && col == xMaxFormPos )
            {
                appendColumn( colDef );
            }
            else
            {
                appendColumn( colPad );
            }
        }
        for( int row = 1; row <= yMaxFormPos; row++ )
        {   
            appendRow( rowDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && row == yMaxFormPos )
            {
                appendRow( rowDef );
            }
            else
            {
                appendRow( rowPad );                   
            }
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // Set line numbers 
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l1, cc.xy( 1 , row * 2 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l2, cc.xy( xMaxFormPos * 2 + 1, row * 2 ) );
            }
            else
            {
                javax.swing.JLabel l1 = new javax.swing.JLabel( " " );
                add( l1, cc.xy( 1 , row * 2 ) );                
            }
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // set column numbers
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l1, cc.xy( col * 2, 1 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l2, cc.xy( col * 2, yMaxFormPos * 2 + 1 ) );
            }
        }
        
        //----------------------------------------------------------------------
        // Change Layout for "Date"
        //----------------------------------------------------------------------
        com.jgoodies.forms.layout.FormLayout layout = getLayout();
        
        if( ! DEBUG_LINE_AND_ROW_NUMBERS )
        {
            // Taxonomic name
            layout.removeColumn(  2 );            
            // layout.insertColumn(  2, new com.jgoodies.forms.layout.ColumnSpec( "fill:d:grow(0.2)" ) );
            layout.insertColumn(  2, new com.jgoodies.forms.layout.ColumnSpec( "fill:80dlu:nogrow" ) );
            layout.removeColumn(  4 );
            layout.insertColumn(  4, new com.jgoodies.forms.layout.ColumnSpec( "fill:d:grow(0.2)" ) );
            // date
            layout.removeColumn(  6 );
            layout.insertColumn(  6, new com.jgoodies.forms.layout.ColumnSpec( "fill:12dlu:nogrow" ) );
            layout.removeColumn(  8 );
            layout.insertColumn(  8, new com.jgoodies.forms.layout.ColumnSpec( "fill:12dlu:nogrow" ) );
            layout.removeColumn( 10 );
            layout.insertColumn( 10, new com.jgoodies.forms.layout.ColumnSpec( "fill:20dlu:nogrow" ) );
            // Suppl.
            layout.removeColumn( 12 );
            layout.insertColumn( 12, new com.jgoodies.forms.layout.ColumnSpec( "fill:d:grow(0.2)" ) );
            // category
            layout.removeColumn( 14 );
            layout.insertColumn( 14, new com.jgoodies.forms.layout.ColumnSpec( "fill:d:grow(0.2)" ) );
            // Category
            layout.removeColumn( 16 );
            layout.insertColumn( 16, new com.jgoodies.forms.layout.ColumnSpec( "fill:d:grow(0.2)" ) );
            layout.removeColumn( 18 );
            layout.insertColumn( 18, new com.jgoodies.forms.layout.ColumnSpec( "fill:d:grow(0.2)" ) );
            layout.removeColumn( 20 );
            layout.insertColumn( 20, new com.jgoodies.forms.layout.ColumnSpec( "fill:d:grow(1.0)" ) );
            layout.removeColumn( 22 );
            layout.insertColumn( 22, new com.jgoodies.forms.layout.ColumnSpec( "fill:d:grow(0.2)" ) );
            // Exsiccatum
            layout.removeColumn( 24 );
            layout.insertColumn( 24, new com.jgoodies.forms.layout.ColumnSpec( "fill:10dlu:nogrow" ) );
            layout.removeColumn( 26 );
            layout.insertColumn( 26, new com.jgoodies.forms.layout.ColumnSpec( "fill:d:grow(1.0)" ) );
        }        
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
        // Add Record selector 
        //----------------------------------------------------------------------
        identificationRecords  = new DnDataRecordSelector();
        identificationUnitRecords  = new DnDataRecordSelector();
        
        java.awt.GridBagConstraints gridBagConstraints;
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 6;
        add( identificationUnitRecords, gridBagConstraints );
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 6;
        add( identificationRecords, gridBagConstraints );
       
        initComponents();        
    }
    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void debug( int x, int y, int l, int h )
    {
        System.out.println( "x: " + x +  " \ty: " + y + " \tl:" + l );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void setLayout( java.awt.LayoutManager lm )
    {
        
    }
    void add( javax.swing.JComponent c, java.awt.GridBagConstraints gbc )    
    {
        cc = new CellConstraints();
        System.out.println( c );
        // Don't show Lable outside the form
        if( gbc.gridx > xMaxFormPos || gbc.gridy > yMaxFormPos )
        {
            return;
        }
        cc.xywh( ( gbc.gridx + 1 ) * 2, ( gbc.gridy + 1 ) * 2, ( gbc.gridwidth * 2 ) -1, ( gbc.gridheight * 2 ) -1 );
        System.out.println( cc );        
        add( c, cc );
        
    }
    /** This method is called from within the constructor to     
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabelTaxonomicGroup = new javax.swing.JLabel();
        jComboBoxTaxonomicGroup = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jLabelTypifiedTaxonAndState = new javax.swing.JLabel();
        jTextFieldTypifiedTaxonAndState = new javax.swing.JTextField();
        jComboBoxTypifiedTaxonAndState = new javax.swing.JComboBox();
        jLabelTaxonomicName = new javax.swing.JLabel();
        jLabelVernacularName = new javax.swing.JLabel();
        jLabelDate = new javax.swing.JLabel();
        jLabelDateSupl = new javax.swing.JLabel();
        jLabelCategory = new javax.swing.JLabel();
        jLabelQualifier = new javax.swing.JLabel();
        jLabelLiteratureUsed = new javax.swing.JLabel();
        jLabelResponsible = new javax.swing.JLabel();
        jLabelExsiccatum = new javax.swing.JLabel();
        jLabelNotes = new javax.swing.JLabel();
        jComboBoxTaxonomicName = new javax.swing.JComboBox();
        jTextFieldVernacularName = new javax.swing.JTextField();
        jTextFieldDateDD = new javax.swing.JTextField();
        jTextFieldDateMM = new javax.swing.JTextField();
        jTextFieldDateYYYY = new javax.swing.JTextField();
        jTextFieldDateSupl = new javax.swing.JTextField();
        jLabelDateCategory = new javax.swing.JLabel();
        jComboBoxDateCategory = new javax.swing.JComboBox();
        jComboBoxCategory = new javax.swing.JComboBox();
        jComboBoxQualifier = new javax.swing.JComboBox();
        jTextFieldLiteratureUsed = new javax.swing.JTextField();
        jCheckBoxExsiccatum = new javax.swing.JCheckBox();
        jTextFieldNotes = new javax.swing.JTextField();
        jLabelColonizedPart = new javax.swing.JLabel();
        jTextFieldColonizedPart = new javax.swing.JTextField();
        jLabelGrowingLivingOn = new javax.swing.JLabel();
        jComboBoxGrowingLivingOn = new javax.swing.JComboBox();
        jLabelLifeState = new javax.swing.JLabel();
        jTextFieldLifeState = new javax.swing.JTextField();
        jCheckBoxOnlyObserved = new javax.swing.JCheckBox();
        jLabelNotes2 = new javax.swing.JLabel();
        jTextFieldNotes2 = new javax.swing.JTextField();
        jComboBoxResponsible = new javax.swing.JComboBox();

        setLayout(new java.awt.GridBagLayout());

        jLabelTaxonomicGroup.setText("Taxonomic group:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(jLabelTaxonomicGroup, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        add(jComboBoxTaxonomicGroup, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 6;
        add(jLabel1, gridBagConstraints);

        jLabelTypifiedTaxonAndState.setText("Typified taxon and state:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 8;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        add(jLabelTypifiedTaxonAndState, gridBagConstraints);

        jTextFieldTypifiedTaxonAndState.setText("TypifiedTaxonAndState");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldTypifiedTaxonAndState, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 11;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxTypifiedTaxonAndState, gridBagConstraints);

        jLabelTaxonomicName.setText("Taxonomic name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        add(jLabelTaxonomicName, gridBagConstraints);

        jLabelVernacularName.setText("Vernacular Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        add(jLabelVernacularName, gridBagConstraints);

        jLabelDate.setText("Date (dd|mm|yyyy");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        add(jLabelDate, gridBagConstraints);

        jLabelDateSupl.setText("Supl.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelDateSupl, gridBagConstraints);

        jLabelCategory.setText("Category");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelCategory, gridBagConstraints);

        jLabelQualifier.setText("Qualifier");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 8;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelQualifier, gridBagConstraints);

        jLabelLiteratureUsed.setText("Literature used");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 1;
        add(jLabelLiteratureUsed, gridBagConstraints);

        jLabelResponsible.setText("Responsible");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelResponsible, gridBagConstraints);

        jLabelExsiccatum.setText("Exsiccatum");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 11;
        gridBagConstraints.gridy = 1;
        add(jLabelExsiccatum, gridBagConstraints);

        jLabelNotes.setText("Notes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 12;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelNotes, gridBagConstraints);

        jComboBoxTaxonomicName.setEditable(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        add(jComboBoxTaxonomicName, gridBagConstraints);

        jTextFieldVernacularName.setText("jTextFieldVernacularName");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        add(jTextFieldVernacularName, gridBagConstraints);

        jTextFieldDateDD.setText("dd");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldDateDD, gridBagConstraints);

        jTextFieldDateMM.setText("mm");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldDateMM, gridBagConstraints);

        jTextFieldDateYYYY.setText("yyyy");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldDateYYYY, gridBagConstraints);

        jTextFieldDateSupl.setText("supl.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldDateSupl, gridBagConstraints);

        jLabelDateCategory.setText("/ category)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelDateCategory, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxDateCategory, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxCategory, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 8;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxQualifier, gridBagConstraints);

        jTextFieldLiteratureUsed.setText("LiteratureUsed");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldLiteratureUsed, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 11;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jCheckBoxExsiccatum, gridBagConstraints);

        jTextFieldNotes.setText("jTextField1");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 12;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldNotes, gridBagConstraints);

        jLabelColonizedPart.setText("Colonized part");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        add(jLabelColonizedPart, gridBagConstraints);

        jTextFieldColonizedPart.setText("jTextFieldColonizedPart");
        jTextFieldColonizedPart.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jTextFieldColonizedPartActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldColonizedPart, gridBagConstraints);

        jLabelGrowingLivingOn.setText("growing / living on");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 4;
        add(jLabelGrowingLivingOn, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxGrowingLivingOn, gridBagConstraints);

        jLabelLifeState.setText("Life state");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 8;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelLifeState, gridBagConstraints);

        jTextFieldLifeState.setText("jTextFieldLifeState");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldLifeState, gridBagConstraints);

        jCheckBoxOnlyObserved.setText("Only observed");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jCheckBoxOnlyObserved, gridBagConstraints);

        jLabelNotes2.setText("Notes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelNotes2, gridBagConstraints);

        jTextFieldNotes2.setText("Notes 2");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 12;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldNotes2, gridBagConstraints);

        jComboBoxResponsible.setEditable(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxResponsible, gridBagConstraints);

    }//GEN-END:initComponents

    private void jTextFieldColonizedPartActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jTextFieldColonizedPartActionPerformed
    {//GEN-HEADEREND:event_jTextFieldColonizedPartActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldColonizedPartActionPerformed
    
    public static void main( String [] args  )
    {
        CollectionTabIndentification p = new CollectionTabIndentification();
        
        javax.swing.JFrame f = new javax.swing.JFrame();        
        f.getContentPane().add( p.getPanel() );
        f.setVisible( true );
        f.setDefaultCloseOperation( javax.swing.JFrame.DISPOSE_ON_CLOSE );
    }
    
    /**
     * Getter for property jTextFieldColonizedPart.
     * @return Value of property jTextFieldColonizedPart.
     */
    public javax.swing.JTextField getJTextFieldColonizedPart()
    {
        return jTextFieldColonizedPart;
    }    
    
    /**
     * Setter for property jTextFieldColonizedPart.
     * @param jTextFieldColonizedPart New value of property jTextFieldColonizedPart.
     */
    public void setJTextFieldColonizedPart(javax.swing.JTextField jTextFieldColonizedPart)
    {
        this.jTextFieldColonizedPart = jTextFieldColonizedPart;
    }
    
    /**
     * Getter for property jTextFieldDateDD.
     * @return Value of property jTextFieldDateDD.
     */
    public javax.swing.JTextField getJTextFieldDateDD()
    {
        return jTextFieldDateDD;
    }
    
    /**
     * Setter for property jTextFieldDateDD.
     * @param jTextFieldDateDD New value of property jTextFieldDateDD.
     */
    public void setJTextFieldDateDD(javax.swing.JTextField jTextFieldDateDD)
    {
        this.jTextFieldDateDD = jTextFieldDateDD;
    }
    
    /**
     * Getter for property jTextFieldDateMM.
     * @return Value of property jTextFieldDateMM.
     */
    public javax.swing.JTextField getJTextFieldDateMM()
    {
        return jTextFieldDateMM;
    }
    
    /**
     * Setter for property jTextFieldDateMM.
     * @param jTextFieldDateMM New value of property jTextFieldDateMM.
     */
    public void setJTextFieldDateMM(javax.swing.JTextField jTextFieldDateMM)
    {
        this.jTextFieldDateMM = jTextFieldDateMM;
    }
    
    /**
     * Getter for property jTextFieldDateSupl.
     * @return Value of property jTextFieldDateSupl.
     */
    public javax.swing.JTextField getJTextFieldDateSupl()
    {
        return jTextFieldDateSupl;
    }
    
    /**
     * Setter for property jTextFieldDateSupl.
     * @param jTextFieldDateSupl New value of property jTextFieldDateSupl.
     */
    public void setJTextFieldDateSupl(javax.swing.JTextField jTextFieldDateSupl)
    {
        this.jTextFieldDateSupl = jTextFieldDateSupl;
    }
    
    /**
     * Getter for property jTextFieldDateYYYY.
     * @return Value of property jTextFieldDateYYYY.
     */
    public javax.swing.JTextField getJTextFieldDateYYYY()
    {
        return jTextFieldDateYYYY;
    }
    
    /**
     * Setter for property jTextFieldDateYYYY.
     * @param jTextFieldDateYYYY New value of property jTextFieldDateYYYY.
     */
    public void setJTextFieldDateYYYY(javax.swing.JTextField jTextFieldDateYYYY)
    {
        this.jTextFieldDateYYYY = jTextFieldDateYYYY;
    }
    
    /**
     * Getter for property jTextFieldLifeState.
     * @return Value of property jTextFieldLifeState.
     */
    public javax.swing.JTextField getJTextFieldLifeState()
    {
        return jTextFieldLifeState;
    }
    
    /**
     * Setter for property jTextFieldLifeState.
     * @param jTextFieldLifeState New value of property jTextFieldLifeState.
     */
    public void setJTextFieldLifeState(javax.swing.JTextField jTextFieldLifeState)
    {
        this.jTextFieldLifeState = jTextFieldLifeState;
    }
    
    /**
     * Getter for property jTextFieldLiteratureUsed.
     * @return Value of property jTextFieldLiteratureUsed.
     */
    public javax.swing.JTextField getJTextFieldLiteratureUsed()
    {
        return jTextFieldLiteratureUsed;
    }
    
    /**
     * Setter for property jTextFieldLiteratureUsed.
     * @param jTextFieldLiteratureUsed New value of property jTextFieldLiteratureUsed.
     */
    public void setJTextFieldLiteratureUsed(javax.swing.JTextField jTextFieldLiteratureUsed)
    {
        this.jTextFieldLiteratureUsed = jTextFieldLiteratureUsed;
    }
    
    /**
     * Getter for property jTextFieldNotes.
     * @return Value of property jTextFieldNotes.
     */
    public javax.swing.JTextField getJTextFieldNotes()
    {
        return jTextFieldNotes;
    }
    
    /**
     * Setter for property jTextFieldNotes.
     * @param jTextFieldNotes New value of property jTextFieldNotes.
     */
    public void setJTextFieldNotes(javax.swing.JTextField jTextFieldNotes)
    {
        this.jTextFieldNotes = jTextFieldNotes;
    }
    
    /**
     * Getter for property jTextFieldNotes2.
     * @return Value of property jTextFieldNotes2.
     */
    public javax.swing.JTextField getJTextFieldNotes2()
    {
        return jTextFieldNotes2;
    }
    
    /**
     * Setter for property jTextFieldNotes2.
     * @param jTextFieldNotes2 New value of property jTextFieldNotes2.
     */
    public void setJTextFieldNotes2(javax.swing.JTextField jTextFieldNotes2)
    {
        this.jTextFieldNotes2 = jTextFieldNotes2;
    }
    
    /**
     * Getter for property jTextFieldTypifiedTaxonAndState.
     * @return Value of property jTextFieldTypifiedTaxonAndState.
     */
    public javax.swing.JTextField getJTextFieldTypifiedTaxonAndState()
    {
        return jTextFieldTypifiedTaxonAndState;
    }
    
    /**
     * Setter for property jTextFieldTypifiedTaxonAndState.
     * @param jTextFieldTypifiedTaxonAndState New value of property jTextFieldTypifiedTaxonAndState.
     */
    public void setJTextFieldTypifiedTaxonAndState(javax.swing.JTextField jTextFieldTypifiedTaxonAndState)
    {
        this.jTextFieldTypifiedTaxonAndState = jTextFieldTypifiedTaxonAndState;
    }
    
    /**
     * Getter for property jTextFieldVernacularName.
     * @return Value of property jTextFieldVernacularName.
     */
    public javax.swing.JTextField getJTextFieldVernacularName()
    {
        return jTextFieldVernacularName;
    }
    
    /**
     * Setter for property jTextFieldVernacularName.
     * @param jTextFieldVernacularName New value of property jTextFieldVernacularName.
     */
    public void setJTextFieldVernacularName(javax.swing.JTextField jTextFieldVernacularName)
    {
        this.jTextFieldVernacularName = jTextFieldVernacularName;
    }
    
    /**
     * Getter for property jCheckBoxExsiccatum.
     * @return Value of property jCheckBoxExsiccatum.
     */
    public javax.swing.JCheckBox getJCheckBoxExsiccatum()
    {
        return jCheckBoxExsiccatum;
    }
    
    /**
     * Setter for property jCheckBoxExsiccatum.
     * @param jCheckBoxExsiccatum New value of property jCheckBoxExsiccatum.
     */
    public void setJCheckBoxExsiccatum(javax.swing.JCheckBox jCheckBoxExsiccatum)
    {
        this.jCheckBoxExsiccatum = jCheckBoxExsiccatum;
    }
    
    /**
     * Getter for property jCheckBoxOnlyObserved.
     * @return Value of property jCheckBoxOnlyObserved.
     */
    public javax.swing.JCheckBox getJCheckBoxOnlyObserved()
    {
        return jCheckBoxOnlyObserved;
    }
    
    /**
     * Setter for property jCheckBoxOnlyObserved.
     * @param jCheckBoxOnlyObserved New value of property jCheckBoxOnlyObserved.
     */
    public void setJCheckBoxOnlyObserved(javax.swing.JCheckBox jCheckBoxOnlyObserved)
    {
        this.jCheckBoxOnlyObserved = jCheckBoxOnlyObserved;
    }
    
    /**
     * Getter for property jComboBoxCategory.
     * @return Value of property jComboBoxCategory.
     */
    public javax.swing.JComboBox getJComboBoxCategory()
    {
        return jComboBoxCategory;
    }
    
    /**
     * Getter for property jComboBoxDateCategory.
     * @return Value of property jComboBoxDateCategory.
     */
    public javax.swing.JComboBox getJComboBoxDateCategory()
    {
        return jComboBoxDateCategory;
    }
    
    /**
     * Getter for property jComboBoxGrowingLivingOn.
     * @return Value of property jComboBoxGrowingLivingOn.
     */
    public javax.swing.JComboBox getJComboBoxGrowingLivingOn()
    {
        return jComboBoxGrowingLivingOn;
    }
    
    /**
     * Getter for property jComboBoxQualifier.
     * @return Value of property jComboBoxQualifier.
     */
    public javax.swing.JComboBox getJComboBoxQualifier()
    {
        return jComboBoxQualifier;
    }
    
    /**
     * Getter for property jComboBoxResponsible.
     * @return Value of property jComboBoxResponsible.
     */
    public javax.swing.JComboBox getJComboBoxResponsible()
    {
        return jComboBoxResponsible;
    }
    
    /**
     * Getter for property jComboBoxTaxonomicGroup.
     * @return Value of property jComboBoxTaxonomicGroup.
     */
    public javax.swing.JComboBox getJComboBoxTaxonomicGroup()
    {
        return jComboBoxTaxonomicGroup;
    }
    
    /**
     * Getter for property jComboBoxTaxonomicName.
     * @return Value of property jComboBoxTaxonomicName.
     */
    public javax.swing.JComboBox getJComboBoxTaxonomicName()
    {
        return jComboBoxTaxonomicName;
    }
    
    /**
     * Getter for property jComboBoxTypifiedTaxonAndState.
     * @return Value of property jComboBoxTypifiedTaxonAndState.
     */
    public javax.swing.JComboBox getJComboBoxTypifiedTaxonAndState()
    {
        return jComboBoxTypifiedTaxonAndState;
    }
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox jCheckBoxExsiccatum;
    private javax.swing.JCheckBox jCheckBoxOnlyObserved;
    private javax.swing.JComboBox jComboBoxCategory;
    private javax.swing.JComboBox jComboBoxDateCategory;
    private javax.swing.JComboBox jComboBoxGrowingLivingOn;
    private javax.swing.JComboBox jComboBoxQualifier;
    private javax.swing.JComboBox jComboBoxResponsible;
    private javax.swing.JComboBox jComboBoxTaxonomicGroup;
    private javax.swing.JComboBox jComboBoxTaxonomicName;
    private javax.swing.JComboBox jComboBoxTypifiedTaxonAndState;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabelCategory;
    private javax.swing.JLabel jLabelColonizedPart;
    private javax.swing.JLabel jLabelDate;
    private javax.swing.JLabel jLabelDateCategory;
    private javax.swing.JLabel jLabelDateSupl;
    private javax.swing.JLabel jLabelExsiccatum;
    private javax.swing.JLabel jLabelGrowingLivingOn;
    private javax.swing.JLabel jLabelLifeState;
    private javax.swing.JLabel jLabelLiteratureUsed;
    private javax.swing.JLabel jLabelNotes;
    private javax.swing.JLabel jLabelNotes2;
    private javax.swing.JLabel jLabelQualifier;
    private javax.swing.JLabel jLabelResponsible;
    private javax.swing.JLabel jLabelTaxonomicGroup;
    private javax.swing.JLabel jLabelTaxonomicName;
    private javax.swing.JLabel jLabelTypifiedTaxonAndState;
    private javax.swing.JLabel jLabelVernacularName;
    private javax.swing.JTextField jTextFieldColonizedPart;
    private javax.swing.JTextField jTextFieldDateDD;
    private javax.swing.JTextField jTextFieldDateMM;
    private javax.swing.JTextField jTextFieldDateSupl;
    private javax.swing.JTextField jTextFieldDateYYYY;
    private javax.swing.JTextField jTextFieldLifeState;
    private javax.swing.JTextField jTextFieldLiteratureUsed;
    private javax.swing.JTextField jTextFieldNotes;
    private javax.swing.JTextField jTextFieldNotes2;
    private javax.swing.JTextField jTextFieldTypifiedTaxonAndState;
    private javax.swing.JTextField jTextFieldVernacularName;
    // End of variables declaration//GEN-END:variables
    
}
