/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * PopupSelectionList.java
 *
 * Created on 24. Mai 2004, 15:22
 */

package net.metadiversity.diversity.navigator.gui;

/**
 *
 * @author  didi
 */
public class PopupSelectionList extends DnDialog
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3689626991234002992L;
    javax.swing.DefaultListModel model;    
    Object [] selectedObjects;
    
    /** Creates new form PopupSelectionList */
    public PopupSelectionList( java.awt.Frame parent, boolean modal, java.util.Vector items )
    {
        super( parent, modal );                           
        model = new javax.swing.DefaultListModel();
        selectedObjects = null; 
        if( items == null )
        {
            model.addElement( "Diversity Database Group 1" );
            model.addElement( "Diversity Database Group 2" );
            model.addElement( "Diversity Database Group 3" );
            model.addElement( "Diversity Database Group 4" );
        }
        else
        {
            java.util.ListIterator iter = items.listIterator();
            while( iter.hasNext() )
            {
                model.addElement( iter.next() );
            }
        }            
        initComponents();
        pack();
        center();
    }
              
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        scrollPane = new javax.swing.JScrollPane();
        list = new javax.swing.JList();
        panel = new javax.swing.JPanel();
        addButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        helpButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter()
        {
            public void windowClosing(java.awt.event.WindowEvent evt)
            {
                closeDialog(evt);
            }
        });

        list.setModel(model);
        scrollPane.setViewportView(list);

        getContentPane().add(scrollPane, java.awt.BorderLayout.CENTER);

        addButton.setMnemonic('A');
        addButton.setText("Add");
        addButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                addButtonActionPerformed(evt);
            }
        });

        panel.add(addButton);

        cancelButton.setMnemonic('C');
        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                cancelButtonActionPerformed(evt);
            }
        });

        panel.add(cancelButton);

        helpButton.setMnemonic('H');
        helpButton.setText("Help");
        helpButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                helpButtonActionPerformed(evt);
            }
        });

        panel.add(helpButton);

        getContentPane().add(panel, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void addButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_addButtonActionPerformed
    {//GEN-HEADEREND:event_addButtonActionPerformed
        // System.out.println( "Add " );
        /*
        selectedObjects = list.getSelectedValues();        
        for( int i = 0; i < selectedObjects.length; i++ )
        {
            System.out.println( (String) selectedObjects[ i ] );
        } 
         */            
        selectedObjects = list.getSelectedValues();
        closeDialog();
    }//GEN-LAST:event_addButtonActionPerformed

    private void helpButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_helpButtonActionPerformed
    {//GEN-HEADEREND:event_helpButtonActionPerformed
        // System.out.println( "Help" );                
    }//GEN-LAST:event_helpButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
    {//GEN-HEADEREND:event_cancelButtonActionPerformed
        // System.out.println( "Cancel" );
        selectedObjects = null;        
        closeDialog();        
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt)//GEN-FIRST:event_closeDialog
    {
        // System.out.println( "Close dialog" );
        closeDialog();
    }//GEN-LAST:event_closeDialog
    private void closeDialog()
    {
        System.out.println( "Close dialog" );
        setVisible( false );
        dispose();
    }    
    public java.util.Vector getSelectedValues()
    {
        if( selectedObjects == null )
        {
            return null;
        }
        java.util.Vector ret = new java.util.Vector();
        for( int i = 0; i < selectedObjects.length; i++ )
        {
            ret.add( (String) selectedObjects[ i ] );
        } 
        return ret;
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        PopupSelectionList psl = new PopupSelectionList(new javax.swing.JFrame(), true, null );
        psl.setVisible( true );
        java.util.Vector v = psl.getSelectedValues();        
        for( int i = 0; i < v.size(); i++ )
        {
            System.out.println( (String) v.get( i ) );
        } 
    }    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton helpButton;
    private javax.swing.JList list;
    private javax.swing.JPanel panel;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables
    
}
