/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.gui;

//import net.metadiversity.diversity.navigator.project.*;

import org.apache.log4j.Logger;
//import org.apache.log4j.Logger;
//import org.apache.log4j.Priority;
import org.apache.log4j.Level;

import java.awt.*;
// import java.awt.event.*;
import java.sql.*;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
//import javax.swing.table.*;

/**
   Show Query-Results
 */

/**
 *
 * @author  Dieter Neubacher
 */
// public class QueryResultSetTable extends javax.swing.JComponent
 public class QueryResultSetTable extends javax.swing.JTabbedPane
// public class QueryResultSetTable extends javax.swing.JPanel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257569524823177273L;

    static Logger logger = Logger.getLogger( QueryResultSetTable.class.getName() );
    
    private JScrollPane                 scrollPane;
    private QueryResultSetTableModel    model;
    private ResultSet                   rs;
    // ??? private Connection                  con;
    private Statement                   stat;
    private boolean                     scrolling;

    /**
     * Test 
     */
    public static void main( String[] args )
    {
        int WIDTH  = 400;
        int HEIGHT = 300;
        java.sql.Connection          con = null;
        
        org.apache.log4j.BasicConfigurator.configure();
        logger.getRoot().setLevel( Level.DEBUG );
        logger.setLevel( Level.DEBUG );
        
        String url      = "jdbc:postgresql://hongkong:5432/checklists";
        String username = "didi";
        String password = "";
        
        String query    = "SELECT * FROM checklists_data;"; 

        //    password = args[1];
        
        try
        {
            Class.forName( "org.postgresql.Driver" );
            con = DriverManager.getConnection( url, username, password );        
        }    
        catch( java.lang.ClassNotFoundException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
               
        JFrame frame = new javax.swing.JFrame();
        frame.setTitle( "ResultSet" );
        frame.setSize( WIDTH, HEIGHT );
        
        QueryResultSetTable qrst = new QueryResultSetTable( con, query );
        frame.getContentPane().add( qrst );
        
        frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        frame.pack();
        frame.setVisible( true );
    }
    /**
     *
     */
    public QueryResultSetTable( java.sql.Connection con, String query )
    {
        try
        {
            DatabaseMetaData meta = con.getMetaData();
                        
            if( meta.supportsResultSetType( ResultSet.TYPE_SCROLL_INSENSITIVE ) )
            {
                scrolling = true;
                // System.out.println( "Scrolling true" );
                stat = con.createStatement( ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY );
            }
            else
            {
                stat = con.createStatement();
                scrolling = false;
                // System.out.println( "Scrolling false" );
            }            
            
            if( scrollPane != null )
            {    
                remove( scrollPane );
            }
            if( rs != null )  
            {    
                rs.close();
            }
            rs = stat.executeQuery( query );
            
            if( scrolling )
            {
                model = new QueryScrollingResultSetTableModel( rs );
            }
            else
            {
                model = new QueryCachingResultSetTableModel( rs );
            }

         
            JTable table = new JTable( model );
            table.setAutoResizeMode( javax.swing.JTable.AUTO_RESIZE_OFF );
            scrollPane = new JScrollPane( table );
            add( scrollPane, BorderLayout.CENTER );
            this.setVisible( true );
           
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
   }
}
