/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="ApplicationSearchSelectionStrings"
 *     
*/
public class ApplicationSearchSelectionString implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3617013057146861112L;

    /** identifier field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.ApplicationSearchSelectionStringPK comp_id;

    /** nullable persistent field */
    private String itemTable;

    /** nullable persistent field */
    private String sqlstring;

    /** full constructor */
    public ApplicationSearchSelectionString(net.metadiversity.diversity.navigator.hibernate.bsm.ApplicationSearchSelectionStringPK comp_id, String itemTable, String sqlstring) {
        this.comp_id = comp_id;
        this.itemTable = itemTable;
        this.sqlstring = sqlstring;
    }

    /** default constructor */
    public ApplicationSearchSelectionString() {
    }

    /** minimal constructor */
    public ApplicationSearchSelectionString(net.metadiversity.diversity.navigator.hibernate.bsm.ApplicationSearchSelectionStringPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.ApplicationSearchSelectionStringPK getComp_id() {
        return this.comp_id;
    }

    public void setComp_id(net.metadiversity.diversity.navigator.hibernate.bsm.ApplicationSearchSelectionStringPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.property
     *             column="ItemTable"
     *             length="50"
     *         
     */
    public String getItemTable() {
        return this.itemTable;
    }

    public void setItemTable(String itemTable) {
        this.itemTable = itemTable;
    }

    /** 
     *            @hibernate.property
     *             column="SQLString"
     *             length="4000"
     *         
     */
    public String getSqlstring() {
        return this.sqlstring;
    }

    public void setSqlstring(String sqlstring) {
        this.sqlstring = sqlstring;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("comp_id", getComp_id())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof ApplicationSearchSelectionString) ) return false;
        ApplicationSearchSelectionString castOther = (ApplicationSearchSelectionString) other;
        return new EqualsBuilder()
            .append(this.getComp_id(), castOther.getComp_id())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getComp_id())
            .toHashCode();
    }

}
