/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import java.util.Date;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="TaxonAcceptedName_Log"
 *     
*/
public class TaxonAcceptedNameLog implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3256720675992318006L;

    /** identifier field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonAcceptedNameLogPK comp_id;

    /** nullable persistent field */
    private String conceptSuffix;

    /** nullable persistent field */
    private String conceptNotes;

    /** nullable persistent field */
    private String refId;

    /** nullable persistent field */
    private String refText;

    /** nullable persistent field */
    private String refDetail;

    /** nullable persistent field */
    private String typistsNotes;

    /** nullable persistent field */
    private String logInsertedBy;

    /** nullable persistent field */
    private Date logInsertedWhen;

    /** nullable persistent field */
    private String logUpdatedBy;

    /** nullable persistent field */
    private Date logUpdatedWhen;

    /** nullable persistent field */
    private String logState;

    /** nullable persistent field */
    private String logUser;

    /** full constructor */
    public TaxonAcceptedNameLog(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonAcceptedNameLogPK comp_id, String conceptSuffix, String conceptNotes, String refId, String refText, String refDetail, String typistsNotes, String logInsertedBy, Date logInsertedWhen, String logUpdatedBy, Date logUpdatedWhen, String logState, String logUser) {
        this.comp_id = comp_id;
        this.conceptSuffix = conceptSuffix;
        this.conceptNotes = conceptNotes;
        this.refId = refId;
        this.refText = refText;
        this.refDetail = refDetail;
        this.typistsNotes = typistsNotes;
        this.logInsertedBy = logInsertedBy;
        this.logInsertedWhen = logInsertedWhen;
        this.logUpdatedBy = logUpdatedBy;
        this.logUpdatedWhen = logUpdatedWhen;
        this.logState = logState;
        this.logUser = logUser;
    }

    /** default constructor */
    public TaxonAcceptedNameLog() {
    }

    /** minimal constructor */
    public TaxonAcceptedNameLog(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonAcceptedNameLogPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonAcceptedNameLogPK getComp_id() {
        return this.comp_id;
    }

    public void setComp_id(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonAcceptedNameLogPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.property
     *             column="ConceptSuffix"
     *             length="200"
     *         
     */
    public String getConceptSuffix() {
        return this.conceptSuffix;
    }

    public void setConceptSuffix(String conceptSuffix) {
        this.conceptSuffix = conceptSuffix;
    }

    /** 
     *            @hibernate.property
     *             column="ConceptNotes"
     *             length="500"
     *         
     */
    public String getConceptNotes() {
        return this.conceptNotes;
    }

    public void setConceptNotes(String conceptNotes) {
        this.conceptNotes = conceptNotes;
    }

    /** 
     *            @hibernate.property
     *             column="RefID"
     *             length="20"
     *         
     */
    public String getRefId() {
        return this.refId;
    }

    public void setRefId(String refId) {
        this.refId = refId;
    }

    /** 
     *            @hibernate.property
     *             column="RefText"
     *             length="255"
     *         
     */
    public String getRefText() {
        return this.refText;
    }

    public void setRefText(String refText) {
        this.refText = refText;
    }

    /** 
     *            @hibernate.property
     *             column="RefDetail"
     *             length="255"
     *         
     */
    public String getRefDetail() {
        return this.refDetail;
    }

    public void setRefDetail(String refDetail) {
        this.refDetail = refDetail;
    }

    /** 
     *            @hibernate.property
     *             column="TypistsNotes"
     *             length="255"
     *         
     */
    public String getTypistsNotes() {
        return this.typistsNotes;
    }

    public void setTypistsNotes(String typistsNotes) {
        this.typistsNotes = typistsNotes;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedBy"
     *             length="50"
     *         
     */
    public String getLogInsertedBy() {
        return this.logInsertedBy;
    }

    public void setLogInsertedBy(String logInsertedBy) {
        this.logInsertedBy = logInsertedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedWhen"
     *             length="16"
     *         
     */
    public Date getLogInsertedWhen() {
        return this.logInsertedWhen;
    }

    public void setLogInsertedWhen(Date logInsertedWhen) {
        this.logInsertedWhen = logInsertedWhen;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedBy"
     *             length="50"
     *         
     */
    public String getLogUpdatedBy() {
        return this.logUpdatedBy;
    }

    public void setLogUpdatedBy(String logUpdatedBy) {
        this.logUpdatedBy = logUpdatedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedWhen"
     *             length="16"
     *         
     */
    public Date getLogUpdatedWhen() {
        return this.logUpdatedWhen;
    }

    public void setLogUpdatedWhen(Date logUpdatedWhen) {
        this.logUpdatedWhen = logUpdatedWhen;
    }

    /** 
     *            @hibernate.property
     *             column="LogState"
     *             length="1"
     *         
     */
    public String getLogState() {
        return this.logState;
    }

    public void setLogState(String logState) {
        this.logState = logState;
    }

    /** 
     *            @hibernate.property
     *             column="LogUser"
     *             length="50"
     *         
     */
    public String getLogUser() {
        return this.logUser;
    }

    public void setLogUser(String logUser) {
        this.logUser = logUser;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("comp_id", getComp_id())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof TaxonAcceptedNameLog) ) return false;
        TaxonAcceptedNameLog castOther = (TaxonAcceptedNameLog) other;
        return new EqualsBuilder()
            .append(this.getComp_id(), castOther.getComp_id())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getComp_id())
            .toHashCode();
    }

}
