/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import java.util.Date;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="TaxonHierarchy"
 *     
*/
public class TaxonHierarchy implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257563997233559859L;

    /** identifier field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchyPK comp_id;

    /** nullable persistent field */
    private Integer nameParentId;

    /** nullable persistent field */
    private String hierarchyRefId;

    /** nullable persistent field */
    private String hierarchyRefText;

    /** nullable persistent field */
    private String hierarchyRefDetail;

    /** nullable persistent field */
    private Boolean hierarchyPositionIsUncertain;

    /** nullable persistent field */
    private String hierarchyTypistsNotes;

    /** nullable persistent field */
    private String hierarchyListCache;

    /** nullable persistent field */
    private String logInsertedBy;

    /** nullable persistent field */
    private Date logInsertedWhen;

    /** nullable persistent field */
    private String logUpdatedBy;

    /** nullable persistent field */
    private Date logUpdatedWhen;

    /** nullable persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.ProjectProxy projectProxy;

    /** nullable persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonName;

    /** full constructor */
    public TaxonHierarchy(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchyPK comp_id, Integer nameParentId, String hierarchyRefId, String hierarchyRefText, String hierarchyRefDetail, Boolean hierarchyPositionIsUncertain, String hierarchyTypistsNotes, String hierarchyListCache, String logInsertedBy, Date logInsertedWhen, String logUpdatedBy, Date logUpdatedWhen, net.metadiversity.diversity.navigator.hibernate.bsm.ProjectProxy projectProxy, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonName) {
        this.comp_id = comp_id;
        this.nameParentId = nameParentId;
        this.hierarchyRefId = hierarchyRefId;
        this.hierarchyRefText = hierarchyRefText;
        this.hierarchyRefDetail = hierarchyRefDetail;
        this.hierarchyPositionIsUncertain = hierarchyPositionIsUncertain;
        this.hierarchyTypistsNotes = hierarchyTypistsNotes;
        this.hierarchyListCache = hierarchyListCache;
        this.logInsertedBy = logInsertedBy;
        this.logInsertedWhen = logInsertedWhen;
        this.logUpdatedBy = logUpdatedBy;
        this.logUpdatedWhen = logUpdatedWhen;
        this.projectProxy = projectProxy;
        this.taxonName = taxonName;
    }

    /** default constructor */
    public TaxonHierarchy() {
    }

    /** minimal constructor */
    public TaxonHierarchy(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchyPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchyPK getComp_id() {
        return this.comp_id;
    }

    public void setComp_id(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchyPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.property
     *             column="NameParentID"
     *             length="10"
     *         
     */
    public Integer getNameParentId() {
        return this.nameParentId;
    }

    public void setNameParentId(Integer nameParentId) {
        this.nameParentId = nameParentId;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyRefID"
     *             length="20"
     *         
     */
    public String getHierarchyRefId() {
        return this.hierarchyRefId;
    }

    public void setHierarchyRefId(String hierarchyRefId) {
        this.hierarchyRefId = hierarchyRefId;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyRefText"
     *             length="255"
     *         
     */
    public String getHierarchyRefText() {
        return this.hierarchyRefText;
    }

    public void setHierarchyRefText(String hierarchyRefText) {
        this.hierarchyRefText = hierarchyRefText;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyRefDetail"
     *             length="255"
     *         
     */
    public String getHierarchyRefDetail() {
        return this.hierarchyRefDetail;
    }

    public void setHierarchyRefDetail(String hierarchyRefDetail) {
        this.hierarchyRefDetail = hierarchyRefDetail;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyPositionIsUncertain"
     *             length="1"
     *         
     */
    public Boolean getHierarchyPositionIsUncertain() {
        return this.hierarchyPositionIsUncertain;
    }

    public void setHierarchyPositionIsUncertain(Boolean hierarchyPositionIsUncertain) {
        this.hierarchyPositionIsUncertain = hierarchyPositionIsUncertain;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyTypistsNotes"
     *             length="255"
     *         
     */
    public String getHierarchyTypistsNotes() {
        return this.hierarchyTypistsNotes;
    }

    public void setHierarchyTypistsNotes(String hierarchyTypistsNotes) {
        this.hierarchyTypistsNotes = hierarchyTypistsNotes;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyListCache"
     *             length="1000"
     *         
     */
    public String getHierarchyListCache() {
        return this.hierarchyListCache;
    }

    public void setHierarchyListCache(String hierarchyListCache) {
        this.hierarchyListCache = hierarchyListCache;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedBy"
     *             length="50"
     *         
     */
    public String getLogInsertedBy() {
        return this.logInsertedBy;
    }

    public void setLogInsertedBy(String logInsertedBy) {
        this.logInsertedBy = logInsertedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedWhen"
     *             length="16"
     *         
     */
    public Date getLogInsertedWhen() {
        return this.logInsertedWhen;
    }

    public void setLogInsertedWhen(Date logInsertedWhen) {
        this.logInsertedWhen = logInsertedWhen;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedBy"
     *             length="50"
     *         
     */
    public String getLogUpdatedBy() {
        return this.logUpdatedBy;
    }

    public void setLogUpdatedBy(String logUpdatedBy) {
        this.logUpdatedBy = logUpdatedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedWhen"
     *             length="16"
     *         
     */
    public Date getLogUpdatedWhen() {
        return this.logUpdatedWhen;
    }

    public void setLogUpdatedWhen(Date logUpdatedWhen) {
        this.logUpdatedWhen = logUpdatedWhen;
    }

    /** 
     *            @hibernate.many-to-one
     *             update="false"
     *             insert="false"
     *         
     *            @hibernate.column
     *             name="Project"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.ProjectProxy getProjectProxy() {
        return this.projectProxy;
    }

    public void setProjectProxy(net.metadiversity.diversity.navigator.hibernate.bsm.ProjectProxy projectProxy) {
        this.projectProxy = projectProxy;
    }

    /** 
     *            @hibernate.many-to-one
     *             update="false"
     *             insert="false"
     *         
     *            @hibernate.column
     *             name="NameID"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName getTaxonName() {
        return this.taxonName;
    }

    public void setTaxonName(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonName) {
        this.taxonName = taxonName;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("comp_id", getComp_id())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof TaxonHierarchy) ) return false;
        TaxonHierarchy castOther = (TaxonHierarchy) other;
        return new EqualsBuilder()
            .append(this.getComp_id(), castOther.getComp_id())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getComp_id())
            .toHashCode();
    }

}
