/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.project;

import javax.swing.event.*;
import javax.swing.tree.*;
import java.util.*;

import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */
public class ProjectTreeModel implements TreeModel 
{
    static Logger logger = Logger.getLogger( ProjectTreeModel.class.getName() );
    
	private ProjectNode root = null;
	private Vector Listeners = new Vector();
	private ProjectPane inPane;

	public ProjectTreeModel( ProjectPane inPane ) 
        {
		this.inPane = inPane;
		root = new ProjectNode( inPane, null, ProjectNode.NODE_TYPE_PROJECTS_CAPTION, "Projects" );
	}

	public void reload() 
        {
		root.reloadChilds();
		for (Enumeration Enum=Listeners.elements(); Enum.hasMoreElements(); ) 
                {
			TreeModelListener tml = (TreeModelListener)Enum.nextElement();
			Object[] reloadFrom = { root };
			TreeModelEvent tme = new TreeModelEvent(this, reloadFrom);
			tml.treeStructureChanged( tme );
		}
	}
	public void reloadSubTree( ProjectNode reloadFromNode ) 
        {
		root.reloadChilds();
		for( Enumeration Enum=Listeners.elements(); Enum.hasMoreElements(); ) 
                {
			TreeModelListener l = (TreeModelListener)Enum.nextElement();
			Object[] reloadFrom = {reloadFromNode};
			TreeModelEvent e = new TreeModelEvent(this, reloadFrom);
			l.treeStructureChanged(e);
		}
	}
	public void addTreeModelListener(TreeModelListener l) 
        {
		Listeners.add(l);
	}
        //----------------------------------------------------------------------
	public Object getChild( Object parent, int index ) 
        {
		return (Object) (((ProjectNode)parent).getChild( index ) );
	}
        //----------------------------------------------------------------------
	public int getChildCount(Object parent) 
        {
		return ((ProjectNode) parent).getChildCount();
	}        
        //----------------------------------------------------------------------
	public int getIndexOfChild( Object parent, Object child ) 
        {
		return ((ProjectNode) parent).getChildIndex( child );
	}
        //----------------------------------------------------------------------
	public Object getRoot() 
        {
		return (Object) root;
	}
        //----------------------------------------------------------------------
	public boolean isLeaf( Object node ) 
        {
		return ((ProjectNode) node).isLeaf();
	}
        //----------------------------------------------------------------------
	public void removeTreeModelListener( TreeModelListener l ) 
        {
		Listeners.remove(l);
	}
        //----------------------------------------------------------------------
	public void valueForPathChanged( TreePath path, Object newValue ) 
        {
	}
}
