/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * UbtCollectionProjectPlugin.java
 *
 * Created on 18. November 2003, 16:15
 */

package net.metadiversity.diversity.navigator.projectPlugin;

import net.metadiversity.diversity.navigator.gui.DnOptionPane;
import org.apache.log4j.Logger;

//import net.metadiversity.diversity.navigator.gui.ProjectQueryPanel;
import net.metadiversity.diversity.navigator.gui.delta_editor.DeltaEditor;
import net.metadiversity.diversity.navikey.ui.NaviKey;

/**
 *
 * @author  Dieter Neubacher
 */
public class DiversityDescriptionsLiasMainProjectPlugin extends Plugin
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3256446897664570418L;
    static Logger logger = Logger.getLogger( DiversityDescriptionsLiasMainProjectPlugin.class.getName() );
    
    /** Creates a new instance of UbtCollectionProjectPlugin */
    public DiversityDescriptionsLiasMainProjectPlugin()
    {
        super( "LIAS Main", "Diversity Workbench" );

        // Add project databases
        
        String delta_editor_database = "LIAS Main Descriptions";
        addProjectDatabase( null, delta_editor_database );
        
        String diversity_taxon_names_database = "Diversity Taxon Names Fungi";
        addProjectDatabase( null, diversity_taxon_names_database );
        
        String diversity_accepted_names_cache_database = "Diversity Taxon Names Cache";
        addProjectDatabase( null, diversity_accepted_names_cache_database );

        java.sql.Connection connectionAcceptedNames = null;        
        java.sql.Connection namesConnection = null;        
        java.sql.Connection con = null;
        
        try
        {
            net.metadiversity.diversity.navigator.connection.ConnectionInfo ci;        
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( delta_editor_database );
            logger.info( "Connect to: " + ci.getUrl() );
            con = ci.getConnection();
            
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( diversity_taxon_names_database );
            logger.info( "Connect to: " + ci.getUrl() );
            namesConnection = ci.getConnection();
            
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( diversity_accepted_names_cache_database );
            logger.info( "Connect to: " + ci.getUrl() );
            connectionAcceptedNames = ci.getConnection();
        }
        catch( java.sql.SQLException ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        catch( Exception ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        if( connectionAcceptedNames == null )
        {
             DnOptionPane.DnShowErrorDialog( "Can't connect to AcceptedNamesCache database");
             return;
        }
//        String tablePrefix = "LIASmain";
        String tablePrefix = "Lias";

        logger.info( "init DeltaEditor" );
        DeltaEditor p = new DeltaEditor( con,  namesConnection, connectionAcceptedNames, tablePrefix, true );
        
        logger.info( "init data for Navikey" );
        String specs = p.getSpecsString();
        String chars = p.getCharsString();
        String items = p.getItemsString();
        
        logger.info( "init Navikey" );
        NaviKey navikey = new NaviKey( (java.awt.Container) getIdentificationPanel(), specs, chars, items );
        navikey.init();
        
        this.setGridViewPanel( p );
        this.pack();
        this.setVisible( true );
    }
}
