/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * ColumnInfo.java
 *
 * Created on January 17, 2002, 4:24 PM
 */
package net.metadiversity.diversity.navigator;

import net.metadiversity.diversity.navigator.types.DnBoolean;

import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */

public class ColumnInfo 
{
    static Logger logger = Logger.getLogger( ColumnInfo.class );
    
    private String   name;          // Table entry name
    private short    dataType;      // SQL data type
    private String   typeName;      // Database type name
    private int      size;          // 
    private int      decimals;
    private boolean  canBeNull;
    private boolean  pk = false;        
    private Class    classOf;
    private String   defaultValue;  // default value for this entry 

        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
	public ColumnInfo( String Name, short DataType, String TypeName, int Size, int Decimals, boolean CanBeNull, String DefaultValue ) 
        {
		this.name           = Name;
		this.dataType       = DataType;
		this.typeName       = TypeName;
		this.size           = Size;
		this.decimals       = Decimals;
		this.canBeNull      = CanBeNull;
                this.defaultValue   = DefaultValue;
                
                switch( dataType )
                {
                    case java.sql.Types.BIT :        
                        this.classOf = ( new DnBoolean() ).getClass();
                        break;
                    case java.sql.Types.INTEGER :        
                    case java.sql.Types.TINYINT :        
                        this.classOf = ( new Integer( 0 ) ).getClass();
                        break;
                    default :
                        // ??? this.classOf = ( new String() ).getClass();
                        this.classOf = "".getClass();
                        break;
                }    
	}
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
	public String getName() 
        {
            return name;
        }
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
	public String getDefaultValue() 
        {
            return defaultValue;
        }
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
        public short getDataType()
        {
            return dataType;
        }
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
        public String getTypeName()
        {
            return typeName;
        }
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
        public int getSize()
        {
            return size;
        }
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
        public int getDecimals()
        {
            return decimals;
        }
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
        public boolean isNull()
        {
            return canBeNull;
        }
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
        public boolean isPrimaryKey()
        {
            return pk;
        }
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
        public void setPrimaryKey( boolean b )
        {
            pk = b;
        }
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
        public Class isClassOf()
        {
            return classOf;
        }   
        /* (non-Javadoc)
		 * @see java.lang.Object#toString()
		 */
		//----------------------------------------------------------------------
        //----------------------------------------------------------------------
	public String toString() 
        {
		return name + ": " + typeName + " (" + size + ")";
	}
	/**
	 * @return
	 */
	public boolean isCanBeNull() 
	{
		return canBeNull;
	}

}

