/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * SystemPropertiesTableModel.java
 *
 * Created on 21. M�rz 2003, 11:10
 */

package net.metadiversity.diversity.navigator.about;
import org.apache.log4j.Logger;

import javax.swing.table.AbstractTableModel;

/**
 *
 * @author  didi
 */
public class SystemPropertiesTableModel extends AbstractTableModel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 4049637875920352310L;


    static Logger logger = Logger.getLogger( SystemPropertiesTableModel.class.getName() );
    
    
    java.util.Vector data;
    java.util.Vector name;
    
    /** Creates a new instance of SystemPropertiesTableModel */
    public SystemPropertiesTableModel()
    {
        data = new java.util.Vector();
        name = new java.util.Vector();

        name.add( "Property" );
        name.add( "Value" );
        
        // Show all System properies
        
        java.util.Properties properties = System.getProperties();
               
        for( java.util.Enumeration e = properties.propertyNames(); e.hasMoreElements(); ) 
        {
            String n = (String) e.nextElement();
            java.util.Vector v = new java.util.Vector();
            v.add( n );
            v.add( System.getProperty( n ) );
            data.add( v );
        }
    }
    
    /** Returns the number of columns in the model. A
     * <code>JTable</code> uses this method to determine how many columns it
     * should create and display by default.
     *
     * @return the number of columns in the model
     * @see #getRowCount
     *
     */
    public int getColumnCount()
    {
        return 2;
    }
    
    /** Returns the number of rows in the model. A
     * <code>JTable</code> uses this method to determine how many rows it
     * should display.  This method should be quick, as it
     * is called frequently during rendering.
     *
     * @return the number of rows in the model
     * @see #getColumnCount
     *
     */
    public int getRowCount()
    {
        return data.size();
    }
    
    /** Returns the value for the cell at <code>columnIndex</code> and
     * <code>rowIndex</code>.
     *
     * @param	rowIndex	the row whose value is to be queried
     * @param	columnIndex 	the column whose value is to be queried
     * @return	the value Object at the specified cell
     *
     */
    public Object getValueAt( int rowIndex, int columnIndex )
    {
        return ( (java.util.Vector)data.get( rowIndex ) ).get( columnIndex ); 
    }    
    
    /**  Returns a default name for the column using spreadsheet conventions:
     *  A, B, C, ... Z, AA, AB, etc.  If <code>column</code> cannot be found,
     *  returns an empty string.
     *
     * @param column  the column being queried
     * @return a string containing the default name of <code>column</code>
     *
     */
    public String getColumnName(int column)
    {
        switch( column )
        {
            case 0:
                    return "Property";                   
            case 1:
                    return "Value";
            default:
                    return "";
        }
    }
}
