/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DbConnection.java
 *
 * Created on December 14, 2001, 10:53 AM
 */
package net.metadiversity.diversity.navigator.checklists.database;

import java.sql.*;            // JDBC

import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 * @version 
 */
public class DbConnection 
{
    static Logger logger = Logger.getLogger( DbConnection.class.getName() ); 
    
    boolean DEBUG_FLAG = false;

    private String serverUrl;
    private String userName;
    private String passWord;
    private String dataBaseName;

    private StringBuffer lastErrorMessage;
    
    // Database Systems

    private static int  MS_ACCSSES  = 0;
    private static int  POSTGRESS   = 1;
    private static int  MY_SQL      = 2;
    private static int  JDATA       = 3;

    // debug

    private static boolean debugFlag = false;

    int selectedDataBase = POSTGRESS;
    
    /** Creates new DbConnection */
    public DbConnection() 
    {
	// default values
	userName       = "";
	dataBaseName   = "";
	serverUrl      = "";
	passWord       = "";
        
        lastErrorMessage = new StringBuffer();
    }

    public DbConnection( String url, String database, String user, String pass)
    {
	// default values
	userName       = user;
	dataBaseName   = database;
	serverUrl      = url;
	passWord       = pass;
        
        lastErrorMessage = new StringBuffer();
    }
    //-------------------------------------------------------------------------------------
    //
    //-------------------------------------------------------------------------------------
    public java.sql.Connection connect()
    {   
        java.sql.Connection  con = null;
        
	try
	{
            net.metadiversity.diversity.navigator.connection.ConnectionInfo ci;        
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( "checklists" );
            con = DriverManager.getConnection( ci.getUrl(), ci.getName(), ci.getUrl() );
        }
        catch( java.sql.SQLException ex )
        {
            logger.error( "Can't connect to checklists" );
        }
        
        return con;
    }    
/*  OLD-VERSION    
    public java.sql.Connection connect()
    {
	try
	{
	    // Use which driver for database accsses
	    String      url;
	    java.sql.Connection  con;

	    switch( selectedDataBase )
	    {
	    case 0 : // MS-ACCSSES --------------------------------------------

		try
		{
		    Class.forName( "sun.jdbc.odbc.JdbcOdbcDriver" );
		}
		catch( java.lang.ClassNotFoundException ee )
		{
		    System.err.print( "ClassNotFoundException: " );
		    System.err.println( ee.getMessage() );
		}
		url = "jdbc:odbc:InfoBase";
		break;

	    case 1 : // Postgress ---------------------------------------------
		// The JDBC Driver is in location
		// /usr/lib/pgsql/lib/postgresql.jar
                if( debugFlag )
                {
		    System.out.println( "Load PostgreSQL Driver..." );
                }
		lastErrorMessage.append( "Load PostgreSQL Driver...\n" );

		Class.forName( "org.postgresql.Driver" );

		// jdbc:postgresql:database
		// jdbc:postgresql://host/database
		// jdbc:postgresql://host:port/database
		// url = "jdbc:postgresql://china.didi.dn:5432/" + dataBaseName;
		url = "jdbc:postgresql://" + serverUrl + ":5432/" + dataBaseName;
		break;

	    case 2 : // MySQL -------------------------------------------------
		// Class.forName( "com.imaginary.sql.msql.MsqlDriver" );
		url = "jdbc:postgresql://china.didi.dn:5432/checklist";
		break;

	    case 3: // JData --------------------------------------------

		// Try to load the JData2_0 driver

		try
		{
		    java.sql.Driver drv = (Driver) Class.forName("JData2_0.sql.$Driver").newInstance();
		}
		catch( Exception ee )
	        {
		    System.out.println( "Cannot load the driver, reason:" + ee.toString() );
		    System.out.println( "Most likely the Java class path is incorrect." );
		}
		url = "jdbc:JDataConnect://127.0.0.1/test-java:test:1234";
		break;

	    default:
		System.out.println( "Database invalid" );
		url = "";
	    }
	    // Get Database Conection

	    // System.out.println( "Connect..." + url + "/" + userName + "/" + passWord );
	    // con = DriverManager.getConnection( url, userName, passWord );

            if( debugFlag )
            {
	        System.out.println( "Connect..." + url + "/" + userName + "/" + passWord );
            }
	    lastErrorMessage.append( "Connect..." + url + "/" + userName +"\n" );
	    con = DriverManager.getConnection( url, userName, passWord );
            if( debugFlag )
            {
    	        System.out.println( "Connect..ok" );
            }
	    lastErrorMessage.append( "Connect..ok" );

	    return con;
	}
	catch( Exception ex )
	{

	    System.out.println( ex.getMessage() + "\n" );
	    lastErrorMessage.append( ex.getMessage() + "\n" );


	    if( ex instanceof java.lang.ClassNotFoundException )
	    {
		    System.err.print( "ClassNotFoundException: " );
		    System.err.println( ex.getMessage() );
		    lastErrorMessage.append( "ClassNotFoundException:\n"+  ex.getMessage() + "\n" );
	    }
	    // System.out.println( "ex: " + ex.getMessage());
	    if( ex instanceof SQLException )
	    {
		String err = ((SQLException)ex).getSQLState();
		if ( err != null )
		{
		    System.out.println( "error: " + err );
		}
		SQLException SQLex;
		while ( ( SQLex = ((SQLException)ex).getNextException() ) != null )
		{
		    System.out.println( "sql exception " + SQLex.getSQLState());
		}
	    }
	    return null;
	}
    }
*/    
    //-------------------------------------------------------------------------------------
    //
    //-------------------------------------------------------------------------------------
}
