/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * Title:        Checklist
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      University Bayreuth
 * @author Dieter Neubacher
 * @version 1.0
 */

package net.metadiversity.diversity.navigator.checklists.taxon;

public class TaxonInput extends javax.swing.JPanel
{
/**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3761127150073231413L;
// private javax.swing.JPanel jPanelInputFieldsTaxon;

private int fieldCount;
private javax.swing.JLabel [] label;
private javax.swing.JLabel outputLine;
private javax.swing.JTextField [] textField;

    public TaxonInput()
    {
        outputLine = null;
        initComponents();
    }

    public TaxonInput( javax.swing.JLabel output )
    {
        outputLine = output;
        initComponents();
    }

    public void initComponents()
    {

        fieldCount = 5;

        String [] labelText = { "genus", "species", "subspecific rank", "(author)", "author" };
        // String [] labelText = { "genus", "species", "subspecies", "variety", "form", "(author)", "author" };

        label       = new javax.swing.JLabel[ fieldCount ];
        textField   = new javax.swing.JTextField[ fieldCount ];

        setLayout( new java.awt.GridLayout( 2, fieldCount ) );

        // labels
        for( int i = 0; i < fieldCount; i++ )
        {
            label[ i ]      = new javax.swing.JLabel();
            label[ i ].setText( labelText[ i ] );
            add( label[ i ] );
        }
        // input fields
        for( int i = 0; i < fieldCount; i++ )
        {
            textField[ i ]  = new javax.swing.JTextField();
            add( textField[ i ] );

            textField[ i ].addKeyListener( new java.awt.event.KeyAdapter ()
            {
                public void keyReleased( java.awt.event.KeyEvent evt )
                {
		    showOutputLine();
                }
            }
	    );

            textField[ i ].addActionListener (new java.awt.event.ActionListener ()
	    {
	        public void actionPerformed (java.awt.event.ActionEvent evt)
	        {
	        }
            }
	    );
        }
/*
	jLabelOutputLine         = new javax.swing.JLabel();
        jLabelOutputLine.setForeground( java.awt.Color.red );
        jLabelOutputLine.setFont( new java.awt.Font ( "Dialog", 1, 12 ) );
        jLabelOutputLine.setHorizontalAlignment( javax.swing.SwingConstants.CENTER );
*/
    }
    public void setGenus( String s )            { textField[ 0 ].setText( s ); }
    public void setSpecies( String s )          { textField[ 1 ].setText( s ); }
    public void setSubSpecies( String s )       { textField[ 2 ].setText( s ); }
    public void setVariety( String s )          { textField[ 3 ].setText( s ); }
    public void setForm( String s )             { textField[ 4 ].setText( s ); }
    public void setFirstDiscription( String s ) { textField[ 5 ].setText( s ); }
    public void setAuthor( String s )           { textField[ 6 ].setText( s ); }

    public String getGenus()            { return textField[ 0 ].getText().trim(); }
    public String getSpecies()          { return textField[ 1 ].getText().trim(); }
    public String getSubSpecies()       { return textField[ 2 ].getText().trim(); }
    public String getVariety()          { return textField[ 3 ].getText().trim(); }
    public String getForm()             { return textField[ 4 ].getText().trim(); }
    public String getFirstDiscription() { return textField[ 5 ].getText().trim(); }
    public String getAuthor()           { return textField[ 6 ].getText().trim(); }



    private void showOutputLine()
    {
	java.lang.StringBuffer out = new java.lang.StringBuffer();

	if( textField[ 0 ].getText().trim().length() != 0 )
	    out.append( textField[ 0 ].getText()      + " " );

	if( textField[ 1 ].getText().trim().length() != 0 )
	    out.append( textField[ 1 ].getText()    + " " );

	if( textField[ 2 ].getText().trim().length() != 0 )
	    out.append( "sub. " + textField[ 2 ].getText() + " " );

	if( textField[ 3 ].getText().trim().length() != 0 )
	    out.append( "var. " + textField[ 3 ].getText() + " " );

	if( textField[ 4 ].getText().trim().length() != 0  )
	    out.append( "f. " + textField[ 4 ].getText() + " " );

	if( textField[ 5 ].getText().trim().length() != 0 )
	    out.append( "(" + textField[ 5 ].getText() + ")" );

	if( textField[ 6 ].getText().trim().length() != 0 )
	    out.append( " " + textField[ 6 ].getText() + " " );

	outputLine.setText( out.toString() );
	outputLine.setVisible( true );
    }

}
