/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DnDialog.java
 *
 * Created on 26. Mai 2004, 16:07
 */

package net.metadiversity.diversity.navigator.gui;

/**
 *
 * @author  didi
 */
public class DnDialog extends javax.swing.JDialog
{
    
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3832616300827653430L;
    /** Creates new form DnDialog */
    public DnDialog(java.awt.Frame parent, boolean modal)
    {
        super(parent, modal);
        initComponents();
        center();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        
        addWindowListener(new java.awt.event.WindowAdapter()
        {
            public void windowClosing(java.awt.event.WindowEvent evt)
            {
                closeDialog(evt);
            }
        });
        
        pack();
    }//GEN-END:initComponents
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt)//GEN-FIRST:event_closeDialog
    {
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    private void closeDialog()
    {
        setVisible(false);
        dispose();
    }
    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void center() 
    {
        java.awt.Point parentFrameLocation = this.getParent().getLocation();
        java.awt.Dimension parentFrameSize = this.getParent().getSize();
        java.awt.Dimension thisDialogSize = this.getSize();

        // Calculate locations
        int xLocation = parentFrameLocation.x + parentFrameSize.width / 2 - thisDialogSize.width / 2;
        int yLocation = parentFrameLocation.y + parentFrameSize.height / 2 - thisDialogSize.height / 2;

        // Do not set location outside of screen
        if( xLocation < 0 ) xLocation = 15;
        if( yLocation < 0 ) yLocation = 15;

        // Do not cover parent frame
        if( xLocation <= parentFrameLocation.x + 15 ) xLocation = parentFrameLocation.x + 15;
        if( yLocation <= parentFrameLocation.y + 15 ) yLocation = parentFrameLocation.y + 15;

        this.setLocation( xLocation, yLocation );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        new DnDialog(new javax.swing.JFrame(), true).setVisible( true );
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    
}
