/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * CollectionTabIndentification.java
 *
 * Created on 15. September 2004, 11:39
 */

package net.metadiversity.diversity.navigator.gui;

import javax.swing.JFrame;

import com.jgoodies.forms.layout.*;
import com.jgoodies.forms.layout.ColumnSpec;
/**
 *
 * @author  didi
 */
public class DnPanelFormsTemplate extends com.jgoodies.forms.builder.PanelBuilder
{
    com.jgoodies.forms.builder.PanelBuilder     builder;
    // default format values
    static final String DEFAULT_COLUMNE_FORMAT = "fill:d:grow";
    static final String PAD_COLUMNE_FORMAT     = "fill:3dlu:nogrow";
    static final String DEFAULT_ROW_FORMAT     = "fill:d:nogrow";
    static final String PAD_ROW_FORMAT         = "fill:3dlu:nogrow";    
    // Form parameter
    int xMaxFormPos;
    int yMaxFormPos;
    // debug
    boolean DEBUG_ADD_COMPONENT = false;
    boolean DEBUG_LINE_AND_ROW_NUMBERS = false;
    //
    CellConstraints cc;
    
    public void showLineNumbers( boolean b )
    {
        DEBUG_LINE_AND_ROW_NUMBERS = b;
    }
    
    public DnPanelFormsTemplate()
    {
        super( new com.jgoodies.forms.layout.FormLayout( "", "" ) );
        showLineNumbers( false );
        cc = new CellConstraints();
        xMaxFormPos = 9;
        yMaxFormPos = 11;
/*        
//        columnFormatString = PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +
//                             PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +  
        columnFormatString = PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             // date
                             PAD_COLUMNE_FORMAT + ", " + "fill:10dlu:nogrow" + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:10dlu:nogrow" + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:20dlu:nogrow" + ", " +  
                             // Suppl.
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             // category
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             // Category
                             // PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +  
                             // PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +  
                             // PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +  
                             // PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " + 
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(1.0)" + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             // Exsiccatum
                             PAD_COLUMNE_FORMAT + ", " + "fill:10dlu:nogrow" + ", " +  
//                             PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(1.0)" + ", " +  
                             PAD_COLUMNE_FORMAT 
                            ;
*/        
        
        ColumnSpec colPad = new com.jgoodies.forms.layout.ColumnSpec( PAD_COLUMNE_FORMAT );              
        ColumnSpec colDef = new com.jgoodies.forms.layout.ColumnSpec( DEFAULT_COLUMNE_FORMAT );              
        
        RowSpec rowPad = new com.jgoodies.forms.layout.RowSpec( PAD_ROW_FORMAT );              
        RowSpec rowDef = new com.jgoodies.forms.layout.RowSpec( DEFAULT_ROW_FORMAT );              

        
        if( DEBUG_LINE_AND_ROW_NUMBERS )
        {
            appendColumn( colDef );
            appendRow( rowDef );
        }
        else
        {
            appendColumn( colPad );
            appendRow( rowPad );                
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            appendColumn( colDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && col == xMaxFormPos )
            {
                appendColumn( colDef );
            }
            else
            {
                appendColumn( colPad );
            }
        }
        for( int row = 1; row <= yMaxFormPos; row++ )
        {   
            appendRow( rowDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && row == yMaxFormPos )
            {
                appendRow( rowDef );
            }
            else
            {
                appendRow( rowPad );                   
            }
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // Set line numbers 
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l1, cc.xy( 1 , row * 2 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l2, cc.xy( xMaxFormPos * 2 + 1, row * 2 ) );
            }
            else
            {
                javax.swing.JLabel l1 = new javax.swing.JLabel( " " );
                add( l1, cc.xy( 1 , row * 2 ) );                
            }
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // set column numbers
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l1, cc.xy( col * 2, 1 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l2, cc.xy( col * 2, yMaxFormPos * 2 + 1 ) );
            }
        }
        
        initComponents();                
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void debug( int x, int y, int l, int h )
    {
        System.out.println( "x: " + x +  " \ty: " + y + " \tl:" + l );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void setLayout( java.awt.LayoutManager lm )
    {
        
    }
    void add( javax.swing.JComponent c, java.awt.GridBagConstraints gbc )    
    {
        cc = new CellConstraints();
        System.out.println( c );
        // Don't show Lable outside the form
        if( gbc.gridx > xMaxFormPos || gbc.gridy > yMaxFormPos )
        {
            return;
        }
        cc.xywh( ( gbc.gridx + 1 ) * 2, ( gbc.gridy + 1 ) * 2, ( gbc.gridwidth * 2 ) -1, ( gbc.gridheight * 2 ) -1 );
        System.out.println( cc );        
        add( c, cc );
        
    }
    /** This method is called from within the constructor to     
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        java.awt.GridBagConstraints gridBagConstraints;

        setLayout(new java.awt.GridBagLayout());

    }//GEN-END:initComponents
    
    public static void main( String [] args  )
    {
        CollectionTabGeographicData p = new CollectionTabGeographicData();
        
        javax.swing.JFrame f = new javax.swing.JFrame();        
        f.getContentPane().add( p.getPanel() );
        f.setVisible( true );
        f.setDefaultCloseOperation( JFrame.DISPOSE_ON_CLOSE );
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    
}
