/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.gui;

import org.apache.log4j.Logger;

import java.sql.*;

/**
   Dieses Klasse verwendet einen bildlauff�higen Cursor (ein
   JDBC 2-Feature), um Elemente der Ergebnismenge zu lokalisieren.
*/
class QueryScrollingResultSetTableModel extends QueryResultSetTableModel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257291313920751671L;
    static Logger logger = Logger.getLogger( QueryScrollingResultSetTableModel.class.getName() );
    /**
      Konstruiert das Tabellenmodell.
      @param aResultSet Anzuzeigende Ergebnismenge
    */
    public QueryScrollingResultSetTableModel( ResultSet aResultSet )
    {
        super( aResultSet );
    }
    //---------------------------------------------------------------------------
    //---------------------------------------------------------------------------
    public Object getValueAt( int r, int c )
    {
        try
        {
            ResultSet rs = getResultSet();
            rs.absolute( r + 1 );
            return rs.getObject( c + 1 );
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
            return null;
        }
    }
    //---------------------------------------------------------------------------
    //---------------------------------------------------------------------------
    public int getRowCount()
    {
        try
        {
            ResultSet rs = getResultSet();
            rs.last();
            return rs.getRow();
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
            return 0;
        }
    }
}