/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * QueryTreeModel.java
 *
 * Created on 29. Juli 2003, 12:29
 */

package net.metadiversity.diversity.navigator.gui;

import net.metadiversity.diversity.navigator.project.*;

import org.apache.log4j.Logger;


/**
 *
 * @author  Dieter Neubacher
 */
public class QueryTreeModel implements javax.swing.tree.TreeModel
{
    static Logger logger = Logger.getLogger( QueryTreeModel.class.getName() );
    
    private DnDbProjectRoot projectRoot;
    private javax.swing.event.EventListenerList listenerList;
            
    static int MAX_LEVEL = 5;
    
    private boolean debug = false;
    
    /** Creates a new instance of QueryTreeModel */
    public QueryTreeModel( DnDbProjectRoot root )
    {
        if( debug ) if( logger.isDebugEnabled() ) logger.debug( "QueryTreeModel()" ); 
        
        projectRoot = root;
        listenerList = new javax.swing.event.EventListenerList();        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void addTreeModelListener( javax.swing.event.TreeModelListener treeModelListener )
    {
        if( debug ) if( logger.isDebugEnabled() ) logger.debug( "addTreeModelListener()" ); 
        listenerList.add( javax.swing.event.TreeModelListener.class, treeModelListener );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public Object getChild( Object parent, int param )
    {
        if( debug ) if( logger.isDebugEnabled() ) logger.debug( "getChild( " + parent + ", " + param + " )" );

        Object obj = projectRoot.getChild( (java.lang.String) parent, param );                
        
        return obj;
/*        
        if( parent.toString().compareTo( "root" ) == 0 ) 
        {
            return parent.toString() + "." + projectRoot.getChild( param );
        }
        else
        {
            return "getChild";
        }    
 */
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getChildCount( Object parent )
    {
         if( debug ) if( logger.isDebugEnabled() ) logger.debug( "getChildCount( " + parent + " )" );
         
         return projectRoot.getChildCount( (java.lang.String) parent );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getIndexOfChild( Object parent, Object child )
    {
        if( debug ) if( logger.isDebugEnabled() ) logger.debug( "getChild( " + parent + ", " + child + " )" );
         
        return 1;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public Object getRoot()
    {
        return "root";
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public boolean isLeaf( Object node )
    {
        if( debug )  if( logger.isDebugEnabled() ) logger.debug( "isLeaf( " + node + ")" );
        
        int level = 0;
        int pos = 0;
        java.lang.String str = node.toString();
        while( ( pos = str.indexOf( '.' ) ) > 0 )
        {
            if( debug )  if( logger.isDebugEnabled() ) logger.debug( "str: " + str );
            level++;
            str = str.substring( ++pos );
            if( level == MAX_LEVEL )
            {
                return true;
            }
        }    
        return false;
    }
    //--------------------------------------------------------------------------
    public void removeTreeModelListener(javax.swing.event.TreeModelListener treeModelListener)
    {
    }
    //--------------------------------------------------------------------------
    public void valueForPathChanged(javax.swing.tree.TreePath treePath, Object obj)
    {
    }    
}
