/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DeltaEditorChangeEvent.java
 *
 * Created on 19. M�rz 2004, 17:42
 */

package net.metadiversity.diversity.navigator.gui.delta_editor;

/**
 *
 * @author  didi
 */
public class DeltaEditorChangeEvent extends javax.swing.event.ChangeEvent
{    
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3834312825861648948L;
    
    final public static int NONE                    = 0x00;
    final public static int REMOVE_CHARACTER_STATE  = 0x01;
    final public static int ADD_CHARACTER_STATE     = 0x02;
    final public static int UPDATE_CHARACTER_DESCRIPTION_STATE = 0x04;
    int mode;
    int row;
    int col;
    /** Creates a new instance of DeltaEditorChangeEvent */
    public DeltaEditorChangeEvent( java.lang.Object source )    
    {
        super( source );
        mode = NONE;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public DeltaEditorChangeEvent( java.lang.Object source, int mode, int row, int col )    
    {
        super( source );
        this.mode = mode;
        this.row = row;
        this.col = col;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getMode()
    {
        return mode;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getRow()
    {
        return row;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getColumn()
    {
        return col;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
}
