/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * TaxonNameFormPanel.java
 *
 * Created on 8. Juni 2005, 05:38
 */

package net.metadiversity.diversity.navigator.gui.taxon_names;

//import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
//import java.sql.Statement;
//import java.util.Date;
//import java.util.Set;

//import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;

import org.apache.log4j.Logger;

//import net.metadiversity.diversity.navigator.db.delta_editor.DeltaEditorData;
//import net.metadiversity.diversity.navigator.gui.ProjectQueryPanel;
//import net.metadiversity.diversity.navigator.gui.delta_editor.DeltaEditor;
//import net.metadiversity.diversity.navikey.ui.NaviKey;
//import org.apache.log4j.Logger;

//import net.metadiversity.diversity.navigator.gui.ProjectQueryPanel;
//import net.metadiversity.diversity.navigator.gui.delta_editor.DeltaEditor;
//import net.metadiversity.diversity.navikey.ui.NaviKey;

/**
 *
 * @author  didi
 */
public class TaxonNameFormPanel extends FormTemplate
{
    static Logger logger = Logger.getLogger( TaxonNameFormPanel.class.getName() );
    

    private static boolean rankComboBoxInitFlag = false;
    private static DefaultComboBoxModel rankModel = new DefaultComboBoxModel( );
    
    private static boolean sanctioningAuthorComboBoxInitFlag = false;
    private static DefaultComboBoxModel sanctioningAuthorModel  = new DefaultComboBoxModel( );
    
    
    private static boolean infragenericEpithetComboBoxInitFlag = false;
    private static DefaultComboBoxModel infragenericEpithetModel  = new DefaultComboBoxModel( );
    
    private java.sql.Connection namesConnection = null;
    private boolean flagAppendSelectionWhereAnd = false;
    
    /** Creates new form TestFormPanel */
    public TaxonNameFormPanel()     
    {
        super( 9, 15 );
        this.namesConnection = null;
        initComponents();
    }
    
    public TaxonNameFormPanel( java.sql.Connection namesConnection )     
    {
        super( 9, 15 );
        this.namesConnection = namesConnection;
        
        if( namesConnection == null )
        {
        try
        {
            String db = "Diversity Taxon Names Fungi";
            net.metadiversity.diversity.navigator.connection.ConnectionInfo ci;        
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( db );
            namesConnection = ci.getConnection();
            logger.info( "Connect to: " + ci.getUrl() );
        }
        catch( SQLException e )
        {
            e.printStackTrace();
        }
        }
        initComponents();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void setLayout( java.awt.LayoutManager lm )
    {
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jTextFieldGenOrSupragenName = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jComboBoxInfragenericEpithet = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldGenusOfSpecies = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jTextFieldSpeciesEpithet = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextFieldInfraspecificEpithet = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jTextFieldOriginalOrthography = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jComboBoxTaxonomicRank = new javax.swing.JComboBox();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jTextFieldBasionym = new javax.swing.JTextField();
        jTextFieldCombining = new javax.swing.JTextField();
        jTextFieldPublishing = new javax.swing.JTextField();
        jComboBoxSa = new javax.swing.JComboBox();
        jCheckBox1 = new javax.swing.JCheckBox();
        jLabel12 = new javax.swing.JLabel();
        jTextFieldAnaTeleomorth = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jScrollPaneTypistNotes = new javax.swing.JScrollPane();
        jTextAreaTypistNotes = new javax.swing.JTextArea();

        setLayout(new java.awt.GridBagLayout());

        jLabel1.setLabelFor(jTextFieldGenOrSupragenName);
        jLabel1.setText("Gen. or supragen. name:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel1, gridBagConstraints);

        jTextFieldGenOrSupragenName.setText("jTextFieldGenOrSupragenName");
        jTextFieldGenOrSupragenName.setName("");
        jTextFieldGenOrSupragenName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldGenOrSupragenNameActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldGenOrSupragenName, gridBagConstraints);

        jLabel2.setDisplayedMnemonic('G');
        jLabel2.setLabelFor(jTextFieldGenusOfSpecies);
        jLabel2.setText("Genus (of species):");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxInfragenericEpithet, gridBagConstraints);

        jLabel3.setLabelFor(jComboBoxInfragenericEpithet);
        jLabel3.setText("Infrageneric epithet:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel3, gridBagConstraints);

        jTextFieldGenusOfSpecies.setText("jTextFieldGenusOfSpecies");
        jTextFieldGenusOfSpecies.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldGenusOfSpeciesActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldGenusOfSpecies, gridBagConstraints);

        jLabel4.setDisplayedMnemonic('S');
        jLabel4.setText("Species epithet:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel4, gridBagConstraints);

        jTextFieldSpeciesEpithet.setText("jTextFieldSpeciesEpithet");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldSpeciesEpithet, gridBagConstraints);

        jLabel5.setLabelFor(jTextFieldInfraspecificEpithet);
        jLabel5.setText("Infraspecific epithet:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel5, gridBagConstraints);

        jTextFieldInfraspecificEpithet.setText("jTextFieldInfraspecificEpithet");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldInfraspecificEpithet, gridBagConstraints);

        jLabel6.setDisplayedMnemonic('O');
        jLabel6.setLabelFor(jTextFieldOriginalOrthography);
        jLabel6.setText("Original orthography:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel6, gridBagConstraints);

        jTextFieldOriginalOrthography.setText("jTextFieldOriginalOrthography");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldOriginalOrthography, gridBagConstraints);

        jLabel7.setDisplayedMnemonic('R');
        jLabel7.setLabelFor(jComboBoxTaxonomicRank);
        jLabel7.setText("Taxonomic rank:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel7, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxTaxonomicRank, gridBagConstraints);

        jLabel8.setDisplayedMnemonic('B');
        jLabel8.setLabelFor(jTextFieldBasionym);
        jLabel8.setText("Basionym");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel8, gridBagConstraints);

        jLabel9.setDisplayedMnemonic('C');
        jLabel9.setLabelFor(jTextFieldCombining);
        jLabel9.setText("Combining");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel9, gridBagConstraints);

        jLabel10.setDisplayedMnemonic('P');
        jLabel10.setLabelFor(jTextFieldPublishing);
        jLabel10.setText("Publishing");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel10, gridBagConstraints);

        jLabel11.setText("Sa.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel11, gridBagConstraints);

        jTextFieldBasionym.setText("jTextFieldBasionym");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldBasionym, gridBagConstraints);

        jTextFieldCombining.setText("jTextFieldCombining");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 9;
        add(jTextFieldCombining, gridBagConstraints);

        jTextFieldPublishing.setText("jTextFieldPublishing");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 9;
        add(jTextFieldPublishing, gridBagConstraints);

        jComboBoxSa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxSaActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxSa, gridBagConstraints);

        jCheckBox1.setMnemonic('H');
        jCheckBox1.setText("Is Hybrid");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 7;
        add(jCheckBox1, gridBagConstraints);

        jLabel12.setDisplayedMnemonic('A');
        jLabel12.setLabelFor(jTextFieldAnaTeleomorth);
        jLabel12.setText("Ana/Teleomorth:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel12, gridBagConstraints);

        jTextFieldAnaTeleomorth.setText("jTextFieldAnaTeleomorth");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldAnaTeleomorth, gridBagConstraints);

        jLabel13.setDisplayedMnemonic('N');
        jLabel13.setText("Typist notes:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel13, gridBagConstraints);

        jTextAreaTypistNotes.setText("jTextAreaTypistNotes");
        jScrollPaneTypistNotes.setViewportView(jTextAreaTypistNotes);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.gridheight = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(jScrollPaneTypistNotes, gridBagConstraints);

    }//GEN-END:initComponents

    private void jComboBoxSaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxSaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxSaActionPerformed

    private void jTextFieldGenOrSupragenNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldGenOrSupragenNameActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldGenOrSupragenNameActionPerformed

    private void jTextFieldGenusOfSpeciesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldGenusOfSpeciesActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldGenusOfSpeciesActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JComboBox jComboBoxInfragenericEpithet;
    private javax.swing.JComboBox jComboBoxSa;
    private javax.swing.JComboBox jComboBoxTaxonomicRank;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPaneTypistNotes;
    private javax.swing.JTextArea jTextAreaTypistNotes;
    private javax.swing.JTextField jTextFieldAnaTeleomorth;
    private javax.swing.JTextField jTextFieldBasionym;
    private javax.swing.JTextField jTextFieldCombining;
    private javax.swing.JTextField jTextFieldGenOrSupragenName;
    private javax.swing.JTextField jTextFieldGenusOfSpecies;
    private javax.swing.JTextField jTextFieldInfraspecificEpithet;
    private javax.swing.JTextField jTextFieldOriginalOrthography;
    private javax.swing.JTextField jTextFieldPublishing;
    private javax.swing.JTextField jTextFieldSpeciesEpithet;
    // End of variables declaration//GEN-END:variables
    
    public static void main( String [] args  ) throws SQLException
    {
        TaxonNameFormPanel p = new TaxonNameFormPanel( null );
        
        
        javax.swing.JFrame f = new javax.swing.JFrame();        
        f.getContentPane().add( p.getPanel() );
        f.setVisible( true );
        f.setDefaultCloseOperation( JFrame.DISPOSE_ON_CLOSE );
    }

    //---------------------------------------------------------------------------
    // search NameID
    //---------------------------------------------------------------------------
    public TaxonNameSelectEntry searchNameID( String headerText )
    {
        TaxonNameFormPanel p = new TaxonNameFormPanel();
        
        p.jTextFieldGenOrSupragenName.setText( "*" );
        p.jTextFieldGenOrSupragenName.setEditable( true );
        p.jTextFieldSpeciesEpithet.setText( "*" );
        p.jTextFieldSpeciesEpithet.setEditable( true );
      
        p.jTextFieldInfraspecificEpithet.setText( "" );
        p.jTextFieldInfraspecificEpithet.setEditable( true );
        p.jTextFieldPublishing.setText( "" );
        p.jTextFieldPublishing.setEditable( true );
        p.jTextFieldBasionym.setText( "" );
        p.jTextFieldBasionym.setEditable( true );
        p.jTextFieldCombining.setText( "" );
        p.jTextFieldCombining.setEditable( true );
        p.jTextFieldOriginalOrthography.setText( "" );
        p.jTextFieldOriginalOrthography.setEditable( true );
        p.jTextAreaTypistNotes.setText( "" );
        p.jTextAreaTypistNotes.setEditable( true );
        p.jTextFieldAnaTeleomorth.setText( "" );
        p.jTextFieldAnaTeleomorth.setEditable( true );
        p.jTextFieldGenusOfSpecies.setText( "" );
        p.jTextFieldGenusOfSpecies.setEditable( true );
        //-----------------------
        // init rank selection
        //-----------------------
        if( rankComboBoxInitFlag == false )
        {
            try
            {
                // default sellection 
                rankModel.addElement( "" );
                rankModel.addElement( "*" );
                
                java.sql.Statement stm = namesConnection.createStatement();
                ResultSet res = stm.executeQuery( "SELECT code FROM TaxonNameTaxonomicRank_Enum" );
                while( res.next() )
                {	
                    rankModel.addElement( res.getString( "code" ) );
                }
                rankComboBoxInitFlag = true;
            }
            catch( SQLException ex )
            {
                logger.error( ex.getMessage(), ex.fillInStackTrace() );
            }
        }
        p.jComboBoxTaxonomicRank.setModel( rankModel );
        //-----------------------
        // init SanctioningAuthor selection
        //-----------------------
        if( sanctioningAuthorComboBoxInitFlag == false )
        {
            try
            {
                // default sellection 
                sanctioningAuthorModel.addElement( "" );
                sanctioningAuthorModel.addElement( "*" );

                java.sql.Statement stm = namesConnection.createStatement();
                /*
                ResultSet res = stm.executeQuery( "SELECT code FROM TaxonNameTaxonomicRank_Enum" );
                while( res.next() )
                {	
                    rankModel.addElement( res.getString( "code" ) );
                }
                */
                sanctioningAuthorComboBoxInitFlag = true;
            }
            catch( SQLException ex )
            {
                logger.error( ex.getMessage(), ex.fillInStackTrace() );
            }
        }
        p.jComboBoxSa.setModel( sanctioningAuthorModel );
        //-----------------------
        // init infragenericEpithet selection
        //-----------------------
        if( infragenericEpithetComboBoxInitFlag == false )
        {
            try
            {
                // default sellection 
                infragenericEpithetModel.addElement( "" );
                infragenericEpithetModel.addElement( "*" );

                java.sql.Statement stm = namesConnection.createStatement();
                /*
                ResultSet res = stm.executeQuery( "SELECT code FROM TaxonNameTaxonomicRank_Enum" );
                while( res.next() )
                {	
                    rankModel.addElement( res.getString( "code" ) );
                }
                */
                infragenericEpithetComboBoxInitFlag = true;
            }
            catch( SQLException ex )
            {
                logger.error( ex.getMessage(), ex.fillInStackTrace() );
            }
        }
        p.jComboBoxInfragenericEpithet.setModel( infragenericEpithetModel );
        //-----------------------------------
        // TaxonNameNomenclaturalStatus_Enum
        //-----------------------------------

        // Show three options "Skip", "OK", "Cancel"
        Object[] possibleValues = { "Skip", "Ok", "Cancel" };

//        Object obj = javax.swing.JOptionPane.showInternalInputDialog( null, p.getPanel(), headerText, javax.swing.JOptionPane.INFORMATION_MESSAGE, null, possibleValues, possibleValues[ 0 ] );
//        Object obj = javax.swing.JOptionPane.showInputDialog( null, p.getPanel(), headerText, javax.swing.JOptionPane.INFORMATION_MESSAGE, null, possibleValues, possibleValues[ 0 ] );
//         int test = javax.swing.JOptionPane.showInternalOptionDialog( this, dia, "Pleace select or input:", javax.swing.JOptionPane.INFORMATION_MESSAGE, null, possibleValues, possibleValues[ 0 ] );
        
        
//        int test = javax.swing.JOptionPane.showConfirmDialog( null, p.getPanel(), headerText, JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE );

        int test = javax.swing.JOptionPane.showOptionDialog( null, p.getPanel(), "headerText", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, null, possibleValues, possibleValues[ 0 ] );

        if( test == 0 )       // Skip
        {
            return new TaxonNameSelectEntry( 0, "?" );
        }        
        else if( test == 2 ) // Cancel 
        {
            return null;
        }
/*        
        
        jTextFieldAnaTeleomorth.setText( res.getString( "anamorphTeleomorph" ) );
        jTextFieldBasionym.setText( res.getString( "basionymAuthors" ));
        jTextFieldCombining.setText( res.getString( "combiningAuthors" ));
    //    jTextFieldGenusOfSpecies;
        jTextFieldOriginalOrthography.setText( res.getString( "originalOrthography" ) );
*/        
        String gen = p.jTextFieldGenOrSupragenName.getText();
        String spe = p.jTextFieldSpeciesEpithet.getText();
        String epi = p.jTextFieldInfraspecificEpithet.getText();
        String pub = p.jTextFieldPublishing.getText();
        String bas = p.jTextFieldBasionym.getText();
        String com = p.jTextFieldCombining.getText();
        String gof = p.jTextFieldGenusOfSpecies.getText();
        String oro = p.jTextFieldOriginalOrthography.getText();
        String tno = p.jTextAreaTypistNotes.getText();
        String ana = p.jTextFieldAnaTeleomorth.getText();

        String san = (String) p.jComboBoxSa.getSelectedItem();
        String rsl = (String) p.jComboBoxTaxonomicRank.getSelectedItem();
        String igr = (String) p.jComboBoxInfragenericEpithet.getSelectedItem();
        
        flagAppendSelectionWhereAnd = true;
        StringBuffer select = new StringBuffer();        
        
        
        select.append( "SELECT TaxonName.NameId AS NameID, taxonNameCache FROM TaxonName, TaxonAcceptedName WHERE TaxonName.NameId = TaxonAcceptedName.NameId AND TaxonAcceptedName.IgnoreButKeepForReference = 0 " );
            
        select.append( appendSelectionWhere( "genusOrSupragenericName", gen ) );
        select.append( appendSelectionWhere( "speciesEpithet", 			spe ) );
        select.append( appendSelectionWhere( "infraspecificEpithet", 	epi ) );
        select.append( appendSelectionWhere( "publishingAuthors", 		pub ) );
        select.append( appendSelectionWhere( "basionymAuthors", 		bas ) );
        select.append( appendSelectionWhere( "combiningAuthors", 		com ) );
        select.append( appendSelectionWhere( "originalOrthography", 	oro ) );
        select.append( appendSelectionWhere( "anamorphTeleomorph", 		ana ) );
        select.append( appendSelectionWhere( "typistNotes", 			tno ) );
        // ComboBoxes
        select.append( appendSelectionWhere( "TaxonomicRank ", 			rsl ) );
        select.append( appendSelectionWhere( "SanctioningAuthor",		san ) );
        select.append( appendSelectionWhere( "infragenericEpithet", 	igr ) );
        
        // select.append( appendSelectionWhere( , ) );
        /*        	
    	"nonNomenclaturalNameSuffix " 	+ "LIKE '%' AND " +
    	"isHybrid " 					+ "LIKE '%' ";
*/        	
            
        select.append( " ORDER BY taxonNameCache " );
        	javax.swing.DefaultListModel lm = new javax.swing.DefaultListModel();
        	javax.swing.JList sel = new javax.swing.JList( lm );
        	javax.swing.JScrollPane sp = new javax.swing.JScrollPane( sel );
        
            logger.info( select.toString() );
            try
            {
                java.sql.Statement stm = namesConnection.createStatement();
                ResultSet res = stm.executeQuery( select.toString() );
                while( res.next() )
                {	
                    lm.addElement( new TaxonNameSelectEntry( res.getInt( "NameID" ), res.getString( "taxonNameCache" ) ) );
                    
                    logger.debug( res.getString( "NameID" ) + " " + res.getString( "taxonNameCache" ) );
/*                    
                //    jTextFieldGenusOfSpecies;
*/                    
/*                   
                    jCheckBox1.setSelected( res.getBoolean( "isHybrid" ) );
*/                    
                }
            }
            catch( SQLException ex )
            {
                logger.error( ex.getMessage(), ex.fillInStackTrace() );
            }
            int button = javax.swing.JOptionPane.showConfirmDialog( null, sp, "Select TaxonNameID: ", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE );
            
            if( button == JOptionPane.OK_OPTION )
            {
                logger.info( "Select: " + sel.getSelectedValue());
                return (TaxonNameSelectEntry) sel.getSelectedValue();
            }
            else
            {
                return null;
            }
        
    }
    //---------------------------------------------------------------------------
    //---------------------------------------------------------------------------
    String appendSelectionWhere( String fieldName, String selection )
    {
        String sel = selection.replace( '*', '%' ).trim();
        String ret = "";
        
        if( sel.length() == 0 )
        {
            return ret;
        }
        else
        {
            
            if( flagAppendSelectionWhereAnd )
            {
                ret += " AND ";
            }
            ret += fieldName + " LIKE '" + sel + "' ";
            flagAppendSelectionWhereAnd = true;
        }
        return ret;
    }  
    //---------------------------------------------------------------------------
    // Show data for a given NameID
    //---------------------------------------------------------------------------    
//    public void showData( int nameId, java.sql.Connection con )
    public void showData( int nameId ) throws SQLException
    {
        /*
        private Integer nameId;
        private String taxonNameCache;
        private String genusOrSupragenericName;
        private String infragenericEpithet;
        private String speciesEpithet;
        private String infraspecificEpithet;
        private String basionymAuthors;
        private String combiningAuthors;
        private String publishingAuthors;
        private String sanctioningAuthor;
        private String nonNomenclaturalNameSuffix;
        private Boolean isHybrid;
        private String referenceTitle;
        private Integer referenceId;
        private String volume;
        private String issue;
        private String page;
        private Short yearOfPubl;
        private Short yearOnPubl;
        private String indexingReference;
        private String originalOrthography;
        private String nomenclaturalStatus;
        private String nomenclaturalComment;
        private String typification;
        private String typificationDetails;
        private String typeSpecimenSubstrate;
        private String typeSpecimenLocality;
        private String typificationReferenceTitle;
        private Integer typificationReferenceId;
        private String typificationNotes;
        private String anamorphTeleomorph;
        private String typistNotes;
        private Boolean ignoreButKeepForReference;
        private String logInsertedBy;
        private Date logInsertedWhen;
        private String logUpdatedBy;
        private Date logUpdatedWhen;
        private Short ok;
        private Integer fungiNameId;

        private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum taxonNameNomenclaturalCodeEnum;
        private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum taxonNameNomenclaturalStatusEnum;
        private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameCreationTypeEnum taxonNameCreationTypeEnum;
        private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameTaxonomicRankEnum taxonNameTaxonomicRankEnum;
        private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId4;
        private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId3;
        private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByBasedOnNameId;
        private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameBySpeciesGenusNameId;
        private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId2;
        private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId1;
        private Set taxonNamesByHybridNameId4;
        private Set taxonNamesByHybridNameId3;
        private Set taxonNamesByBasedOnNameId;
        private Set taxonNamesBySpeciesGenusNameId;
        private Set taxonNamesByHybridNameId2;
        private Set taxonNamesByHybridNameId1;
        private Set taxonNameExternalIds;
        private Set taxonHierarchies;
        private Set taxonAcceptedNames;
        private Set taxonSynonymiesByNameId;
        private Set taxonSynonymiesBySynNameId;
        */
        String select = 
        "SELECT " +
        "taxonNameCache, " +
        "genusOrSupragenericName, " +
//        "genusOfSpecies, " +
        "speciesGenusNameId, " +
        "infragenericEpithet, " +
        "speciesEpithet, " +
        "infraspecificEpithet, " +
        "basionymAuthors, " +
        "combiningAuthors, " +
        "publishingAuthors, " +
        "sanctioningAuthor, " +
        "typistNotes, " +
        "anamorphTeleomorph, " +
        "nonNomenclaturalNameSuffix, " +
        "originalOrthography, " +
        "TaxonomicRank, " +
        "isHybrid " +
        " FROM TaxonName " +
        " WHERE NameId = " + nameId;
    
        logger.info( select );
        try
        {
            java.sql.Statement stm = namesConnection.createStatement();
            ResultSet res = stm.executeQuery( select );
            if( res != null )
            {
                res.next();
                jTextAreaTypistNotes.setText( res.getString("typistNotes" ) );
                jTextFieldAnaTeleomorth.setText( res.getString( "anamorphTeleomorph" ) );
                jTextFieldBasionym.setText( res.getString( "basionymAuthors" ));
                jTextFieldCombining.setText( res.getString( "combiningAuthors" ));
                jTextFieldGenOrSupragenName.setText( res.getString( "genusOrSupragenericName" ) );
//                jTextFieldGenusOfSpecies.setText( res.getString( "genusOfSpecies") );
                jTextFieldGenusOfSpecies.setText( res.getString( "speciesGenusNameId") );
                jTextFieldInfraspecificEpithet.setText( res.getString( "infraspecificEpithet" ) );
                jTextFieldOriginalOrthography.setText( res.getString( "originalOrthography" ) );
                jTextFieldPublishing.setText( res.getString( "publishingAuthors" ) );
                jTextFieldSpeciesEpithet.setText( res.getString( "speciesEpithet" ) );
                
                
                
                DefaultComboBoxModel infragenericEpithet = new DefaultComboBoxModel( );
                infragenericEpithet.addElement( res.getString( "infragenericEpithet" ) );
                jComboBoxInfragenericEpithet.setModel( infragenericEpithet );
                
                DefaultComboBoxModel rank = new DefaultComboBoxModel( );
                rank.addElement( res.getString( "TaxonomicRank" ) );                                
                jComboBoxTaxonomicRank.setModel( rank );
                
                DefaultComboBoxModel sa = new DefaultComboBoxModel( );
                sa.addElement( res.getString( "sanctioningAuthor" ) );                                
                jComboBoxSa.setModel( sa );

                jCheckBox1.setSelected( res.getBoolean( "isHybrid" ) );
                
            }
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
    }
    
    
}
