/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import java.sql.Blob;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="dtproperties"
 *     
*/
public class Dtproperty implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3256445802431131699L;

    /** identifier field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.DtpropertyPK comp_id;

    /** nullable persistent field */
    private Integer objectid;

    /** nullable persistent field */
    private String value;

    /** nullable persistent field */
    private String uvalue;

    /** nullable persistent field */
    private Blob lvalue;

    /** persistent field */
    private int version;

    /** full constructor */
    public Dtproperty(net.metadiversity.diversity.navigator.hibernate.bsm.DtpropertyPK comp_id, Integer objectid, String value, String uvalue, Blob lvalue, int version) {
        this.comp_id = comp_id;
        this.objectid = objectid;
        this.value = value;
        this.uvalue = uvalue;
        this.lvalue = lvalue;
        this.version = version;
    }

    /** default constructor */
    public Dtproperty() {
    }

    /** minimal constructor */
    public Dtproperty(net.metadiversity.diversity.navigator.hibernate.bsm.DtpropertyPK comp_id, int version) {
        this.comp_id = comp_id;
        this.version = version;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.DtpropertyPK getComp_id() {
        return this.comp_id;
    }

    public void setComp_id(net.metadiversity.diversity.navigator.hibernate.bsm.DtpropertyPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.property
     *             column="objectid"
     *             length="10"
     *         
     */
    public Integer getObjectid() {
        return this.objectid;
    }

    public void setObjectid(Integer objectid) {
        this.objectid = objectid;
    }

    /** 
     *            @hibernate.property
     *             column="value"
     *             length="255"
     *         
     */
    public String getValue() {
        return this.value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    /** 
     *            @hibernate.property
     *             column="uvalue"
     *             length="255"
     *         
     */
    public String getUvalue() {
        return this.uvalue;
    }

    public void setUvalue(String uvalue) {
        this.uvalue = uvalue;
    }

    /** 
     *            @hibernate.property
     *             column="lvalue"
     *             length="2147483647"
     *         
     */
    public Blob getLvalue() {
        return this.lvalue;
    }

    public void setLvalue(Blob lvalue) {
        this.lvalue = lvalue;
    }

    /** 
     *            @hibernate.property
     *             column="version"
     *             length="10"
     *             not-null="true"
     *         
     */
    public int getVersion() {
        return this.version;
    }

    public void setVersion(int version) {
        this.version = version;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("comp_id", getComp_id())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof Dtproperty) ) return false;
        Dtproperty castOther = (Dtproperty) other;
        return new EqualsBuilder()
            .append(this.getComp_id(), castOther.getComp_id())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getComp_id())
            .toHashCode();
    }

}
