/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="_LiasMainNeueNamen"
 *     
*/
public class LiasMainNeueNamen implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257846567292579892L;

    /** identifier field */
    private Integer id;

    /** nullable persistent field */
    private String organismName;

    /** nullable persistent field */
    private String taxonomicRank;

    /** nullable persistent field */
    private String genusOrSupragenericName;

    /** nullable persistent field */
    private String speciesEpithet;

    /** nullable persistent field */
    private String infraspecificEpithet;

    /** nullable persistent field */
    private String basionymAuthors;

    /** nullable persistent field */
    private String combiningAuthors;

    /** nullable persistent field */
    private String publishingAuthors;

    /** nullable persistent field */
    private String sanctioningAuthor;

    /** nullable persistent field */
    private String isLichen;

    /** nullable persistent field */
    private String isFungus;

    /** nullable persistent field */
    private Integer nameId;

    /** nullable persistent field */
    private String itemName;

    /** nullable persistent field */
    private Byte schonDa;

    /** nullable persistent field */
    private Byte ok;

    /** nullable persistent field */
    private String taxonNameCache;

    /** full constructor */
    public LiasMainNeueNamen(Integer id, String organismName, String taxonomicRank, String genusOrSupragenericName, String speciesEpithet, String infraspecificEpithet, String basionymAuthors, String combiningAuthors, String publishingAuthors, String sanctioningAuthor, String isLichen, String isFungus, Integer nameId, String itemName, Byte schonDa, Byte ok, String taxonNameCache) {
        this.id = id;
        this.organismName = organismName;
        this.taxonomicRank = taxonomicRank;
        this.genusOrSupragenericName = genusOrSupragenericName;
        this.speciesEpithet = speciesEpithet;
        this.infraspecificEpithet = infraspecificEpithet;
        this.basionymAuthors = basionymAuthors;
        this.combiningAuthors = combiningAuthors;
        this.publishingAuthors = publishingAuthors;
        this.sanctioningAuthor = sanctioningAuthor;
        this.isLichen = isLichen;
        this.isFungus = isFungus;
        this.nameId = nameId;
        this.itemName = itemName;
        this.schonDa = schonDa;
        this.ok = ok;
        this.taxonNameCache = taxonNameCache;
    }

    /** default constructor */
    public LiasMainNeueNamen() {
    }

    /** minimal constructor */
    public LiasMainNeueNamen(Integer id) {
        this.id = id;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *             type="java.lang.Integer"
     *             column="ID"
     *         
     */
    public Integer getId() {
        return this.id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    /** 
     *            @hibernate.property
     *             column="OrganismName"
     *             length="255"
     *         
     */
    public String getOrganismName() {
        return this.organismName;
    }

    public void setOrganismName(String organismName) {
        this.organismName = organismName;
    }

    /** 
     *            @hibernate.property
     *             column="TaxonomicRank"
     *             length="50"
     *         
     */
    public String getTaxonomicRank() {
        return this.taxonomicRank;
    }

    public void setTaxonomicRank(String taxonomicRank) {
        this.taxonomicRank = taxonomicRank;
    }

    /** 
     *            @hibernate.property
     *             column="GenusOrSupragenericName"
     *             length="200"
     *         
     */
    public String getGenusOrSupragenericName() {
        return this.genusOrSupragenericName;
    }

    public void setGenusOrSupragenericName(String genusOrSupragenericName) {
        this.genusOrSupragenericName = genusOrSupragenericName;
    }

    /** 
     *            @hibernate.property
     *             column="SpeciesEpithet"
     *             length="255"
     *         
     */
    public String getSpeciesEpithet() {
        return this.speciesEpithet;
    }

    public void setSpeciesEpithet(String speciesEpithet) {
        this.speciesEpithet = speciesEpithet;
    }

    /** 
     *            @hibernate.property
     *             column="InfraspecificEpithet"
     *             length="255"
     *         
     */
    public String getInfraspecificEpithet() {
        return this.infraspecificEpithet;
    }

    public void setInfraspecificEpithet(String infraspecificEpithet) {
        this.infraspecificEpithet = infraspecificEpithet;
    }

    /** 
     *            @hibernate.property
     *             column="BasionymAuthors"
     *             length="255"
     *         
     */
    public String getBasionymAuthors() {
        return this.basionymAuthors;
    }

    public void setBasionymAuthors(String basionymAuthors) {
        this.basionymAuthors = basionymAuthors;
    }

    /** 
     *            @hibernate.property
     *             column="CombiningAuthors"
     *             length="255"
     *         
     */
    public String getCombiningAuthors() {
        return this.combiningAuthors;
    }

    public void setCombiningAuthors(String combiningAuthors) {
        this.combiningAuthors = combiningAuthors;
    }

    /** 
     *            @hibernate.property
     *             column="PublishingAuthors"
     *             length="255"
     *         
     */
    public String getPublishingAuthors() {
        return this.publishingAuthors;
    }

    public void setPublishingAuthors(String publishingAuthors) {
        this.publishingAuthors = publishingAuthors;
    }

    /** 
     *            @hibernate.property
     *             column="SanctioningAuthor"
     *             length="255"
     *         
     */
    public String getSanctioningAuthor() {
        return this.sanctioningAuthor;
    }

    public void setSanctioningAuthor(String sanctioningAuthor) {
        this.sanctioningAuthor = sanctioningAuthor;
    }

    /** 
     *            @hibernate.property
     *             column="IsLichen"
     *             length="2"
     *         
     */
    public String getIsLichen() {
        return this.isLichen;
    }

    public void setIsLichen(String isLichen) {
        this.isLichen = isLichen;
    }

    /** 
     *            @hibernate.property
     *             column="IsFungus"
     *             length="2"
     *         
     */
    public String getIsFungus() {
        return this.isFungus;
    }

    public void setIsFungus(String isFungus) {
        this.isFungus = isFungus;
    }

    /** 
     *            @hibernate.property
     *             column="NameID"
     *             length="10"
     *         
     */
    public Integer getNameId() {
        return this.nameId;
    }

    public void setNameId(Integer nameId) {
        this.nameId = nameId;
    }

    /** 
     *            @hibernate.property
     *             column="ItemName"
     *             length="255"
     *         
     */
    public String getItemName() {
        return this.itemName;
    }

    public void setItemName(String itemName) {
        this.itemName = itemName;
    }

    /** 
     *            @hibernate.property
     *             column="SchonDa"
     *             length="3"
     *         
     */
    public Byte getSchonDa() {
        return this.schonDa;
    }

    public void setSchonDa(Byte schonDa) {
        this.schonDa = schonDa;
    }

    /** 
     *            @hibernate.property
     *             column="OK"
     *             length="3"
     *         
     */
    public Byte getOk() {
        return this.ok;
    }

    public void setOk(Byte ok) {
        this.ok = ok;
    }

    /** 
     *            @hibernate.property
     *             column="TaxonNameCache"
     *             length="200"
     *         
     */
    public String getTaxonNameCache() {
        return this.taxonNameCache;
    }

    public void setTaxonNameCache(String taxonNameCache) {
        this.taxonNameCache = taxonNameCache;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("id", getId())
            .toString();
    }

}
