/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="TaxonNameExternalID"
 *     
*/
public class TaxonNameExternalId implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3258416148675508528L;

    /** identifier field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameExternalIdPK comp_id;

    /** nullable persistent field */
    private String externalNameId;

    /** nullable persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameExternalDatabase taxonNameExternalDatabase;

    /** nullable persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonName;

    /** full constructor */
    public TaxonNameExternalId(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameExternalIdPK comp_id, String externalNameId, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameExternalDatabase taxonNameExternalDatabase, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonName) {
        this.comp_id = comp_id;
        this.externalNameId = externalNameId;
        this.taxonNameExternalDatabase = taxonNameExternalDatabase;
        this.taxonName = taxonName;
    }

    /** default constructor */
    public TaxonNameExternalId() {
    }

    /** minimal constructor */
    public TaxonNameExternalId(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameExternalIdPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameExternalIdPK getComp_id() {
        return this.comp_id;
    }

    public void setComp_id(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameExternalIdPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.property
     *             column="ExternalNameID"
     *             length="50"
     *         
     */
    public String getExternalNameId() {
        return this.externalNameId;
    }

    public void setExternalNameId(String externalNameId) {
        this.externalNameId = externalNameId;
    }

    /** 
     *            @hibernate.many-to-one
     *             update="false"
     *             insert="false"
     *         
     *            @hibernate.column
     *             name="ExternalDatabaseID"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameExternalDatabase getTaxonNameExternalDatabase() {
        return this.taxonNameExternalDatabase;
    }

    public void setTaxonNameExternalDatabase(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameExternalDatabase taxonNameExternalDatabase) {
        this.taxonNameExternalDatabase = taxonNameExternalDatabase;
    }

    /** 
     *            @hibernate.many-to-one
     *             update="false"
     *             insert="false"
     *         
     *            @hibernate.column
     *             name="NameID"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName getTaxonName() {
        return this.taxonName;
    }

    public void setTaxonName(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonName) {
        this.taxonName = taxonName;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("comp_id", getComp_id())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof TaxonNameExternalId) ) return false;
        TaxonNameExternalId castOther = (TaxonNameExternalId) other;
        return new EqualsBuilder()
            .append(this.getComp_id(), castOther.getComp_id())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getComp_id())
            .toHashCode();
    }

}
