/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import java.util.Date;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="TaxonName_Log"
 *     
*/
public class TaxonNameLog implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 4050200830152292152L;

    /** identifier field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameLogPK comp_id;

    /** nullable persistent field */
    private String taxonNameCache;

    /** nullable persistent field */
    private Integer basedOnNameId;

    /** nullable persistent field */
    private String creationType;

    /** nullable persistent field */
    private String taxonomicRank;

    /** nullable persistent field */
    private String genusOrSupragenericName;

    /** nullable persistent field */
    private Integer speciesGenusNameId;

    /** nullable persistent field */
    private String infragenericEpithet;

    /** nullable persistent field */
    private String speciesEpithet;

    /** nullable persistent field */
    private String infraspecificEpithet;

    /** nullable persistent field */
    private String basionymAuthors;

    /** nullable persistent field */
    private String combiningAuthors;

    /** nullable persistent field */
    private String publishingAuthors;

    /** nullable persistent field */
    private String sanctioningAuthor;

    /** nullable persistent field */
    private String nonNomenclaturalNameSuffix;

    /** nullable persistent field */
    private Boolean isHybrid;

    /** nullable persistent field */
    private Integer hybridNameId1;

    /** nullable persistent field */
    private Integer hybridNameId2;

    /** nullable persistent field */
    private Integer hybridNameId3;

    /** nullable persistent field */
    private Integer hybridNameId4;

    /** nullable persistent field */
    private String referenceTitle;

    /** nullable persistent field */
    private Integer referenceId;

    /** nullable persistent field */
    private String volume;

    /** nullable persistent field */
    private String issue;

    /** nullable persistent field */
    private String page;

    /** nullable persistent field */
    private Short yearOfPubl;

    /** nullable persistent field */
    private Short yearOnPubl;

    /** nullable persistent field */
    private String indexingReference;

    /** nullable persistent field */
    private String originalOrthography;

    /** nullable persistent field */
    private Byte nomenclaturalCode;

    /** nullable persistent field */
    private String nomenclaturalStatus;

    /** nullable persistent field */
    private String nomenclaturalComment;

    /** nullable persistent field */
    private String typification;

    /** nullable persistent field */
    private String typificationDetails;

    /** nullable persistent field */
    private String typeSpecimenSubstrate;

    /** nullable persistent field */
    private String typeSpecimenLocality;

    /** nullable persistent field */
    private String typificationReferenceTitle;

    /** nullable persistent field */
    private Integer typificationReferenceId;

    /** nullable persistent field */
    private String typificationNotes;

    /** nullable persistent field */
    private String anamorphTeleomorph;

    /** nullable persistent field */
    private String typistNotes;

    /** nullable persistent field */
    private Boolean ignoreButKeepForReference;

    /** nullable persistent field */
    private String logInsertedBy;

    /** nullable persistent field */
    private Date logInsertedWhen;

    /** nullable persistent field */
    private String logUpdatedBy;

    /** nullable persistent field */
    private Date logUpdatedWhen;

    /** nullable persistent field */
    private String logState;

    /** nullable persistent field */
    private String logUser;

    /** full constructor */
    public TaxonNameLog(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameLogPK comp_id, String taxonNameCache, Integer basedOnNameId, String creationType, String taxonomicRank, String genusOrSupragenericName, Integer speciesGenusNameId, String infragenericEpithet, String speciesEpithet, String infraspecificEpithet, String basionymAuthors, String combiningAuthors, String publishingAuthors, String sanctioningAuthor, String nonNomenclaturalNameSuffix, Boolean isHybrid, Integer hybridNameId1, Integer hybridNameId2, Integer hybridNameId3, Integer hybridNameId4, String referenceTitle, Integer referenceId, String volume, String issue, String page, Short yearOfPubl, Short yearOnPubl, String indexingReference, String originalOrthography, Byte nomenclaturalCode, String nomenclaturalStatus, String nomenclaturalComment, String typification, String typificationDetails, String typeSpecimenSubstrate, String typeSpecimenLocality, String typificationReferenceTitle, Integer typificationReferenceId, String typificationNotes, String anamorphTeleomorph, String typistNotes, Boolean ignoreButKeepForReference, String logInsertedBy, Date logInsertedWhen, String logUpdatedBy, Date logUpdatedWhen, String logState, String logUser) {
        this.comp_id = comp_id;
        this.taxonNameCache = taxonNameCache;
        this.basedOnNameId = basedOnNameId;
        this.creationType = creationType;
        this.taxonomicRank = taxonomicRank;
        this.genusOrSupragenericName = genusOrSupragenericName;
        this.speciesGenusNameId = speciesGenusNameId;
        this.infragenericEpithet = infragenericEpithet;
        this.speciesEpithet = speciesEpithet;
        this.infraspecificEpithet = infraspecificEpithet;
        this.basionymAuthors = basionymAuthors;
        this.combiningAuthors = combiningAuthors;
        this.publishingAuthors = publishingAuthors;
        this.sanctioningAuthor = sanctioningAuthor;
        this.nonNomenclaturalNameSuffix = nonNomenclaturalNameSuffix;
        this.isHybrid = isHybrid;
        this.hybridNameId1 = hybridNameId1;
        this.hybridNameId2 = hybridNameId2;
        this.hybridNameId3 = hybridNameId3;
        this.hybridNameId4 = hybridNameId4;
        this.referenceTitle = referenceTitle;
        this.referenceId = referenceId;
        this.volume = volume;
        this.issue = issue;
        this.page = page;
        this.yearOfPubl = yearOfPubl;
        this.yearOnPubl = yearOnPubl;
        this.indexingReference = indexingReference;
        this.originalOrthography = originalOrthography;
        this.nomenclaturalCode = nomenclaturalCode;
        this.nomenclaturalStatus = nomenclaturalStatus;
        this.nomenclaturalComment = nomenclaturalComment;
        this.typification = typification;
        this.typificationDetails = typificationDetails;
        this.typeSpecimenSubstrate = typeSpecimenSubstrate;
        this.typeSpecimenLocality = typeSpecimenLocality;
        this.typificationReferenceTitle = typificationReferenceTitle;
        this.typificationReferenceId = typificationReferenceId;
        this.typificationNotes = typificationNotes;
        this.anamorphTeleomorph = anamorphTeleomorph;
        this.typistNotes = typistNotes;
        this.ignoreButKeepForReference = ignoreButKeepForReference;
        this.logInsertedBy = logInsertedBy;
        this.logInsertedWhen = logInsertedWhen;
        this.logUpdatedBy = logUpdatedBy;
        this.logUpdatedWhen = logUpdatedWhen;
        this.logState = logState;
        this.logUser = logUser;
    }

    /** default constructor */
    public TaxonNameLog() {
    }

    /** minimal constructor */
    public TaxonNameLog(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameLogPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameLogPK getComp_id() {
        return this.comp_id;
    }

    public void setComp_id(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameLogPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.property
     *             column="TaxonNameCache"
     *             length="200"
     *         
     */
    public String getTaxonNameCache() {
        return this.taxonNameCache;
    }

    public void setTaxonNameCache(String taxonNameCache) {
        this.taxonNameCache = taxonNameCache;
    }

    /** 
     *            @hibernate.property
     *             column="BasedOnNameID"
     *             length="10"
     *         
     */
    public Integer getBasedOnNameId() {
        return this.basedOnNameId;
    }

    public void setBasedOnNameId(Integer basedOnNameId) {
        this.basedOnNameId = basedOnNameId;
    }

    /** 
     *            @hibernate.property
     *             column="CreationType"
     *             length="50"
     *         
     */
    public String getCreationType() {
        return this.creationType;
    }

    public void setCreationType(String creationType) {
        this.creationType = creationType;
    }

    /** 
     *            @hibernate.property
     *             column="TaxonomicRank"
     *             length="50"
     *         
     */
    public String getTaxonomicRank() {
        return this.taxonomicRank;
    }

    public void setTaxonomicRank(String taxonomicRank) {
        this.taxonomicRank = taxonomicRank;
    }

    /** 
     *            @hibernate.property
     *             column="GenusOrSupragenericName"
     *             length="200"
     *         
     */
    public String getGenusOrSupragenericName() {
        return this.genusOrSupragenericName;
    }

    public void setGenusOrSupragenericName(String genusOrSupragenericName) {
        this.genusOrSupragenericName = genusOrSupragenericName;
    }

    /** 
     *            @hibernate.property
     *             column="SpeciesGenusNameID"
     *             length="10"
     *         
     */
    public Integer getSpeciesGenusNameId() {
        return this.speciesGenusNameId;
    }

    public void setSpeciesGenusNameId(Integer speciesGenusNameId) {
        this.speciesGenusNameId = speciesGenusNameId;
    }

    /** 
     *            @hibernate.property
     *             column="InfragenericEpithet"
     *             length="200"
     *         
     */
    public String getInfragenericEpithet() {
        return this.infragenericEpithet;
    }

    public void setInfragenericEpithet(String infragenericEpithet) {
        this.infragenericEpithet = infragenericEpithet;
    }

    /** 
     *            @hibernate.property
     *             column="SpeciesEpithet"
     *             length="100"
     *         
     */
    public String getSpeciesEpithet() {
        return this.speciesEpithet;
    }

    public void setSpeciesEpithet(String speciesEpithet) {
        this.speciesEpithet = speciesEpithet;
    }

    /** 
     *            @hibernate.property
     *             column="InfraspecificEpithet"
     *             length="100"
     *         
     */
    public String getInfraspecificEpithet() {
        return this.infraspecificEpithet;
    }

    public void setInfraspecificEpithet(String infraspecificEpithet) {
        this.infraspecificEpithet = infraspecificEpithet;
    }

    /** 
     *            @hibernate.property
     *             column="BasionymAuthors"
     *             length="100"
     *         
     */
    public String getBasionymAuthors() {
        return this.basionymAuthors;
    }

    public void setBasionymAuthors(String basionymAuthors) {
        this.basionymAuthors = basionymAuthors;
    }

    /** 
     *            @hibernate.property
     *             column="CombiningAuthors"
     *             length="255"
     *         
     */
    public String getCombiningAuthors() {
        return this.combiningAuthors;
    }

    public void setCombiningAuthors(String combiningAuthors) {
        this.combiningAuthors = combiningAuthors;
    }

    /** 
     *            @hibernate.property
     *             column="PublishingAuthors"
     *             length="255"
     *         
     */
    public String getPublishingAuthors() {
        return this.publishingAuthors;
    }

    public void setPublishingAuthors(String publishingAuthors) {
        this.publishingAuthors = publishingAuthors;
    }

    /** 
     *            @hibernate.property
     *             column="SanctioningAuthor"
     *             length="100"
     *         
     */
    public String getSanctioningAuthor() {
        return this.sanctioningAuthor;
    }

    public void setSanctioningAuthor(String sanctioningAuthor) {
        this.sanctioningAuthor = sanctioningAuthor;
    }

    /** 
     *            @hibernate.property
     *             column="NonNomenclaturalNameSuffix"
     *             length="200"
     *         
     */
    public String getNonNomenclaturalNameSuffix() {
        return this.nonNomenclaturalNameSuffix;
    }

    public void setNonNomenclaturalNameSuffix(String nonNomenclaturalNameSuffix) {
        this.nonNomenclaturalNameSuffix = nonNomenclaturalNameSuffix;
    }

    /** 
     *            @hibernate.property
     *             column="IsHybrid"
     *             length="1"
     *         
     */
    public Boolean getIsHybrid() {
        return this.isHybrid;
    }

    public void setIsHybrid(Boolean isHybrid) {
        this.isHybrid = isHybrid;
    }

    /** 
     *            @hibernate.property
     *             column="HybridNameID1"
     *             length="10"
     *         
     */
    public Integer getHybridNameId1() {
        return this.hybridNameId1;
    }

    public void setHybridNameId1(Integer hybridNameId1) {
        this.hybridNameId1 = hybridNameId1;
    }

    /** 
     *            @hibernate.property
     *             column="HybridNameID2"
     *             length="10"
     *         
     */
    public Integer getHybridNameId2() {
        return this.hybridNameId2;
    }

    public void setHybridNameId2(Integer hybridNameId2) {
        this.hybridNameId2 = hybridNameId2;
    }

    /** 
     *            @hibernate.property
     *             column="HybridNameID3"
     *             length="10"
     *         
     */
    public Integer getHybridNameId3() {
        return this.hybridNameId3;
    }

    public void setHybridNameId3(Integer hybridNameId3) {
        this.hybridNameId3 = hybridNameId3;
    }

    /** 
     *            @hibernate.property
     *             column="HybridNameID4"
     *             length="10"
     *         
     */
    public Integer getHybridNameId4() {
        return this.hybridNameId4;
    }

    public void setHybridNameId4(Integer hybridNameId4) {
        this.hybridNameId4 = hybridNameId4;
    }

    /** 
     *            @hibernate.property
     *             column="ReferenceTitle"
     *             length="255"
     *         
     */
    public String getReferenceTitle() {
        return this.referenceTitle;
    }

    public void setReferenceTitle(String referenceTitle) {
        this.referenceTitle = referenceTitle;
    }

    /** 
     *            @hibernate.property
     *             column="ReferenceID"
     *             length="10"
     *         
     */
    public Integer getReferenceId() {
        return this.referenceId;
    }

    public void setReferenceId(Integer referenceId) {
        this.referenceId = referenceId;
    }

    /** 
     *            @hibernate.property
     *             column="Volume"
     *             length="20"
     *         
     */
    public String getVolume() {
        return this.volume;
    }

    public void setVolume(String volume) {
        this.volume = volume;
    }

    /** 
     *            @hibernate.property
     *             column="Issue"
     *             length="255"
     *         
     */
    public String getIssue() {
        return this.issue;
    }

    public void setIssue(String issue) {
        this.issue = issue;
    }

    /** 
     *            @hibernate.property
     *             column="Page"
     *             length="10"
     *         
     */
    public String getPage() {
        return this.page;
    }

    public void setPage(String page) {
        this.page = page;
    }

    /** 
     *            @hibernate.property
     *             column="YearOfPubl"
     *             length="5"
     *         
     */
    public Short getYearOfPubl() {
        return this.yearOfPubl;
    }

    public void setYearOfPubl(Short yearOfPubl) {
        this.yearOfPubl = yearOfPubl;
    }

    /** 
     *            @hibernate.property
     *             column="YearOnPubl"
     *             length="5"
     *         
     */
    public Short getYearOnPubl() {
        return this.yearOnPubl;
    }

    public void setYearOnPubl(Short yearOnPubl) {
        this.yearOnPubl = yearOnPubl;
    }

    /** 
     *            @hibernate.property
     *             column="IndexingReference"
     *             length="255"
     *         
     */
    public String getIndexingReference() {
        return this.indexingReference;
    }

    public void setIndexingReference(String indexingReference) {
        this.indexingReference = indexingReference;
    }

    /** 
     *            @hibernate.property
     *             column="OriginalOrthography"
     *             length="255"
     *         
     */
    public String getOriginalOrthography() {
        return this.originalOrthography;
    }

    public void setOriginalOrthography(String originalOrthography) {
        this.originalOrthography = originalOrthography;
    }

    /** 
     *            @hibernate.property
     *             column="NomenclaturalCode"
     *             length="3"
     *         
     */
    public Byte getNomenclaturalCode() {
        return this.nomenclaturalCode;
    }

    public void setNomenclaturalCode(Byte nomenclaturalCode) {
        this.nomenclaturalCode = nomenclaturalCode;
    }

    /** 
     *            @hibernate.property
     *             column="NomenclaturalStatus"
     *             length="50"
     *         
     */
    public String getNomenclaturalStatus() {
        return this.nomenclaturalStatus;
    }

    public void setNomenclaturalStatus(String nomenclaturalStatus) {
        this.nomenclaturalStatus = nomenclaturalStatus;
    }

    /** 
     *            @hibernate.property
     *             column="NomenclaturalComment"
     *             length="1000"
     *         
     */
    public String getNomenclaturalComment() {
        return this.nomenclaturalComment;
    }

    public void setNomenclaturalComment(String nomenclaturalComment) {
        this.nomenclaturalComment = nomenclaturalComment;
    }

    /** 
     *            @hibernate.property
     *             column="Typification"
     *             length="50"
     *         
     */
    public String getTypification() {
        return this.typification;
    }

    public void setTypification(String typification) {
        this.typification = typification;
    }

    /** 
     *            @hibernate.property
     *             column="TypificationDetails"
     *             length="255"
     *         
     */
    public String getTypificationDetails() {
        return this.typificationDetails;
    }

    public void setTypificationDetails(String typificationDetails) {
        this.typificationDetails = typificationDetails;
    }

    /** 
     *            @hibernate.property
     *             column="TypeSpecimenSubstrate"
     *             length="255"
     *         
     */
    public String getTypeSpecimenSubstrate() {
        return this.typeSpecimenSubstrate;
    }

    public void setTypeSpecimenSubstrate(String typeSpecimenSubstrate) {
        this.typeSpecimenSubstrate = typeSpecimenSubstrate;
    }

    /** 
     *            @hibernate.property
     *             column="TypeSpecimenLocality"
     *             length="255"
     *         
     */
    public String getTypeSpecimenLocality() {
        return this.typeSpecimenLocality;
    }

    public void setTypeSpecimenLocality(String typeSpecimenLocality) {
        this.typeSpecimenLocality = typeSpecimenLocality;
    }

    /** 
     *            @hibernate.property
     *             column="TypificationReferenceTitle"
     *             length="100"
     *         
     */
    public String getTypificationReferenceTitle() {
        return this.typificationReferenceTitle;
    }

    public void setTypificationReferenceTitle(String typificationReferenceTitle) {
        this.typificationReferenceTitle = typificationReferenceTitle;
    }

    /** 
     *            @hibernate.property
     *             column="TypificationReferenceID"
     *             length="10"
     *         
     */
    public Integer getTypificationReferenceId() {
        return this.typificationReferenceId;
    }

    public void setTypificationReferenceId(Integer typificationReferenceId) {
        this.typificationReferenceId = typificationReferenceId;
    }

    /** 
     *            @hibernate.property
     *             column="TypificationNotes"
     *             length="200"
     *         
     */
    public String getTypificationNotes() {
        return this.typificationNotes;
    }

    public void setTypificationNotes(String typificationNotes) {
        this.typificationNotes = typificationNotes;
    }

    /** 
     *            @hibernate.property
     *             column="AnamorphTeleomorph"
     *             length="255"
     *         
     */
    public String getAnamorphTeleomorph() {
        return this.anamorphTeleomorph;
    }

    public void setAnamorphTeleomorph(String anamorphTeleomorph) {
        this.anamorphTeleomorph = anamorphTeleomorph;
    }

    /** 
     *            @hibernate.property
     *             column="TypistNotes"
     *             length="200"
     *         
     */
    public String getTypistNotes() {
        return this.typistNotes;
    }

    public void setTypistNotes(String typistNotes) {
        this.typistNotes = typistNotes;
    }

    /** 
     *            @hibernate.property
     *             column="IgnoreButKeepForReference"
     *             length="1"
     *         
     */
    public Boolean getIgnoreButKeepForReference() {
        return this.ignoreButKeepForReference;
    }

    public void setIgnoreButKeepForReference(Boolean ignoreButKeepForReference) {
        this.ignoreButKeepForReference = ignoreButKeepForReference;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedBy"
     *             length="50"
     *         
     */
    public String getLogInsertedBy() {
        return this.logInsertedBy;
    }

    public void setLogInsertedBy(String logInsertedBy) {
        this.logInsertedBy = logInsertedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedWhen"
     *             length="16"
     *         
     */
    public Date getLogInsertedWhen() {
        return this.logInsertedWhen;
    }

    public void setLogInsertedWhen(Date logInsertedWhen) {
        this.logInsertedWhen = logInsertedWhen;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedBy"
     *             length="50"
     *         
     */
    public String getLogUpdatedBy() {
        return this.logUpdatedBy;
    }

    public void setLogUpdatedBy(String logUpdatedBy) {
        this.logUpdatedBy = logUpdatedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedWhen"
     *             length="16"
     *         
     */
    public Date getLogUpdatedWhen() {
        return this.logUpdatedWhen;
    }

    public void setLogUpdatedWhen(Date logUpdatedWhen) {
        this.logUpdatedWhen = logUpdatedWhen;
    }

    /** 
     *            @hibernate.property
     *             column="LogState"
     *             length="1"
     *         
     */
    public String getLogState() {
        return this.logState;
    }

    public void setLogState(String logState) {
        this.logState = logState;
    }

    /** 
     *            @hibernate.property
     *             column="LogUser"
     *             length="50"
     *         
     */
    public String getLogUser() {
        return this.logUser;
    }

    public void setLogUser(String logUser) {
        this.logUser = logUser;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("comp_id", getComp_id())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof TaxonNameLog) ) return false;
        TaxonNameLog castOther = (TaxonNameLog) other;
        return new EqualsBuilder()
            .append(this.getComp_id(), castOther.getComp_id())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getComp_id())
            .toHashCode();
    }

}
