/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import java.util.Set;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="TaxonNameNomenclaturalStatus_Enum"
 *     
*/
public class TaxonNameNomenclaturalStatusEnum implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3258689909991945013L;

    /** identifier field */
    private String code;

    /** nullable persistent field */
    private String description;

    /** nullable persistent field */
    private String displayText;

    /** nullable persistent field */
    private Short displayOrder;

    /** nullable persistent field */
    private Boolean displayEnable;

    /** nullable persistent field */
    private String internalNotes;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum taxonNameNomenclaturalStatusEnum;

    /** persistent field */
    private Set taxonNames;

    /** persistent field */
    private Set taxonNameNomenclaturalStatusEnums;

    /** full constructor */
    public TaxonNameNomenclaturalStatusEnum(String code, String description, String displayText, Short displayOrder, Boolean displayEnable, String internalNotes, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum taxonNameNomenclaturalStatusEnum, Set taxonNames, Set taxonNameNomenclaturalStatusEnums) {
        this.code = code;
        this.description = description;
        this.displayText = displayText;
        this.displayOrder = displayOrder;
        this.displayEnable = displayEnable;
        this.internalNotes = internalNotes;
        this.taxonNameNomenclaturalStatusEnum = taxonNameNomenclaturalStatusEnum;
        this.taxonNames = taxonNames;
        this.taxonNameNomenclaturalStatusEnums = taxonNameNomenclaturalStatusEnums;
    }

    /** default constructor */
    public TaxonNameNomenclaturalStatusEnum() {
    }

    /** minimal constructor */
    public TaxonNameNomenclaturalStatusEnum(String code, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum taxonNameNomenclaturalStatusEnum, Set taxonNames, Set taxonNameNomenclaturalStatusEnums) {
        this.code = code;
        this.taxonNameNomenclaturalStatusEnum = taxonNameNomenclaturalStatusEnum;
        this.taxonNames = taxonNames;
        this.taxonNameNomenclaturalStatusEnums = taxonNameNomenclaturalStatusEnums;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *             type="java.lang.String"
     *             column="Code"
     *         
     */
    public String getCode() {
        return this.code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    /** 
     *            @hibernate.property
     *             column="Description"
     *             length="500"
     *         
     */
    public String getDescription() {
        return this.description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    /** 
     *            @hibernate.property
     *             column="DisplayText"
     *             length="50"
     *         
     */
    public String getDisplayText() {
        return this.displayText;
    }

    public void setDisplayText(String displayText) {
        this.displayText = displayText;
    }

    /** 
     *            @hibernate.property
     *             column="DisplayOrder"
     *             length="5"
     *         
     */
    public Short getDisplayOrder() {
        return this.displayOrder;
    }

    public void setDisplayOrder(Short displayOrder) {
        this.displayOrder = displayOrder;
    }

    /** 
     *            @hibernate.property
     *             column="DisplayEnable"
     *             length="1"
     *         
     */
    public Boolean getDisplayEnable() {
        return this.displayEnable;
    }

    public void setDisplayEnable(Boolean displayEnable) {
        this.displayEnable = displayEnable;
    }

    /** 
     *            @hibernate.property
     *             column="InternalNotes"
     *             length="500"
     *         
     */
    public String getInternalNotes() {
        return this.internalNotes;
    }

    public void setInternalNotes(String internalNotes) {
        this.internalNotes = internalNotes;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="ParentCode"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum getTaxonNameNomenclaturalStatusEnum() {
        return this.taxonNameNomenclaturalStatusEnum;
    }

    public void setTaxonNameNomenclaturalStatusEnum(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum taxonNameNomenclaturalStatusEnum) {
        this.taxonNameNomenclaturalStatusEnum = taxonNameNomenclaturalStatusEnum;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="NomenclaturalCode"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName"
     *         
     */
    public Set getTaxonNames() {
        return this.taxonNames;
    }

    public void setTaxonNames(Set taxonNames) {
        this.taxonNames = taxonNames;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="ParentCode"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum"
     *         
     */
    public Set getTaxonNameNomenclaturalStatusEnums() {
        return this.taxonNameNomenclaturalStatusEnums;
    }

    public void setTaxonNameNomenclaturalStatusEnums(Set taxonNameNomenclaturalStatusEnums) {
        this.taxonNameNomenclaturalStatusEnums = taxonNameNomenclaturalStatusEnums;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("code", getCode())
            .toString();
    }

}
