/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import java.util.Date;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="TaxonSynonymy_Log"
 *     
*/
public class TaxonSynonymyLog implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3258130241426569267L;

    /** identifier field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonSynonymyLogPK comp_id;

    /** nullable persistent field */
    private String conceptSuffix;

    /** nullable persistent field */
    private String conceptNotes;

    /** nullable persistent field */
    private String synRefId;

    /** nullable persistent field */
    private String synRefText;

    /** nullable persistent field */
    private String synRefDetail;

    /** nullable persistent field */
    private String synTypistsNotes;

    /** nullable persistent field */
    private String synType;

    /** nullable persistent field */
    private Boolean synIsUncertain;

    /** nullable persistent field */
    private String logInsertedBy;

    /** nullable persistent field */
    private Date logInsertedWhen;

    /** nullable persistent field */
    private String logUpdatedBy;

    /** nullable persistent field */
    private Date logUpdatedWhen;

    /** nullable persistent field */
    private String logState;

    /** nullable persistent field */
    private String logUser;

    /** full constructor */
    public TaxonSynonymyLog(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonSynonymyLogPK comp_id, String conceptSuffix, String conceptNotes, String synRefId, String synRefText, String synRefDetail, String synTypistsNotes, String synType, Boolean synIsUncertain, String logInsertedBy, Date logInsertedWhen, String logUpdatedBy, Date logUpdatedWhen, String logState, String logUser) {
        this.comp_id = comp_id;
        this.conceptSuffix = conceptSuffix;
        this.conceptNotes = conceptNotes;
        this.synRefId = synRefId;
        this.synRefText = synRefText;
        this.synRefDetail = synRefDetail;
        this.synTypistsNotes = synTypistsNotes;
        this.synType = synType;
        this.synIsUncertain = synIsUncertain;
        this.logInsertedBy = logInsertedBy;
        this.logInsertedWhen = logInsertedWhen;
        this.logUpdatedBy = logUpdatedBy;
        this.logUpdatedWhen = logUpdatedWhen;
        this.logState = logState;
        this.logUser = logUser;
    }

    /** default constructor */
    public TaxonSynonymyLog() {
    }

    /** minimal constructor */
    public TaxonSynonymyLog(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonSynonymyLogPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonSynonymyLogPK getComp_id() {
        return this.comp_id;
    }

    public void setComp_id(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonSynonymyLogPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.property
     *             column="ConceptSuffix"
     *             length="200"
     *         
     */
    public String getConceptSuffix() {
        return this.conceptSuffix;
    }

    public void setConceptSuffix(String conceptSuffix) {
        this.conceptSuffix = conceptSuffix;
    }

    /** 
     *            @hibernate.property
     *             column="ConceptNotes"
     *             length="500"
     *         
     */
    public String getConceptNotes() {
        return this.conceptNotes;
    }

    public void setConceptNotes(String conceptNotes) {
        this.conceptNotes = conceptNotes;
    }

    /** 
     *            @hibernate.property
     *             column="SynRefID"
     *             length="20"
     *         
     */
    public String getSynRefId() {
        return this.synRefId;
    }

    public void setSynRefId(String synRefId) {
        this.synRefId = synRefId;
    }

    /** 
     *            @hibernate.property
     *             column="SynRefText"
     *             length="255"
     *         
     */
    public String getSynRefText() {
        return this.synRefText;
    }

    public void setSynRefText(String synRefText) {
        this.synRefText = synRefText;
    }

    /** 
     *            @hibernate.property
     *             column="SynRefDetail"
     *             length="255"
     *         
     */
    public String getSynRefDetail() {
        return this.synRefDetail;
    }

    public void setSynRefDetail(String synRefDetail) {
        this.synRefDetail = synRefDetail;
    }

    /** 
     *            @hibernate.property
     *             column="SynTypistsNotes"
     *             length="255"
     *         
     */
    public String getSynTypistsNotes() {
        return this.synTypistsNotes;
    }

    public void setSynTypistsNotes(String synTypistsNotes) {
        this.synTypistsNotes = synTypistsNotes;
    }

    /** 
     *            @hibernate.property
     *             column="SynType"
     *             length="50"
     *         
     */
    public String getSynType() {
        return this.synType;
    }

    public void setSynType(String synType) {
        this.synType = synType;
    }

    /** 
     *            @hibernate.property
     *             column="SynIsUncertain"
     *             length="1"
     *         
     */
    public Boolean getSynIsUncertain() {
        return this.synIsUncertain;
    }

    public void setSynIsUncertain(Boolean synIsUncertain) {
        this.synIsUncertain = synIsUncertain;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedBy"
     *             length="50"
     *         
     */
    public String getLogInsertedBy() {
        return this.logInsertedBy;
    }

    public void setLogInsertedBy(String logInsertedBy) {
        this.logInsertedBy = logInsertedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedWhen"
     *             length="16"
     *         
     */
    public Date getLogInsertedWhen() {
        return this.logInsertedWhen;
    }

    public void setLogInsertedWhen(Date logInsertedWhen) {
        this.logInsertedWhen = logInsertedWhen;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedBy"
     *             length="50"
     *         
     */
    public String getLogUpdatedBy() {
        return this.logUpdatedBy;
    }

    public void setLogUpdatedBy(String logUpdatedBy) {
        this.logUpdatedBy = logUpdatedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedWhen"
     *             length="16"
     *         
     */
    public Date getLogUpdatedWhen() {
        return this.logUpdatedWhen;
    }

    public void setLogUpdatedWhen(Date logUpdatedWhen) {
        this.logUpdatedWhen = logUpdatedWhen;
    }

    /** 
     *            @hibernate.property
     *             column="LogState"
     *             length="1"
     *         
     */
    public String getLogState() {
        return this.logState;
    }

    public void setLogState(String logState) {
        this.logState = logState;
    }

    /** 
     *            @hibernate.property
     *             column="LogUser"
     *             length="50"
     *         
     */
    public String getLogUser() {
        return this.logUser;
    }

    public void setLogUser(String logUser) {
        this.logUser = logUser;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("comp_id", getComp_id())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof TaxonSynonymyLog) ) return false;
        TaxonSynonymyLog castOther = (TaxonSynonymyLog) other;
        return new EqualsBuilder()
            .append(this.getComp_id(), castOther.getComp_id())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getComp_id())
            .toHashCode();
    }

}
