/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** @author Hibernate CodeGenerator */
public class TaxonSynonymyPK implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3258131375264642867L;

    /** identifier field */
    private String project;

    /** identifier field */
    private Integer nameId;

    /** identifier field */
    private Integer synNameId;

    /** identifier field */
    private Byte ignoreButKeepForReference;

    /** full constructor */
    public TaxonSynonymyPK(String project, Integer nameId, Integer synNameId, Byte ignoreButKeepForReference) {
        this.project = project;
        this.nameId = nameId;
        this.synNameId = synNameId;
        this.ignoreButKeepForReference = ignoreButKeepForReference;
    }

    /** default constructor */
    public TaxonSynonymyPK() {
    }

    /** 
     *                @hibernate.property
     *                 column="Project"
     *                 length="50"
     *             
     */
    public String getProject() {
        return this.project;
    }

    public void setProject(String project) {
        this.project = project;
    }

    /** 
     *                @hibernate.property
     *                 column="NameID"
     *                 length="10"
     *             
     */
    public Integer getNameId() {
        return this.nameId;
    }

    public void setNameId(Integer nameId) {
        this.nameId = nameId;
    }

    /** 
     *                @hibernate.property
     *                 column="SynNameID"
     *                 length="10"
     *             
     */
    public Integer getSynNameId() {
        return this.synNameId;
    }

    public void setSynNameId(Integer synNameId) {
        this.synNameId = synNameId;
    }

    /** 
     *                @hibernate.property
     *                 column="IgnoreButKeepForReference"
     *                 length="3"
     *             
     */
    public Byte getIgnoreButKeepForReference() {
        return this.ignoreButKeepForReference;
    }

    public void setIgnoreButKeepForReference(Byte ignoreButKeepForReference) {
        this.ignoreButKeepForReference = ignoreButKeepForReference;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("project", getProject())
            .append("nameId", getNameId())
            .append("synNameId", getSynNameId())
            .append("ignoreButKeepForReference", getIgnoreButKeepForReference())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof TaxonSynonymyPK) ) return false;
        TaxonSynonymyPK castOther = (TaxonSynonymyPK) other;
        return new EqualsBuilder()
            .append(this.getProject(), castOther.getProject())
            .append(this.getNameId(), castOther.getNameId())
            .append(this.getSynNameId(), castOther.getSynNameId())
            .append(this.getIgnoreButKeepForReference(), castOther.getIgnoreButKeepForReference())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getProject())
            .append(getNameId())
            .append(getSynNameId())
            .append(getIgnoreButKeepForReference())
            .toHashCode();
    }

}
