/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.ubt.collection;

import java.io.Serializable;
import java.util.Set;
import org.apache.commons.lang.builder.ToStringBuilder;


/** @author Hibernate CodeGenerator */
public class XcollDateCategoryEnum implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3761127158613030704L;

    /** identifier field */
    private String code;

    /** nullable persistent field */
    private String description;

    /** nullable persistent field */
    private String abbreviation;

    /** nullable persistent field */
    private String internalNotes;

    /** persistent field */
    private int displayOrder;

    /** persistent field */
    private boolean displayEnable;

    /** persistent field */
    private Set identifications;

    /** persistent field */
    private Set collectionSpecimensByCollectionDateCategory;

    /** persistent field */
    private Set collectionSpecimensByAccessionDateCategory;

    /** full constructor */
    public XcollDateCategoryEnum(String code, String description, String abbreviation, String internalNotes, int displayOrder, boolean displayEnable, Set identifications, Set collectionSpecimensByCollectionDateCategory, Set collectionSpecimensByAccessionDateCategory) {
        this.code = code;
        this.description = description;
        this.abbreviation = abbreviation;
        this.internalNotes = internalNotes;
        this.displayOrder = displayOrder;
        this.displayEnable = displayEnable;
        this.identifications = identifications;
        this.collectionSpecimensByCollectionDateCategory = collectionSpecimensByCollectionDateCategory;
        this.collectionSpecimensByAccessionDateCategory = collectionSpecimensByAccessionDateCategory;
    }

    /** default constructor */
    public XcollDateCategoryEnum() {
    }

    /** minimal constructor */
    public XcollDateCategoryEnum(String code, int displayOrder, boolean displayEnable, Set identifications, Set collectionSpecimensByCollectionDateCategory, Set collectionSpecimensByAccessionDateCategory) {
        this.code = code;
        this.displayOrder = displayOrder;
        this.displayEnable = displayEnable;
        this.identifications = identifications;
        this.collectionSpecimensByCollectionDateCategory = collectionSpecimensByCollectionDateCategory;
        this.collectionSpecimensByAccessionDateCategory = collectionSpecimensByAccessionDateCategory;
    }

    public String getCode() {
        return this.code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getDescription() {
        return this.description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getAbbreviation() {
        return this.abbreviation;
    }

    public void setAbbreviation(String abbreviation) {
        this.abbreviation = abbreviation;
    }

    public String getInternalNotes() {
        return this.internalNotes;
    }

    public void setInternalNotes(String internalNotes) {
        this.internalNotes = internalNotes;
    }

    public int getDisplayOrder() {
        return this.displayOrder;
    }

    public void setDisplayOrder(int displayOrder) {
        this.displayOrder = displayOrder;
    }

    public boolean isDisplayEnable() {
        return this.displayEnable;
    }

    public void setDisplayEnable(boolean displayEnable) {
        this.displayEnable = displayEnable;
    }

    public Set getIdentifications() {
        return this.identifications;
    }

    public void setIdentifications(Set identifications) {
        this.identifications = identifications;
    }

    public Set getCollectionSpecimensByCollectionDateCategory() {
        return this.collectionSpecimensByCollectionDateCategory;
    }

    public void setCollectionSpecimensByCollectionDateCategory(Set collectionSpecimensByCollectionDateCategory) {
        this.collectionSpecimensByCollectionDateCategory = collectionSpecimensByCollectionDateCategory;
    }

    public Set getCollectionSpecimensByAccessionDateCategory() {
        return this.collectionSpecimensByAccessionDateCategory;
    }

    public void setCollectionSpecimensByAccessionDateCategory(Set collectionSpecimensByAccessionDateCategory) {
        this.collectionSpecimensByAccessionDateCategory = collectionSpecimensByAccessionDateCategory;
    }
    
    public String toString() {
        return new ToStringBuilder(this)
            .append("code", getCode())
            .toString();
    }
}
