/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DnDBGroup.java
 *
 * Created on 28. Juli 2003, 11:24
 */

package net.metadiversity.diversity.navigator.project;

import org.apache.log4j.Logger;

/**
 *
 * @author  Dieter Neubacher
 */
public class DnDbGroup
{
    static Logger logger = Logger.getLogger( DnDbGroup.class.getName() );
    
    private java.lang.String    projectName;
    private java.lang.String    dbGroupName;
    // ??? private java.lang.String    description; 
    
    private java.util.LinkedHashMap dnDatabases;
    /** Creates a new instance of DnDBGroup */
    public DnDbGroup( java.lang.String groupName )
    {
        dnDatabases = new java.util.LinkedHashMap();
        
        this.projectName    = null;
        this.dbGroupName    = groupName;
    }
    public java.lang.String getName()
    {
        return dbGroupName;
    }
    
    public void addDnDatabase( DnDatabase database )
    {
        dnDatabases.put( database.getName(), database );
        return;
    }
    
    public DnDatabase getDnDatabaseByName( java.lang.String dnDbName )
    {
        return ( DnDatabase ) dnDatabases.get( dnDbName );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getChildCount()
    {
        return dnDatabases.size();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public java.lang.String getChild( int i )
    {
        java.util.Iterator iter = dnDatabases.keySet().iterator();
        int ii = 0;
        Object obj = null;
        while( iter.hasNext() )
        {
            obj = iter.next();
            if( i == ii )
            {
                break;
            }
        }
        return obj.toString();
    }
}
