/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DeteilsPanel.java
 *
 * Created on 22. Mai 2003, 14:22
 */

package net.metadiversity.diversity.navigator.table;

import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */
public class DetailsPanel extends javax.swing.JPanel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257291309659271473L;
    
    static Logger logger = Logger.getLogger( DetailsPanel.class.getName() );
    // Variables declaration

    private javax.swing.JList       listPrimaryKey;
    private javax.swing.JPanel      panelHeader;
    private javax.swing.JList       listForeignKey;
    private javax.swing.JPanel      panelForeignKey;
    private javax.swing.JScrollPane detailPane;
    private javax.swing.JPanel      panelKeys;
    private javax.swing.JPanel      panelPrimaryKey;
    private javax.swing.JScrollPane scrollPanePrimaryKey;
    private javax.swing.JLabel      labelHeader;
    private javax.swing.JScrollPane scrollPaneForeignKey;
    private javax.swing.JTable      detailsTable;
    private DetailsTableModel       model;
    private TableTableModel         resultModel;
    private java.util.Vector        primaryKeys;
    private java.util.Vector        foreignKeys;
    
    /** Creates new form DeteilsPanel */
    public DetailsPanel( TableTableModel resultModel )
    {
        this.resultModel = resultModel;
        primaryKeys = resultModel.getPrimaryKey();
        foreignKeys = resultModel.getForeignKeys();
        
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     */

    private void initComponents()
    {
        model = new DetailsTableModel( resultModel );
        detailsTable = new javax.swing.JTable( model );

        detailPane              = new javax.swing.JScrollPane( detailsTable );
        panelHeader             = new javax.swing.JPanel();
        labelHeader             = new javax.swing.JLabel();
        panelKeys               = new javax.swing.JPanel();
        panelPrimaryKey         = new javax.swing.JPanel();
        scrollPanePrimaryKey    = new javax.swing.JScrollPane();
        listPrimaryKey          = new javax.swing.JList();
        panelForeignKey         = new javax.swing.JPanel();
        scrollPaneForeignKey    = new javax.swing.JScrollPane();
        listForeignKey          = new javax.swing.JList();

        setLayout(new java.awt.BorderLayout());

        add(detailPane, java.awt.BorderLayout.CENTER);

        labelHeader.setText( "Table Structure of \"" + resultModel.getTableName() + "\"" );
        panelHeader.add(labelHeader);
        add(panelHeader, java.awt.BorderLayout.NORTH);
        panelKeys.setLayout(new java.awt.GridLayout());

        //----------------------------------------------------------------------
        // Primary keys
        //----------------------------------------------------------------------
        panelPrimaryKey.setLayout( new javax.swing.BoxLayout( panelPrimaryKey, javax.swing.BoxLayout.Y_AXIS ) );
        panelPrimaryKey.setBorder( new javax.swing.border.TitledBorder( "Primary key" ) );
        listPrimaryKey.setModel( new javax.swing.AbstractListModel()
        {
            public int getSize() 
	    { 
		return primaryKeys.size(); 
	    }
            public Object getElementAt( int i ) 
	    { 
		return primaryKeys.get( i ); 
	    }
        });
        listPrimaryKey.setVisibleRowCount(3);
        scrollPanePrimaryKey.setViewportView(listPrimaryKey);
        panelPrimaryKey.add(scrollPanePrimaryKey);
        panelKeys.add(panelPrimaryKey);

        //----------------------------------------------------------------------
        // Foreign keys
        //----------------------------------------------------------------------

        panelForeignKey.setLayout( new javax.swing.BoxLayout( panelForeignKey, javax.swing.BoxLayout.X_AXIS ) );
        panelForeignKey.setBorder( new javax.swing.border.TitledBorder("Foreign keys"));
        listForeignKey.setModel( new javax.swing.AbstractListModel()
        {
            public int getSize() 
	    { 
		return foreignKeys.size(); 
	    }
            public Object getElementAt( int i ) 
	    { 
		return foreignKeys.get( i ); 
	    }
        });
        listForeignKey.setVisibleRowCount( 3 );
        scrollPaneForeignKey.setViewportView(listForeignKey);
        panelForeignKey.add( scrollPaneForeignKey );
        panelKeys.add( panelForeignKey );
        add(panelKeys, java.awt.BorderLayout.SOUTH);
    }
}
