/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DetailTableModel.java
 *
 * Created on 22. Mai 2003, 12:50
 */

package net.metadiversity.diversity.navigator.table;

import javax.swing.table.*;
//import javax.swing.table.TableCellRenderer;
// import javax.swing.DefaultCellEditor;

import org.apache.log4j.Logger;
/**
 *
 * @author  didi
 */
public class DetailsTableModel extends AbstractTableModel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3689353230035400504L;

    static Logger logger = Logger.getLogger( DetailsTableModel.class.getName() );
    
    String [] colNames =
    {
        "Name", "Type", "Not Null", "Default"
    };
    
    Class[] colTypes = new Class []
    {
        java.lang.String.class, 
        java.lang.String.class, 
        java.lang.Boolean.class, 
        java.lang.String.class
    };
    
    boolean[] colCanEdit = new boolean []
    {
        false, false, false, false
    };

    TableTableModel resultModel; 

    public DetailsTableModel( TableTableModel resultModel )
    {
         if( logger.isDebugEnabled() ) logger.debug( "DetailsTableModel()" );
        this.resultModel = resultModel;
    }
    
    public int getColumnCount()
    {
        return 4;
    }
    
    public int getRowCount()    
    {
        return resultModel.getTablesDetailsCount();
    }
    
    public Object getValueAt( int row, int col )    
    {
        return  resultModel.getTableColumnDetails( row, col ); 
    }
    
    public Class getColumnClass(int columnIndex)
    {
        return colTypes[ columnIndex ];
    }

    public boolean isCellEditable( int rowIndex, int columnIndex )
    {
        return colCanEdit[ columnIndex ];
    }
    
    public String getColumnName( int i )
    {
        return colNames[ i ];
    }        
}
