/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 *
 * Created on 22. Mai 2003, 14:22
 */

package net.metadiversity.diversity.navigator.table;

import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */
public class FilterPanel extends javax.swing.JPanel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3256722870771202104L;

    static Logger logger = Logger.getLogger( FilterPanel.class.getName() );
    
    // Variables declaration

    // ??? private javax.swing.JList       listPrimaryKey;
    private javax.swing.JPanel      panelHeader;
    // ??? private javax.swing.JList       listForeignKey;
    // ??? private javax.swing.JPanel      panelForeignKey;
    private javax.swing.JScrollPane filterPane;
    private javax.swing.JPanel      panelKeys;
    // ??? private javax.swing.JPanel      panelPrimaryKey;
    // ??? private javax.swing.JScrollPane scrollPanePrimaryKey;
    private javax.swing.JLabel      labelHeader;
    // ??? private javax.swing.JScrollPane scrollPaneForeignKey;
    private javax.swing.JTable      filterTable;
    private FilterTableModel        filterModel;
    private TableTableModel         resultModel;
    
    final static String ops []   = { "=", "!=", "<", ">", "<=", ">=", "like", "not like", "~", "~*", "!~", "!~*" }; 
    
/*    
    private java.util.Vector        primaryKeys;
    private java.util.Vector        foreignKeys;
  */  
    /** Creates new form DeteilsPanel */
    public FilterPanel(TableTableModel resultModel)
    {
        this.resultModel = resultModel;        
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     */

    private void initComponents()
    {
        filterModel = new FilterTableModel( resultModel );
        filterTable = new javax.swing.JTable( filterModel );
                
        // define renderer and editor
        
//        filterTable.setDefaultRenderer( AndOrSelector.class, new AndOrTableCellRenderer() );
//        filterTable.setDefaultEditor(   AndOrSelector.class, new AndOrTableCellEditor() );
        //
        // WHERE
        //
        javax.swing.JComboBox whereComboBox = new javax.swing.JComboBox();
        for( int i = 0; i < ops.length; i++ )
        {
            whereComboBox.addItem( ops[ i ] );            
        }
        javax.swing.table.TableColumnModel tcm = filterTable.getColumnModel();
        javax.swing.table.TableColumn whereColumn = tcm.getColumn( FilterTableModel.WHERE_COLUMN );
        whereColumn.setCellEditor( new javax.swing.DefaultCellEditor( whereComboBox ) );
        //
        // AND OR
        //
        javax.swing.JComboBox andOrComboBox = new javax.swing.JComboBox();
        andOrComboBox.addItem( "AND" );
        andOrComboBox.addItem( "OR" );
        
        tcm = filterTable.getColumnModel();
        javax.swing.table.TableColumn andOrColumn = tcm.getColumn( FilterTableModel.ANDOR_COLUMN );
        andOrColumn.setCellEditor( new javax.swing.DefaultCellEditor( andOrComboBox ) );
        
        filterPane              = new javax.swing.JScrollPane( filterTable );
        panelHeader             = new javax.swing.JPanel();
        labelHeader             = new javax.swing.JLabel();
        panelKeys               = new javax.swing.JPanel();
        setLayout(new java.awt.BorderLayout());

        add(filterPane, java.awt.BorderLayout.CENTER);

        labelHeader.setText( "Table Structure of \"xxxx\"" );
        panelHeader.add(labelHeader);
        add( panelHeader, java.awt.BorderLayout.NORTH );
        panelKeys.setLayout( new java.awt.GridLayout() );
    }
}
