/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * LogEvent.java
 *
 * Created on 2. Mai 2003, 14:01
 */

package net.metadiversity.diversity.navigator.util;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */
public class LogEvent 
{    
    static Logger logger = Logger.getLogger( LogEvent.class.getName() );
    
    public String text;
    public Level  level;
    public int    numLines;  
    
    /** Creates a new instance of LogEvent */
    public LogEvent( Level level, String text ) 
    {
        if( logger.isDebugEnabled() )
        {
            logger.debug( "new log event" );
        }
        this.level = level;
        this.text  = text;
        numLines   = 1;
        int pos    = text.indexOf( '\n', 0 );
        int len    = text.length() - 1;

        while( (pos > 0) && (pos < len) )
        {    
            numLines++;
            pos = text.indexOf('\n', pos + 1);
        }    
    }    
}
