/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.util;

/**
 * Title:
 * Description:
 * Copyright:    
 * Company:
 * @author
 * @version 1.0
 */

import java.awt.Color;
import java.awt.BorderLayout;

import javax.swing.*;
/*
import java.awt.Image;
import java.awt.Toolkit;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.MutableAttributeSet;
import javax.swing.text.StyleConstants;

import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Enumeration;
import java.util.ArrayList;

import org.apache.log4j.*;
import org.apache.log4j.Level;

import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
*/

public class LogListPanel extends JPanel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3546920277453124662L;
    private JScrollPane     scrollPane;
    private JList           logList;
    // ??? private java.awt.Font   font;   
    private int eventBufferMaxSize = 1000;
    private int eventBufferCount   = 0;

    private javax.swing.DefaultListModel model;
    
    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public LogListPanel() 
    {
        constructComponents();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void constructComponents() 
    {
        this.setLayout( new BorderLayout() );

        logList = new JList();
        // ??? logList.setFont( font );
        logList.setVisible( true );
                
        model = new javax.swing.DefaultListModel();
        logList.setModel( model );
        
        logList.setCellRenderer( new LogCellRenderer() );
        logList.setVisibleRowCount( 5 );
        scrollPane = new JScrollPane();
        scrollPane.setViewportView( logList );
        scrollPane.getHorizontalScrollBar().setValue( 1000 );       
        scrollPane.getVerticalScrollBar().setValue( 1000 );        
        
        this.add( scrollPane,    BorderLayout.CENTER );        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setTextBackground( Color color ) 
    {
        logList.setBackground( color );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    void setEventBufferSize( int bufferSize ) 
    {
        eventBufferMaxSize = bufferSize;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    void newEvent( LogEvent event )
    {
        // logList.setVisible( false );
        if( eventBufferCount >= eventBufferMaxSize ) 
        {
            model.remove( 0 );
        }
        else
        {
            eventBufferCount++;
        }
        logList.ensureIndexIsVisible( eventBufferCount - 1 );  
        logList.setVisible( true );
        model.addElement( event );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
}