/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * SubsituteTabelCellData
 *
 */

package net.metadiversity.diversity.navigator.util;

import java.sql.*;
import java.io.*;
import java.lang.StringBuffer;
/**
 *
 * @author  Dieter Neubacher
 */
public class SubstituteTableCellData
{    
    java.lang.String db_url     = "jdbc:postgresql://hongkong:5432/bsm-email-list";
    java.lang.String db_user    = "didi";
    java.lang.String db_pwd     = "";
    java.lang.String db_driver  = "org.postgresql.Driver";
    
    java.util.Vector columnType    = null;
    java.util.Vector columnName    = null;
    
    Connection con  = null;
    String importFileName = null;
    
    String tableName = null;
    String fieldName = null;
    
    int replaceCount = 0;
    
    final static boolean debugShowValues = false;
    final static boolean showSqlFlag = false;  
    
    final static String DATESTYLE_EUROPEAN_GERMAN = "SET DATESTYLE TO EUROPEAN, GERMAN;";
    final static char optionNumberFormatDotCharacter = ',';
    
    final static boolean setAutoCommit = false;  // AutoCommit not posible whis SuSE 9.1 and Postgresql Version: 7.4
    
    /** Creates a new instance of ImportMsDbTable */
    public SubstituteTableCellData(String url, String user, String pwd)
    {
        db_url  = url;
        db_user = user;
        db_pwd  = pwd;
        
        columnType = new java.util.Vector();                
        columnName = new java.util.Vector();                                
    }    
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    private int connect()
    {
        // load driver and get DB-Connection
        try
        {
            Class.forName( "org.postgresql.Driver" );
            System.out.println( "Load PostgreSQL Driver..." );
        }
        catch( java.lang.ClassNotFoundException ee )
        {
            System.out.println( "ClassNotFoundException: " );
            System.out.println( ee.getMessage() );
            
            return 1;
        }
        try
        {
            con = java.sql.DriverManager.getConnection( db_url, db_user, db_pwd );
        }            
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getMessage() );             
            return 2;
        }
        
        return 0;
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------    
    public int substitute( String table, String field, String sedCommand )
    {
        boolean errorFlag = false;
        
        java.sql.Statement s;
        
        try
        {
            if( con == null )
            {
                connect();
            }
            String tableName = null;
//            getTableColumnInfo( tableName );
            
            ResultSet resultSet;
            //------------------------------------------------------------------
            // prepare SQL Statment's
            //------------------------------------------------------------------
            con.setAutoCommit( false );
            s = con.createStatement();
            s.execute( "BEGIN TRANSACTION" );
            // set formats 
            s.execute( DATESTYLE_EUROPEAN_GERMAN );
            
            StringBuffer sql = new StringBuffer();
            StringBuffer sqlFields = new StringBuffer();
            StringBuffer sqlValues = new StringBuffer();
            
            String search;
            String replace;
            
            if( sedCommand.startsWith( "s/" ) )
            {
                search = sedCommand.substring( 2 );
                int pos = search.indexOf( "/" );
                
                replace = search.substring( pos + 1 );                
                search = search.substring( 0, pos );
                
                pos = replace.indexOf( "/" );
                replace = replace.substring( 0, pos );                
                System.out.println( "Replace : \"" + search + "\" with \"" + replace + "\"" ); 
            }
            else
            {
                System.out.println( "Can't execute command " + sedCommand );
                return 1;
            }
            
            sql.append( "SELECT DISTINCT " + "\"" + field + "\"  FROM \"" + table + "\" WHERE " );
            sql.append( "\""  + field + "\" LIKE '" + '%' + search + "%\'" );
            
            if( showSqlFlag ) System.out.println( sql );
            resultSet = s.executeQuery( sql.toString() );
            java.util.Vector replaceVector = new java.util.Vector();
            if( resultSet != null )
            {
                while( resultSet.next() )
                {
                    replaceVector.add( resultSet.getString( 1 ) );
                    // System.out.println( "Replace : \"" + resultSet.getString( 1 ) + "\"" );
                }
            }                       
            //--------------
            // replace data
            //--------------
            if( replaceVector.size() > 0 )
            {
                for( int i = 0; i < replaceVector.size(); i++ )
                {
                    String originalData = (String) replaceVector.get( i );
                    String searchString = (String) replaceVector.get( i );                    
                    String replaceWith = searchString;
                    int pos = searchString.indexOf( search );
                    int fromIndex = 0;
                    while( pos >= 0 )
                    {
                        replaceWith = searchString.substring( 0, pos );
                        replaceWith += replace;
                        fromIndex = replaceWith.length(); 
                        replaceWith +=  searchString.substring( pos + search.length() );
                        searchString = replaceWith;
                        pos = searchString.indexOf( search, fromIndex );
                        
                        if( pos > 1000 )
                        {
                            System.out.println( "ERROR Replace : \"" + originalData + "\" with \"" + replaceWith + "\"" );
                            return 1;
                        }
                    }                    
                    System.out.println( "Replace : \"" + originalData + "\" with \"" + replaceWith + "\"" );
                    
                    
                    String update = "UPDATE \"" + table + "\" SET \"" + field + "\" = '" + replaceWith + "' WHERE \"" + field + "\" = '" + originalData + "'";
                    if( showSqlFlag ) System.out.println( update );
                    int ret = s.executeUpdate( update );
                    if( ret > 0 )
                    {
                        replaceCount += ret;
                        System.out.println( "OK " + ret + " rows changed." );
                    }
                    else
                    {
                        // System.out.println( "ERROR" );
                        errorFlag = true;
                    }
                }
                
            }
            s.close();            
            s.close();            
            con.commit();
            if( showSqlFlag ) System.out.println( "Commit Data" );
        }
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
            errorFlag = true;
        }   
        catch( java.lang.Exception ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
            errorFlag = true;
        }
        finally
        {
            try
            {
                if( errorFlag )
                {    
                    con.rollback();
                    System.out.println( "Rollback Data" );
                }
                else
                {
//                    con.commit();
//                    System.out.println( "Commit Data" );
                 }    
//                con.close();
            }
            catch(  java.sql.SQLException ex )
            {
                System.out.println( ex.getLocalizedMessage() );             
            }
        }            
        return 0;
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------    
    public int substitute( String table, String firstField, String secondField, String sedCommand )
    {
        boolean errorFlag = false;
        
        java.sql.Statement s;        
        try
        {
            if( con == null )
            {
                connect();
            }
            String tableName = null;
//            getTableColumnInfo( tableName );
            
            ResultSet resultSet;
            //------------------------------------------------------------------
            // prepare SQL Statment's
            //------------------------------------------------------------------
            if( setAutoCommit )
            {
                con.setAutoCommit( false );
            }
            s = con.createStatement();
            s.execute( "BEGIN TRANSACTION" );
            // set formats 
            s.execute( DATESTYLE_EUROPEAN_GERMAN );
            
            StringBuffer sql = new StringBuffer();
            StringBuffer sqlFields = new StringBuffer();
            StringBuffer sqlValues = new StringBuffer();
            
            String firstSearch;
            String secondSearch;
            String firstReplace;
            String secondReplace;
            
            if( sedCommand.startsWith( "s/" ) )
            {
                String search;
                String replace;
                
                search = sedCommand.substring( 2 );
                int pos = search.indexOf( "/" );
                
                replace = search.substring( pos + 1 );                
                search = search.substring( 0, pos );
                
                pos = replace.indexOf( "/" );
                replace = replace.substring( 0, pos );                
                // position of BLANK or TAB                
                pos = search.indexOf( " " );
                firstSearch     = search.substring( 0, pos );
                secondSearch    = search.substring( pos + 1 );
                pos = replace.indexOf( " " );
                firstReplace    = replace.substring( 0, pos );
                secondReplace   = replace.substring( pos + 1 );                
                //
                System.out.println( "Replace : \"" + firstSearch + ", " + secondSearch + "\" with \"" + firstReplace + ", " + secondReplace + "\"" ); 
            }
            else
            {
                System.out.println( "Can't execute command " + sedCommand );
                return 1;
            }
            
            sql.append( "SELECT DISTINCT " + "\"" + firstField + "\", \"" + secondField + "\"  FROM \"" + table + "\" WHERE " );
            sql.append( "\""  + firstField + "\" LIKE '" + '%' + firstSearch + "%\'" );
            sql.append( " AND \""  + secondField + "\" LIKE '" + '%' + secondSearch + "%\'" );
            
            if( showSqlFlag ) System.out.println( sql );
            resultSet = s.executeQuery( sql.toString() );
            java.util.Vector firstReplaceVector = new java.util.Vector();
            java.util.Vector secondReplaceVector = new java.util.Vector();
            if( resultSet != null )
            {
                while( resultSet.next() )
                {
                    firstReplaceVector.add( resultSet.getString( 1 ) );
                    secondReplaceVector.add( resultSet.getString( 2 ) );
                    // System.out.println( "Replace : \"" + resultSet.getString( 1 ) + "\"" );
                }
            }                       
            //--------------
            // replace data
            //--------------
            if( firstReplaceVector.size() > 0 )
            {
                for( int i = 0; i < firstReplaceVector.size(); i++ )
                {
                    String firstOriginalData = (String) firstReplaceVector.get( i );
                    String firstSearchString = (String) firstReplaceVector.get( i );                    
                    String secondOriginalData = (String) secondReplaceVector.get( i );
                    String secondSearchString = (String) secondReplaceVector.get( i );                    
                    String firstReplaceWith = firstSearchString;
                    String secondReplaceWith = secondSearchString;
                    // First
                    int pos = firstSearchString.indexOf( firstSearch );
                    int fromIndex = 0;
                    while( pos >= 0 )
                    {
                        firstReplaceWith = firstSearchString.substring( 0, pos );
                        firstReplaceWith += firstReplace;
                        fromIndex = firstReplaceWith.length(); 
                        firstReplaceWith +=  firstSearchString.substring( pos + firstSearch.length() );
                        firstSearchString = firstReplaceWith;
                        pos = firstSearchString.indexOf( firstSearch, fromIndex );                        
                        if( pos > 1000 )
                        {
                            System.out.println( "ERROR Replace : \"" + firstOriginalData + "\" with \"" + firstReplaceWith + "\"" );
                            return 1;
                        }
                    }       
                    // Second
                    pos = secondSearchString.indexOf( secondSearch );
                    fromIndex = 0;
                    while( pos >= 0 )
                    {
                        secondReplaceWith = secondSearchString.substring( 0, pos );
                        secondReplaceWith += secondReplace;
                        fromIndex = secondReplaceWith.length(); 
                        secondReplaceWith +=  secondSearchString.substring( pos + secondSearch.length() );
                        secondSearchString = secondReplaceWith;
                        pos = secondSearchString.indexOf( secondSearch, fromIndex );                        
                        if( pos > 1000 )
                        {
                            System.out.println( "ERROR Replace : \"" + secondOriginalData + "\" with \"" + secondReplaceWith + "\"" );
                            return 1;
                        }
                    }       
                    System.out.println( "Replace : \"" + firstOriginalData + ", " + secondOriginalData + "\" with \"" + firstReplaceWith + ", " + secondReplaceWith + "\"" );
                    
                    
                    String update = "UPDATE \"" + table + "\" SET \"" + firstField + "\" = '" + firstReplaceWith + "\', \"" + secondField + "\" = '" + secondReplaceWith + "' WHERE \"" + firstField + "\" = '" + firstOriginalData + "' AND \"" + secondField + "\" = '" + secondOriginalData + "'";
                    if( showSqlFlag ) System.out.println( update );
                    int ret = s.executeUpdate( update );
                    if( ret > 0 )
                    {
                        replaceCount += ret;
                        System.out.println( "OK " + ret + " rows changed." );
                    }
                    else
                    {
                        errorFlag = true;
                        // System.out.println( "ERROR" );
                    }
                }                
            }
            s.close();            
            con.commit();
            if( showSqlFlag ) System.out.println( "Commit Data" );
        }
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
            errorFlag = true;
        }   
        catch( java.lang.Exception ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
            errorFlag = true;
        }
        finally
        {
            try
            {
                if( errorFlag )
                {    
                    con.rollback();
                    System.out.println( "Rollback Data" );
                }
                else
                {
//                    con.commit();
//                    System.out.println( "Commit Data" );
                 }    
//                con.close();
            }
            catch(  java.sql.SQLException ex )
            {
                System.out.println( ex.getLocalizedMessage() );             
            }
        }            
        return 0;
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public void readFile( String table, String field, String fileName )
    {
        readFile( table, field, null, fileName );
    }
    public void readFile( String table, String firstField, String secondField, String fileName )
    {        
        
        System.out.println();
        System.out.println( "Data from file: " + fileName );
        System.out.println();
        
        File f = new File( fileName );
        if( ! f.canRead() )
        {
            System.out.println( "Can't read input file: " + fileName );
            return;
        }
        
        java.io.FileInputStream    fis;
        java.io.InputStreamReader  isr; 
        java.io.BufferedReader     input;

        java.lang.String            encoding = "UTF-8";

        try
        {
            fis = new java.io.FileInputStream( fileName );
            isr = new java.io.InputStreamReader( fis, "UTF-8" );

            input = new java.io.BufferedReader( isr );

            while( input.ready() )
            {
                String command = input.readLine();
                if( ! command.startsWith( "#" ) )
                {
                    if( secondField == null )
                    {                        
                        substitute( table, firstField, command );
                    }
                    else
                    {                        
                        substitute( table, firstField, secondField, command );
                    }
                }
            }                                           
            //------------------------------------------------------------------
            con.close();
            System.out.println( "Total replaced " + replaceCount + " data entries" );
        }
        catch( java.io.FileNotFoundException ex )
        {
            ex.printStackTrace();
        }
        catch( java.io.UnsupportedEncodingException ex )
        {
            ex.printStackTrace();
        }
        catch( java.io.IOException ex )
        {
            ex.printStackTrace();
        }        
        catch(  java.sql.SQLException ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
        }
    }    
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    private void getTableColumnInfo( String tableName ) throws java.sql.SQLException
    {
            DatabaseMetaData dbmd = con.getMetaData();
            ResultSet columnResultSet;

            columnResultSet = dbmd.getColumns( null, null, tableName, null );


            System.out.println( "Get tabel infos for table : >" + tableName + "<"  ); 
            while( columnResultSet.next() ) 
            {
                String name         = columnResultSet.getString(    "COLUMN_NAME" );
                short dataType      = columnResultSet.getShort(     "DATA_TYPE"   );
                // String typeName     = columnResultSet.getString(    "TYPE_NAME"   );
                // int size            = columnResultSet.getInt(       "COLUMN_SIZE" );
                // int decimals        = columnResultSet.getInt(       "DECIMAL_DIGITS");
                // int nullable        = columnResultSet.getInt(       "NULLABLE"    );
                // String defaultVal   = columnResultSet.getString(    "COLUMN_DEF"  );
                // boolean nulls       = ( nullable == DatabaseMetaData.columnNullable );

                columnType.add( new java.lang.Short( dataType ) );
                columnName.add( new java.lang.String( name ) );

                System.out.println( name + ": " + dataType );
            }
            columnResultSet.close();        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        if( args.length == 0 )
        {
            System.out.println( "usage: java net.metadiversity.diversity.navigator.util url user password table field file" );
            System.out.println( "" );
            System.out.println( "url:       \"jdbc:postgresql://hongkong:5432/db-name\"" );
            System.out.println( "user:      username" );
            System.out.println( "password   password" );
            System.out.println( "" );
            System.out.println( "table      database table name" );
            System.out.println( "field      database table field name" );
            System.out.println( "" );
            System.out.println( "file:      sed-File-Name" );
            
            SubstituteTableCellData sub = new SubstituteTableCellData( "jdbc:postgresql://hongkong:5432/checklists", "didi", "xxx" );            
            // test
            // sub.substitute( "checklists_data", "Author", "s/Diedrich/Diederich/g" );            
            // sub.readFile( "checklists_data", "Author", "/home/didi/lias_names/LiasNames_040524/replace/automatically/lias.names.replace.authors.0.040422.txt" );            
            sub.substitute( "checklists_data", "Genus", "Species", "s/Coccocarpia prunosa/Coccocarpia pruinosa/g    #Checklist/ES" );            
        }
        if( args.length == 6 )
        {
            // get paramms            
            SubstituteTableCellData sub = new SubstituteTableCellData( args[ 0 ], args[ 1 ], args[ 2 ] );
            sub.readFile( args[ 3 ], args[ 4 ], args[ 5 ]  );            
        }
        // Replace 2 fields
        if( args.length == 7 )
        {
            // get paramms            
            SubstituteTableCellData sub = new SubstituteTableCellData( args[ 0 ], args[ 1 ], args[ 2 ] );
            sub.readFile( args[ 3 ], args[ 4 ], args[ 5 ], args[ 6 ]  );            
        }
    }    
}
