/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * SubsituteTabelCellData
 *
 */

package net.metadiversity.diversity.navigator.util;

import java.sql.*;
//import java.io.*;
//import java.util.*;
import java.lang.StringBuffer;
/**
 *
 * @author  Dieter Neubacher
 */
public class SwapChecklistLiterature
{    
    java.lang.String db_url     = "jdbc:postgresql://hongkong:5432/bsm-email-list";
    java.lang.String db_user    = "didi";
    java.lang.String db_pwd     = "";
    java.lang.String db_driver  = "org.postgresql.Driver";
    
    Connection con  = null;
    
    final static boolean debugShowValues = false;
    final static boolean showSqlFlag = false;  
    
    final static String DATESTYLE_EUROPEAN_GERMAN = "SET DATESTYLE TO EUROPEAN, GERMAN;";
    final static char optionNumberFormatDotCharacter = ',';
    
    /** Creates a new instance of ImportMsDbTable */
    public SwapChecklistLiterature(String url, String user, String pwd)
    {
        db_url  = url;
        db_user = user;
        db_pwd  = pwd;
        
    }    
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    private int connect()
    {
        // load driver and get DB-Connection
        try
        {
            Class.forName( "org.postgresql.Driver" );
            System.out.println( "Load PostgreSQL Driver..." );
        }
        catch( java.lang.ClassNotFoundException ee )
        {
            System.out.println( "ClassNotFoundException: " );
            System.out.println( ee.getMessage() );
            
            return 1;
        }
        try
        {
            con = java.sql.DriverManager.getConnection( db_url, db_user, db_pwd );
        }            
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getMessage() );             
            return 2;
        }
        
        return 0;
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public void swapLiterature( String id )
    {
        
        boolean errorFlag = false;
        
        java.sql.Statement s;
        
        try
        {
            java.util.Vector taxoLitVector = new java.util.Vector();
            java.util.Vector florLitVector = new java.util.Vector();
            java.util.Vector idVector = new java.util.Vector();
            if( con == null )
            {
                connect();
            }
            String tableName = null;
            ResultSet resultSet;
            //------------------------------------------------------------------
            // prepare SQL Statment's
            //------------------------------------------------------------------
            s = con.createStatement();
            s.execute( "BEGIN TRANSACTION" );
            // set formats 
            s.execute( DATESTYLE_EUROPEAN_GERMAN );
            
            StringBuffer sql = new StringBuffer();
            StringBuffer sqlFields = new StringBuffer();
            StringBuffer sqlValues = new StringBuffer();
            
            String search;
            String replace;
       
            String table = "checklists_data";
            String idField = "id";
            String checklistsIdField = "ChecklistId";
            String taxoLitField = "TaxonRef";
            String florLitField = "FlorRef";
            
            sql.append( "SELECT " + "\"" + idField + "\", \"" + "\"" + taxoLitField + "\", \"" + florLitField + "\"  FROM \"" + table + "\" WHERE " );
            sql.append( "\""  + checklistsIdField + "\" = '" + id + "\'" );
            
            if( showSqlFlag ) System.out.println( sql );
            resultSet = s.executeQuery( sql.toString() );
            if( resultSet != null )
            {
                while( resultSet.next() )
                {
                    idVector.add( resultSet.getString( 1 ) );
                    taxoLitVector.add( resultSet.getString( 2 ) );
                    florLitVector.add( resultSet.getString( 3 ) );
                }
            }                       
            //--------------
            // replace data
            //--------------
            if( idVector.size() > 0 )
            {
                for( int i = 0; i < idVector.size(); i++ )
                {
                    String taxo = (String) florLitVector.get( i );
                    String flor = (String) taxoLitVector.get( i );
                    String rid  = (String) idVector.get( i );
                    
                    String update = "UPDATE \"" + table + "\" SET \"" + taxoLitField + "\" = '" + taxo + "' WHERE \"" + idField + "\" = '" + rid + "'";
                    if( showSqlFlag ) System.out.println( update );
                    int ret = s.executeUpdate( update );
                    if( ! ( ret > 0 ) )
                    {
                        // System.out.println( "ERROR" );
                        errorFlag = true;
                    }
                }
                
            }
            s.close();            
            con.commit();
            if( showSqlFlag ) System.out.println( "Commit Data" );
        }
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
            errorFlag = true;
        }   
        catch( java.lang.Exception ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
            errorFlag = true;
        }
        finally
        {
            try
            {
                if( errorFlag )
                {    
                    con.rollback();
                    System.out.println( "Rollback Data" );
                }
                else
                {
//                    con.commit();
//                    System.out.println( "Commit Data" );
                 }    
//                con.close();
            }
            catch(  java.sql.SQLException ex )
            {
                System.out.println( ex.getLocalizedMessage() );             
            }
        }            
        return;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        if( args.length == 0 )
        {
            System.out.println( "usage: java net.metadiversity.diversity.navigator.util url user password checklist-id" );
            System.out.println( "" );
            System.out.println( "url:       \"jdbc:postgresql://hongkong:5432/db-name\"" );
            System.out.println( "user:      username" );
            System.out.println( "password   password" );
            System.out.println( "" );
            System.out.println( "checklist-id" );
            System.out.println( "" );
            System.exit( 0 );
        }
        if( args.length == 4 )
        {
            // get paramms            
            SwapChecklistLiterature scd = new SwapChecklistLiterature( args[ 0 ], args[ 1 ], args[ 2 ] );
            scd.swapLiterature( args[ 4 ] );
        }
        else
        {
            SwapChecklistLiterature scd = new SwapChecklistLiterature( "jdbc:postgresql://hongkong:5432/checklists", "didi", "xxx" );            
            String id = "123456";
            scd.swapLiterature( id );
        }
        System.exit( 0 );
    }    
}
