/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * TestUrlConnection.java
 *
 * Created on 12. November 2003, 15:16
 */

package net.metadiversity.diversity.navigator.util;

import net.metadiversity.diversity.navigator.gui.DnOptionPane;
import org.apache.log4j.Logger;

/**
 *
 * @author  Dieter Neubacher
 */
public class TestUrlConnection extends java.lang.Thread
{
    static Logger logger = Logger.getLogger( TestUrlConnection.class.getName() );
    
    java.net.URL url = null;
    java.net.Socket socket = null;
    boolean connected = false;
    int timeout = 3000;
    /** Creates a new instance of TestUrlConnection */
    /*
    public TestUrlConnection()
    {
    }
     **/
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public TestUrlConnection( java.lang.String url )
    {
        try
        {
            setUrl( new java.net.URL( url ) );
        }
        catch( java.net.MalformedURLException ex )
        {
            DnOptionPane.showMessageDialog( null, "Invalid URL: "  + url, "Error" , DnOptionPane.ERROR_MESSAGE );                                     
        }
        testURL();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public TestUrlConnection( java.net.URL url )
    {
        setUrl( url );
        testURL();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void testURL()
    {
        if( url.getProtocol().compareToIgnoreCase( "file" ) == 0 )
        {
            connected = true;
            return;
        }
        if( url.getProtocol().compareToIgnoreCase( "jar" ) == 0 )
        {
            connected = true;
            return;
        }
        start();
        
        try
        {
            join( timeout );
        }
        catch( java.lang.InterruptedException ex )
        {
        }
        if( isConnected() == false )
        {
            logger.equals( "Can't connect to " + url );
   // 2005.11.07 ???         
            DnOptionPane.showMessageDialog( null, "Can't connect to " + url, "Error" , DnOptionPane.ERROR_MESSAGE );                                     
        }                
    }        
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void run ()
    {
        try
        {
            int port = url.getPort();
            if( port == -1 ) port = 80;
            System.out.println( "open socket to: " + url.getHost() + ":" + port);
            socket = new java.net.Socket( url.getHost(), port );
            if( socket == null )
            {
                connected = false;
                System.out.println( "can't connect" );
            }
            else
            {
                socket.close();
                connected = true;
                System.out.println( "connect ok" );
            }
            System.out.println( "close socket" );
        }
        catch( java.io.IOException ex )
        {
            System.out.println( "socket exception" );
            System.out.println( ex.getLocalizedMessage() );            
            connected = false;
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setUrl( java.net.URL url )
    {
        this.url = url;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public boolean isConnected()
    {
        return connected;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setTimeout( int time )
    {
        timeout = time;
    }

    /**
     * @param args the command line arguments
     */
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public static void main(String[] args) 
    {
        TestUrlConnection thread = null;
        
        try
        {
            thread = new TestUrlConnection( new java.net.URL( "http://141.84.65.156/test" )  );
            thread = new TestUrlConnection( "http://hongkong:5432/test" );
        }
        catch( java.net.MalformedURLException ex )
        {
            ex.printStackTrace();
        }
        if( thread != null )
        {
            System.out.print( "Status: " + thread.isConnected() );
        }
    }    
}
