package net.metadiversity.diversity.navigator.checklists.database;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Dieter Neubacher
 * @version 1.0
 */
//import java.net.URL;          // F�r Datenbank-URL
import java.sql.*;            // JDBC
//import java.lang.*;
import java.lang.String;
import java.lang.StringBuffer;
//import java.io.FileReader;
//import java.io.StringReader;
//import java.io.BufferedReader;
import java.util.Vector;
//import javax.swing.*;
// logging
import org.apache.log4j.Logger;

//import net.metadiversity.diversity.navigator.checklists.dataimport.ParseImportLine;
//import net.metadiversity.diversity.navigator.checklists.*;

import net.metadiversity.diversity.navigator.util.TestUrlConnection;

public class DBChecklist
{
    static Logger logger = Logger.getLogger( DBChecklist.class.getName() ); 
    
    boolean DEBUG_FLAG = true;

    // debug
    private static boolean debugFlag = false;

    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public boolean checkConnection() // throws SQLException
    {
	try
	{
	    Connection con = connect();
	    con.close();
	    return true;
	}
	catch( Exception ex )
	{
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
	    if (ex instanceof SQLException)
	    {
		String err = ((SQLException)ex).getSQLState();
		if ( err != null )
		{
		    logger.error( "error: " + err );
		}
		SQLException SQLex;
		while ( ( SQLex = ((SQLException)ex).getNextException() ) != null )
		{
		    logger.error( "sql exception " + SQLex.getSQLState());
		}
	    }
	    return false;
	}
    }
    //-------------------------------------------------------------------------------------
    //
    //-------------------------------------------------------------------------------------
    public java.sql.Connection connect()
    {   
        java.sql.Connection  con = null;
  	try
	{
            net.metadiversity.diversity.navigator.connection.ConnectionInfo ci;        
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( "LIAS Checklists" );
/* ???
            try 
            {
                logger.fatal( "Loading driver ..." );
                Class.forName( ci.getDriver() );
            } 
            catch( Exception ex ) 
            {
                logger.fatal( "Can't load driver: " + ci.getDriver() );
                logger.error( ex.getMessage(), ex.fillInStackTrace() );
                return null;
            }
*/
            logger.info( "Connect to: " + ci.getUrl() );
            String url = ci.getUrl();
            url = url.substring( url.indexOf( "//" ) );
            TestUrlConnection test = new TestUrlConnection( "http:" + url );
            if( test.isConnected() )
            {
                con = DriverManager.getConnection( ci.getUrl(), ci.getUser(), ci.getPwd() );
            }
            else
            {
                return con;
            }
        }
        catch( java.sql.SQLException ex )
        {
            logger.error( "Can't connect to checklists" );
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }        
        return con;
    }    
/*    
    //-------------------------------------------------------------------------------------
    //
    //-------------------------------------------------------------------------------------
    public Statement getStmt()
    {
	try
	{
	    Connection con = connect();
	    Statement stmt = con.createStatement();
	    return stmt;
        }
	catch( Exception ex )
	{
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
	    if (ex instanceof SQLException)
	    {
		String err = ((SQLException)ex).getSQLState();
		if ( err != null )
		{
		    logger.error( "error: " + err );
		}
		SQLException SQLex;
		while ( ( SQLex = ((SQLException)ex).getNextException() ) != null )
		{
		    logger.error( "sql exception " + SQLex.getSQLState());
		}
	    }
	    return null;
	}
    }
 */
    //---------------------------------------------
    // execute sql command
    //---------------------------------------------
    public void executeSQLCommand( String cmd )
    {
        if( logger.isDebugEnabled() ) logger.debug( cmd );
	try
	{
	    Connection con = connect();
	    Statement stmt = con.createStatement();
	    //--------------------------------------------------------------------
	    //  SQL-Command
	    //--------------------------------------------------------------------
	    logger.info( "execute SQL command, result:\n" );
	    logger.info( "-----------------------------------------------------\n" );
	    ResultSet rs = stmt.executeQuery( cmd );

	    while( rs.next() )
	    {
		// System.out.print( new Integer( rs.getInt( 1 ) ).toString() );
		logger.info( rs.getString( 1 ) );
		logger.info( "\t" );
		logger.info( rs.getString( 2 ) );
		logger.info( "\t" );
		logger.info( rs.getString( 3 ) );
		//		logger.fatal( new Integer( rs.getInt(2) ).toString() );
		logger.info( "\n" );
	    }
	    stmt.close();
	    con.close();
	}
	catch( Exception ex )
	{
	    logger.error( "ex: " + ex.getMessage());
	    if( ex instanceof SQLException )
	    {
		String err = ((SQLException)ex).getSQLState();
		if( err != null )
		{
		    logger.error( "error: " + err );
		}
		SQLException SQLex;
		while( ( SQLex = ((SQLException)ex).getNextException() ) != null )
		{
		    logger.error( "sql exception " + SQLex.getSQLState());
		}
	    }
	}
    }
    //---------------------------------------------------------------------------
    //
    //---------------------------------------------------------------------------
    private boolean insertCmd( String cmd )
    {
	boolean ret = true;
	try
	{
	    Connection con = connect();
	    Statement stmt = con.createStatement();

	    if( logger.isDebugEnabled() ) logger.debug( cmd );

	    if( stmt.execute( cmd ) == true )
	    {
		// there was an error
		ret = false;
	    }
	    if( logger.isDebugEnabled() ) logger.debug( "Return: " + ret );
	    stmt.close();
	    con.close();
	    return ret;
	}
	catch( Exception ex )
	{
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
	    return false;
	}
    }
/* ???   
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public boolean insertChecklistName( String name )
    {
	String cmd = "INSERT INTO checklist_names ( name ) VALUES ( \'" + name.trim() + "\' );";
	return insertCmd( cmd );
    }
 */
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public long getChecklistHeaderId( java.sql.Connection con,String title ) throws java.sql.SQLException
    {
	return getId( con, "checklists_header", "ChecklistSourceID", "AcknowledgementTitle", title );
    }
/* ???
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public boolean insertName( String name )
    {
	try
	{
	    boolean ret = true;
	    String cmd = "INSERT INTO names ( name ) VALUES ( \'" + name.trim() + "\' );";

	    Connection con = connect();
	    Statement stmt = con.createStatement();

	    if( logger.isDebugEnabled() ) logger.debug( cmd );

	    if( stmt.execute( cmd ) == true )
	    {
		// there was an error
		ret = false;
	    }
	    if( logger.isDebugEnabled() ) logger.debug( "Return: " + ret );
	    stmt.close();
	    con.close();
	    return ret;
	}
	catch( Exception ex )
	{
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
	    return false;
	}
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public boolean checkName( String name )
    {
	try
	{
	    boolean ret = true;
	    String cmd = "SELECT * FROM names WHERE name = \'" + name.trim() + "\';";
	    Connection con = connect();
	    Statement stmt = con.createStatement();
	    if( logger.isDebugEnabled() ) logger.debug( cmd );
	    ResultSet rs = stmt.executeQuery( cmd );

	    if( rs.first() == false  )
	    {
		// there was an error
		ret = false;
	    }
	    if( logger.isDebugEnabled() ) logger.debug( "Return: " + ret );
	    stmt.close();
	    con.close();
	    return ret;
	}
	catch( Exception ex )
	{
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
	    return false;
	}
    }
 */
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public long getId( java.sql.Connection con, String table, String id, String field, String entry ) throws java.sql.SQLException
    {
	long ret = -1;
        String cmd = "SELECT \"" + id + "\" FROM \"" + table +"\" WHERE \"" + field +"\" = \'" + entry.trim() + "\';";
        Statement stmt = con.createStatement();
        if( debugFlag )
        {    
            logger.debug( cmd );
        }        
        ResultSet rs = stmt.executeQuery( cmd );

        if( rs.first() == false  )
        {
            // there was an error
            ret = -1;
        }
        else
        {
            ret = rs.getLong( 1 );
        }
        if( debugFlag )
        {    
            logger.debug( "Return: " + ret );
        }    
        stmt.close();
        return ret;
    }
/*    
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------    
    public void parseData( long checklistId )
    {
	try
	{
	    OrginalLineData data;
	    String cmd = "SELECT line, checklist_id, checked, text, comment FROM lines_orginal WHERE checklist_id = \'" + checklistId + "\';";
	    Connection con = connect();
	    Statement stmt = con.createStatement();
	    if( logger.isDebugEnabled() ) logger.debug( cmd );
	    ResultSet rs = stmt.executeQuery( cmd );

            ParseImportLine parser = new ParseImportLine();

	    while( rs.next() == true  )
	    {
		try
		{
		    data =  new OrginalLineData( rs.getLong( 1 ), rs.getLong( 2 ), rs.getBoolean( 3 ), rs.getString( 4 ), rs.getString( 5 ) );

		    if( logger.isDebugEnabled() ) logger.debug( data.getText() );
                  
		    if( parser.parseData( data.getText() ) == false )
                    {
			    // String msg = "Error found in line: \n" + data.getText();
			    String msg = "Error found in line: \n" + parser.getErrorText();
			    DnOptionPane.showMessageDialog( null, msg, "Error", DnOptionPane.ERROR_MESSAGE );
                    }
		    else
                    {
                        parser.taxon.setErrorFlag( false );
                        String insertCmd = parser.taxon.insertDataString();

                        Connection insertCon = connect();
	                Statement insertStmt = con.createStatement();
                        if( DEBUG_FLAG )
                        {
                            logger.debug( insertCmd );
                        }
                        insertStmt.execute( insertCmd );
                    }
		}
		catch( Exception ex )
		{
                    logger.error( ex.getMessage(), ex.fillInStackTrace() );
		}
	    }
            if( debugFlag )
            {    
                logger.debug( "-- finish --" );
            }    
	    stmt.close();
	    con.close();
	}
	catch( Exception ex )
	{
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
            new ErrorMessage( "Error", ex.getMessage()  );
	}
    }
 */
    //--------------------------------------------------------------------------
    // XML-DATA-LINE-INPUT
    //--------------------------------------------------------------------------    
    public void insertXmlHeader( java.sql.Connection con, Vector dataFields ) throws java.sql.SQLException
    {
        if( debugFlag )
        {    
            logger.debug( "Insert header into database" );
        }    
        Vector entries = new Vector();
// id --> ChecklistSourceID        
//        entries.add( new DataTableEntry( "id",                          DataTableEntry.SERIAL ) ); 
        entries.add( new DataTableEntry( "ChecklistName",               DataTableEntry.STRING ) ); // text,
        entries.add( new DataTableEntry( "ChecklistSourceID",           DataTableEntry.INT ) ); // text,
        entries.add( new DataTableEntry( "ChecklistAuthors",            DataTableEntry.STRING ) ); // text,
        entries.add( new DataTableEntry( "ChecklistVersion",            DataTableEntry.STRING ) ); // text,
        entries.add( new DataTableEntry( "ChecklistOriginalURL",	DataTableEntry.STRING ) ); // text,
        entries.add( new DataTableEntry( "ChecklistInstitution",	DataTableEntry.STRING ) ); // text,
        entries.add( new DataTableEntry( "GeographyOriArea",            DataTableEntry.STRING ) ); // text,
        entries.add( new DataTableEntry( "GeographyEdtAreaID",          DataTableEntry.STRING ) ); // text,
            // -- "AcknowledgementID"		   SERIAL   NOT NULL PRIMARY KEY,
        entries.add( new DataTableEntry( "AcknowledgementTitle",        DataTableEntry.STRING ) ); // varchar(100) NOT NULL UNIQUE,
            // -- "InternetPassWord"		   varchar(50) NOT NULL UNIQUE,
        entries.add( new DataTableEntry( "AcknowledgementText",         DataTableEntry.STRING ) ); // varchar(160) NOT NULL,
        entries.add( new DataTableEntry( "AcknowledgementDisplay",      DataTableEntry.INT    ) ); // int2 NOT NULL DEFAULT 1,
        entries.add( new DataTableEntry( "AcknowledgementLinkURL",      DataTableEntry.STRING ) ); // varchar(255) NULL,
        entries.add( new DataTableEntry( "AcknowledgementLinkHidden",   DataTableEntry.BOOL   ) ); // bool NOT NULL DEFAULT 'true',
        entries.add( new DataTableEntry( "AcknowledgementIconWidth",    DataTableEntry.INT    ) ); // int4 NOT NULL DEFAULT 0,	-- nicht gregor
        entries.add( new DataTableEntry( "AcknowledgementIconHeight",   DataTableEntry.INT    ) ); // int4 NOT NULL DEFAULT 0,	-- nicht gregor
        entries.add( new DataTableEntry( "AcknowledgementStyleSheetURL",DataTableEntry.STRING ) ); // varchar(255) NULL,		-- nicht gregor
        entries.add( new DataTableEntry( "AcknowledgementBackgroundGIF",DataTableEntry.STRING ) ); // varchar(255) NULL,		-- nicht gregor
        entries.add( new DataTableEntry( "AcknowledgementNotes",        DataTableEntry.STRING ) ); // text NULL,
        entries.add( new DataTableEntry( "CopyrightText",               DataTableEntry.STRING ) ); // varchar(100) NOT NULL,
        entries.add( new DataTableEntry( "CopyrightDisplay",            DataTableEntry.INT    ) ); // int2 NOT NULL DEFAULT 2,
        entries.add( new DataTableEntry( "CopyrightLinkURL",            DataTableEntry.STRING ) ); // varchar(255) NULL,
        entries.add( new DataTableEntry( "CopyrightLinkHidden",         DataTableEntry.BOOL   ) ); // bool NOT NULL DEFAULT 'true',
        entries.add( new DataTableEntry( "CopyrightNotes",              DataTableEntry.STRING ) ); // text NULL,
        entries.add( new DataTableEntry( "IconURL",                     DataTableEntry.STRING ) ); // varchar(255) NULL,
        entries.add( new DataTableEntry( "IconDisplay",                 DataTableEntry.INT    ) ); // int2 NOT NULL DEFAULT 3,
        entries.add( new DataTableEntry( "IconLinkURL",                 DataTableEntry.STRING ) ); // varchar(255) NULL,
        entries.add( new DataTableEntry( "IconLinkHidden",              DataTableEntry.BOOL   ) ); // bool NOT NULL DEFAULT 'true',
        entries.add( new DataTableEntry( "IconDescription",             DataTableEntry.STRING ) ); // varchar(100) NULL,
        entries.add( new DataTableEntry( "IconInlineWithText",          DataTableEntry.BOOL   ) ); // bool NOT NULL DEFAULT 'true',
        entries.add( new DataTableEntry( "IconWidth",                   DataTableEntry.INT    ) ); // int4 NOT NULL DEFAULT 0,
        entries.add( new DataTableEntry( "IconHeight",                  DataTableEntry.STRING ) ); // int4 NOT NULL DEFAULT 0,
        entries.add( new DataTableEntry( "InternNotesImportNotes",      DataTableEntry.STRING ) ); // text NULL,
        entries.add( new DataTableEntry( "InternNotesResponsible",      DataTableEntry.STRING ) ); // varchar(50) NOT NULL,
        entries.add( new DataTableEntry( "InternNotesLogCreated_User",  DataTableEntry.STRING ) ); // varchar(50) NOT NULL,
        entries.add( new DataTableEntry( "InternNotesProjectMarker",    DataTableEntry.STRING ) ); // varchar(50) NOT NULL,			-- nicht gregor
        entries.add( new DataTableEntry( "InternNotesInternetPassword", DataTableEntry.STRING ) ); // varchar(50) NOT NULL UNIQUE,		-- nicht gregor
        entries.add( new DataTableEntry( "OGU_InformationText",         DataTableEntry.STRING ) ); // text NULL,	-- nicht gregor
        entries.add( new DataTableEntry( "OGU_InformationLinks",        DataTableEntry.STRING ) ); // text NULL	-- nicht gregor
        
        StringBuffer sql    = new StringBuffer();
        StringBuffer values = new StringBuffer();
        boolean firstEntryFlag = true;
        sql.append( "INSERT INTO checklists_header ( " );        
        values.append( "VALUES ( " );        
        
        
        for( int i = 0, listIndex = 0; i < entries.size(); i++ )
        {               
            DataTableEntry entry = ( DataTableEntry ) entries.get( i ); 

            if( entry.getType() == DataTableEntry.SERIAL )
            {
                listIndex++;
                continue;
            }                
            //-------------------------------------
            // don't put empty fields in statment
            //-------------------------------------
            String param = (String) dataFields.get( listIndex++ );
            param = param.trim();
            if( param.length() == 0 )
            {
                continue;
            }
            if( firstEntryFlag )
            {   
                firstEntryFlag = false;
                sql.append( '"' + entry.getName() + '"' + " " );
                values.append( "?" );            
            }    
            else
            {
                sql.append( ", " + '"' + entry.getName()  + '"'  + " " );
                values.append( ", ?" );            
            }
        }
        sql.append( ") " );
        values.append( ")" );
        String cmd = sql.toString() + values.toString();            
        if( debugFlag )
        {    
            logger.debug( cmd );                    
        }                                     
        java.sql.PreparedStatement ps = con.prepareStatement( cmd );            

        int index = 1;            
        int listIndex = 0;                        
        for( int i = 0; i < entries.size(); i++ )
        {               
            DataTableEntry entry = ( DataTableEntry ) entries.get( listIndex );                 
            try
            {
                if( debugFlag )
                {    
                    logger.debug( "entry: " + entry.getName() + " : " + (String) dataFields. get( listIndex ) );
                }    
                String param = (String) dataFields.get( listIndex++ );
                param = param.trim();
                boolean isNullFlag = false;
                if( param.length() == 0 )
                {    
                    continue;   // skip empty fields
                }
                switch( entry.getType() )
                {                    
                    case DataTableEntry.SERIAL:
                        break;
                    case DataTableEntry.STRING:
                            ps.setString( index++, param );
                        break;
                    case DataTableEntry.INT:                    
                            ps.setInt( index++, java.lang.Integer.parseInt( param ) );
                        break;
                    case DataTableEntry.LONG:                
                            ps.setLong( index++, java.lang.Long.parseLong( param ) );
                        break;
                    case DataTableEntry.DOUBLE:                
                            ps.setDouble( index++, java.lang.Double.parseDouble( param ) );
                        break;
                    case DataTableEntry.BOOL:                
                            ps.setBoolean( index++, java.lang.Boolean.getBoolean( param ) );
                        break;
                    default:            
                        logger.error( "Prepare Statement: invalid type"  );
                }
            }
            catch( java.lang.Exception ex )
            {
                logger.error( ex.getMessage(), ex.fillInStackTrace() );
                logger.error( "Error: build PreparedStatement entry " + entry.getName() );

                throw new java.sql.SQLException();
            }
        }            
        if( debugFlag )
        {
            logger.debug( "Write header into database" );
        }    
        ps.execute();            
        ps.close();            
    }
    //--------------------------------------------------------------------------
    // XML-DATA-LINE-INPUT
    //--------------------------------------------------------------------------    
    public void insertXmlDataLine( java.sql.Connection con, Vector dataFields ) throws java.sql.SQLException
    {
        boolean debugFlag = false;
        StringBuffer sql    = new StringBuffer();
        StringBuffer values = new StringBuffer();
        Vector entries = new Vector();
        
        entries.add( new DataTableEntry( "id",              DataTableEntry.SERIAL ) ); 
        entries.add( new DataTableEntry( "ChecklistId",     DataTableEntry.LONG   ) ); 
        entries.add( new DataTableEntry( "Unit",            DataTableEntry.LONG   ) ); 
        entries.add( new DataTableEntry( "Entry",           DataTableEntry.LONG   ) ); 
        entries.add( new DataTableEntry( "Code",            DataTableEntry.STRING ) ); 
        entries.add( new DataTableEntry( "SynLevel",        DataTableEntry.LONG   ) );
        entries.add( new DataTableEntry( "Genus",           DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "Species",         DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "Rank",            DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "InfraspecificEpithet",  DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "First",           DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "Author",          DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "Suffix",          DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "Status",          DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "ConceptNote",     DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "IdQual",          DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "TaxonRef",        DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "FlorRef",         DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "Typus",           DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "GeoUnit",         DataTableEntry.STRING ) );
        entries.add( new DataTableEntry( "Notes",           DataTableEntry.STRING ) );
        // entries.add( new DataTableEntry( "",  DataTableEntry.STRING ) ); // text,
        
        insertXmlDataLineDatabaseTable( con, "checklists_data", entries, dataFields );        
    }    
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public void insertXmlDataLineDatabaseTable( java.sql.Connection con, String tableName, Vector entries, Vector dataFields ) throws java.sql.SQLException
    {
        boolean debugFlag = false;
        StringBuffer sql    = new StringBuffer();
        StringBuffer values = new StringBuffer();
        boolean firstEntryFlag = true;
                
        java.sql.PreparedStatement ps = null;

        sql.append( "INSERT INTO " + tableName + " ( " );        
        values.append( "VALUES ( " );        
                
        for( int i = 0, listIndex = 0; i < entries.size(); i++ )
        {               
            DataTableEntry entry = ( DataTableEntry ) entries.get( i ); 

            if( entry.getType() == DataTableEntry.SERIAL )
            {
                listIndex++;
                continue;
            }                
            //-------------------------------------
            // don't put empty fields in statment
            //-------------------------------------
            String param = (String) dataFields.get( listIndex++ );
            param = param.trim();
            if( param.length() == 0 )
            {
                continue;
            }
            if( firstEntryFlag )
            {   
                firstEntryFlag = false;
                sql.append( '"' + entry.getName() + '"' + " " );
                values.append( "?" );            
            }    
            else
            {
                sql.append( ", " + '"' + entry.getName()  + '"'  + " " );
                values.append( ", ?" );            
            }
        }
        sql.append( ") " );
        values.append( ")" );
	try
	{
            String cmd = sql.toString() + values.toString();
            if( debugFlag )
            {
                logger.debug( cmd );                    
            }                                                 
	    ps = con.prepareStatement( cmd );            
            
            int index = 1;            
            int listIndex = 0;                        
            for( int i = 0; i < entries.size(); i++ )
            {               
                DataTableEntry entry = ( DataTableEntry ) entries.get( listIndex );                 
                try
                {
                    if( debugFlag )
                    {
                        logger.debug( "entry: " + entry.getName() + " : " + (String) dataFields. get( listIndex ) );
                    }
                    String param = (String) dataFields.get( listIndex++ );
                    param = param.trim();
                    boolean isNullFlag = false;
                    if( param.length() == 0 )
                    {    
                        continue;   // skip empty fields
                    }
                    switch( entry.getType() )
                    {                    
                        case DataTableEntry.SERIAL:
                            break;
                        case DataTableEntry.STRING:
                                ps.setString( index++, param );
                            break;
                        case DataTableEntry.INT:                    
                                ps.setInt( index++, java.lang.Integer.parseInt( param ) );
                            break;
                        case DataTableEntry.LONG:                
                                ps.setLong( index++, java.lang.Long.parseLong( param ) );
                            break;
                        case DataTableEntry.DOUBLE:                
                                ps.setDouble( index++, java.lang.Double.parseDouble( param ) );
                            break;
                        case DataTableEntry.BOOL:                
                                ps.setBoolean( index++, java.lang.Boolean.getBoolean( param ) );
                            break;
                        default:            
                            logger.error( "Prepare Statement: invalid type"  );
                    }
                }
                catch( java.lang.Exception ex )
                {
                    logger.error( "Error: build PreparedStatement entry " + entry.getName() );
                    logger.error( ex.getMessage(), ex.fillInStackTrace() );
                    
                    throw new java.sql.SQLException();
                }
            }            
            ps.execute();            
	}
        finally
        {
            if( ps != null ) ps.close();            
        }
    }
/*    
    //--------------------------------------------------------------------------
    // Read checklist data for ChecklistTable
    //--------------------------------------------------------------------------
    public ChecklistTable readChecklistData()
    {
        boolean debugFlag = false;
        Vector data     = new Vector();
        Vector lineData;
        int line = 0;
	try
	{
	    String cmd = "SELECT genus, species, subspecies, first_name_id, name_id FROM first_list;";
	    Connection con = connect();
	    Statement stmt = con.createStatement();
	    if( debugFlag ) 
            {
                logger.debug( cmd );
            }
	    ResultSet rs = stmt.executeQuery( cmd );
	    if( debugFlag ) 
            {
                logger.debug( "result:" );
            }
	    while( rs.next() == true  )
	    {
		try
		{
                    lineData = new Vector( 5 );

                    if( line >= 9999 ) break;

		    lineData.add( rs.getString( 1 ) );
		    lineData.add( rs.getString( 2 ) );
		    lineData.add( rs.getString( 3 ) );
		    lineData.add( rs.getString( 4 ) );
		    lineData.add( rs.getString( 5 ) );
                    line++;

                    data.add( lineData );
		}
		catch( Exception ex )
		{
                    logger.error( ex.getMessage(), ex.fillInStackTrace() );
		}
	    }
	    stmt.close();
	    con.close();

	}
	catch( Exception ex )
	{
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
	}
        return new ChecklistTable( data );
    }    
*/    
    //--------------------------------------------------------------------------
    // Get Table for Gis data visualisation
    //--------------------------------------------------------------------------
    public StringBuffer readGisData() throws java.sql.SQLException
    {
        boolean debugFlag = false;
        boolean newLineFlag = false;
        StringBuffer buffer = new StringBuffer( 1000000 );
        
	Connection con = connect();
	Statement stmt = con.createStatement();
            
	try
	{
	    String cmd = "SELECT DISTINCT \"Genus\", \"Species\", \"ChecklistId\" FROM \"checklists_data\"  WHERE \"Code\" LIKE 'a%' ORDER BY \"Genus\", \"Species\", \"ChecklistId\" ASC;";
	    if( debugFlag ) 
            {
                logger.debug( cmd );
            }
	    ResultSet rs = stmt.executeQuery( cmd );
	    if( debugFlag ) 
            {
                logger.debug( "result:" );
            }
            String seperator = ",";
            
            String genus   = "";
            String species = "";
            String gettyId = "";
            
            String lastGenus   = "";
            String lastSpecies = "";
            
	    while( rs.next() == true  )
	    {
                newLineFlag = false;
		try
		{
		    genus   = rs.getString( 1 );
		    species = rs.getString( 2 );
		    gettyId = rs.getString( 3 );
                  
                    if( genus == null || species == null || gettyId == null )
                    {
                        logger.info( "ERROR: " + genus + " " + species + " " + gettyId   );                            
                        continue;
                    }
                    
                    if( lastGenus.compareTo( genus ) != 0 )
                    {
                        lastGenus = genus;
                        newLineFlag = true;
                        buffer.append( "\n" );
                    }
                    if( lastSpecies.compareTo( species ) != 0 )
                    {
                        lastSpecies = species;
                        if( ! newLineFlag )
                        {    
                            newLineFlag = true;
                            buffer.append( "\n" );
                        }
                    }
                    if( newLineFlag )
                    {
                        buffer.append( genus + " " + species + seperator + gettyId );
                        if( debugFlag ) 
                        {
                            logger.debug( "\n" );
                            logger.debug( genus + " " + species + seperator + gettyId  );
                        }
                    }
                    else
                    {
                        buffer.append( seperator + gettyId );
                        if( debugFlag ) 
                        {
                            logger.debug( seperator + gettyId );
                        }
                    }                        
		}
		catch( Exception ex )
		{
                    logger.error( ex.getMessage(), ex.fillInStackTrace() );
		}
	    }
	}
        /*
	catch( Exception ex )
	{
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
	}
         */
        finally
        {            
	    stmt.close();
	    con.close();
        }
        return buffer;
    }
    //--------------------------------------------------------------------------
    // Get Table for Gis cross data table visualisation
    //--------------------------------------------------------------------------
    public StringBuffer readGisCrossData() throws java.sql.SQLException
    {
        boolean debugFlag       = false;
        boolean newLineFlag     = false;
        boolean firstLineFlag   = true;
        StringBuffer buffer = new StringBuffer( 1000000 );
        String seperator = " ";
        
        Connection con = connect();
        Statement stmt = con.createStatement();
        
	try
	{
            //------------------------------------------------------------------
            // get all locations, store locations in Vector "checklistsId"
            //------------------------------------------------------------------
	    String cmd = "SELECT DISTINCT \"ChecklistSourceID\" FROM \"checklists_header\"  ORDER BY \"ChecklistSourceID\" ASC;";
            
	    if( debugFlag ) 
            {
                logger.debug( cmd );
            }
	    ResultSet rs = stmt.executeQuery( cmd );
            int id = 0;
            java.util.Vector checklistsId = new java.util.Vector();
            boolean nextFlag = false;
            // write all locations into the first line
	    while( rs.next() == true  )
	    {
		try
		{
                    id = rs.getInt( 1 );
                    checklistsId.add( new java.lang.Integer( id ) );
                    if( nextFlag )
                    {
                        buffer.append( seperator + id );
                    }
                    else
                    {
                        // buffer.append( "Locations" + seperator + id );
                        buffer.append( id );
                    }
                }
		catch( Exception ex )
		{
                    logger.error( ex.getMessage(), ex.fillInStackTrace() );
		}
                nextFlag = true;
            }                
            buffer.append( "\n" );
            //------------------------------------------------------------------
            // get checklists entries and build table
            //------------------------------------------------------------------
            cmd = "SELECT DISTINCT \"Genus\", \"Species\", \"ChecklistId\" FROM \"checklists_data\"  WHERE \"Code\" LIKE 'a%' ORDER BY \"Genus\", \"Species\", \"ChecklistId\" ASC;";
	    if( debugFlag ) 
            {
                logger.debug( cmd );
            }
	    rs = stmt.executeQuery( cmd );
	    if( debugFlag ) 
            {
                logger.debug( "result:" );
            }
            
            String genus   = "";
            String species = "";
            int    gettyId = -1;
            
            String lastGenus   = "";
            String lastSpecies = "";
            
            int thisIndex;
            int lastIndex = 0;
	    while( rs.next() == true  )
	    {
                newLineFlag = false;
		try
		{
		    genus   = rs.getString( 1 );
		    species = rs.getString( 2 );
		    gettyId = rs.getInt( 3 );
                  
                    if( genus == null || species == null || gettyId == -1 )
                    {
                        logger.info( "ERROR: " + genus + " " + species + " " + gettyId   );                            
                        continue;
                    }                    
                    if( lastGenus.compareTo( genus ) != 0 )
                    {
                        lastGenus = genus;
                        newLineFlag = true;
                    }
                    if( lastSpecies.compareTo( species ) != 0 )
                    {
                        lastSpecies = species;
                        if( ! newLineFlag )
                        {    
                            newLineFlag = true;
                        }
                    }
                    if( newLineFlag )
                    {
                        // first we will finish the last written line
                        if( ! firstLineFlag )
                        {
                            for( int i = lastIndex + 1; i < checklistsId.size(); i++ )
                            {
                                buffer.append( seperator + "0" );
                            }
                            buffer.append( "\n" );
                        }
                        else
                        {
                            firstLineFlag = false;
                        }
                        // start next line whis "genus" + "species"
                        lastIndex = 0;
                        buffer.append( "\"" + genus + " " + species + "\"" );
                        
                        thisIndex = checklistsId.indexOf( new java.lang.Integer( gettyId ) );
                        
                        for( int i = lastIndex; i < thisIndex; i++ )
                        {
                            buffer.append( seperator + "0" );
                        }
                        buffer.append( seperator + "1" );
                        lastIndex = thisIndex;
                    }
                    else
                    {
                        thisIndex = checklistsId.indexOf( new java.lang.Integer( gettyId ) );
                        
                        for( int i = lastIndex +1; i < thisIndex; i++ )
                        {
                            buffer.append( seperator + "0" );
                        }
                        buffer.append( seperator + "1" );
                        lastIndex = thisIndex;
                    }                        
		}               
		catch( Exception ex )
		{
                    logger.error( ex.getMessage(), ex.fillInStackTrace() );
		}
	    }
            // now readall resultsets are finish, we have to complied the last output line.
            for( int i = lastIndex + 1; i < checklistsId.size(); i++ )
            {
                buffer.append( seperator + "0" );
            }
            buffer.append( "\n" );
	}
        finally
        {
	    stmt.close();
	    con.close();            
        }
        return buffer;
    }    
}
