package net.metadiversity.diversity.navigator.connection;

import java.awt.*;
// import java.util.*;

import javax.swing.*;
// import javax.swing.tree.*;

import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.*;
import net.metadiversity.diversity.navigator.gui.DnOptionPane;
import net.metadiversity.diversity.navigator.gui.DnMenuItem;
import net.metadiversity.diversity.navigator.db.*;

public class ConnectionsPane extends JPanel 
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 4049354201802814514L;

    static Logger logger = Logger.getLogger( ConnectionsPane.class.getName() );
    
    DiversityNavigator mainWindow;

    DBTreeModel dbTreeModel = null;
        
    javax.swing.JTree       databaseTree;
        
    javax.swing.JPopupMenu  popConnections;
    javax.swing.JPopupMenu  popDatabase;
    javax.swing.JPopupMenu  popTable;
        
    javax.swing.JScrollPane sp;

    public ConnectionsPane() 
    {
        super();
        logger.debug( "ConnectionsPane()" );
        setLayout( new BorderLayout() );
                                
        dbTreeModel = new DBTreeModel( this );   
        databaseTree = new JTree( dbTreeModel );
        databaseTree.setCellRenderer( new DBTreeCellRenderer() );
        databaseTree.addMouseListener( new java.awt.event.MouseListener() 
        {
            public void mouseClicked( java.awt.event.MouseEvent e) {}
            public void mouseEntered( java.awt.event.MouseEvent e) {}
            public void mouseExited(  java.awt.event.MouseEvent e) {}
            public void mousePressed( java.awt.event.MouseEvent e) 
            {
                // logger.debug( "mousePressed( " + e.getModifiers() + " )" );
                // Apple Mac used (ALT) ??? mouse for right butten simulation
                if( ( e.getModifiers() & java.awt.event.InputEvent.BUTTON3_MASK ) == java.awt.event.InputEvent.BUTTON3_MASK ||
                    ( e.getModifiers() & java.awt.event.InputEvent.BUTTON2_MASK ) == java.awt.event.InputEvent.BUTTON2_MASK   
                  )
                    
                {    
                    rightClick( e.getX(), e.getY() );
                }
            }
            public void mouseReleased( java.awt.event.MouseEvent e) {}
        });
                
        sp = new JScrollPane( databaseTree );
        add( sp, BorderLayout.CENTER );
                
        //--------------------------------------------------------------
        // create popup menus
        //--------------------------------------------------------------
        popConnections                  = new JPopupMenu( "Connections" );
        popDatabase                     = new JPopupMenu( "Connection" );
        popTable                        = new JPopupMenu( "Table" );
/* Use DnMenuItem
 *                                
        JMenuItem mnAddConnection       = new JMenuItem( "Add new connection", java.awt.event.KeyEvent.VK_A );
        JMenuItem mnEditConnection      = new JMenuItem( "Edit connection properties", java.awt.event.KeyEvent.VK_E );
        JMenuItem mnDeleteConnection    = new JMenuItem( "Delete this connection", java.awt.event.KeyEvent.VK_D );
                
        mnAddConnection.setIcon( DiversityNavigatorProperties.getMenuIconAddConnection() );
        mnEditConnection.setIcon( DiversityNavigatorProperties.getMenuIconEditConnection() );
        mnDeleteConnection.setIcon( DiversityNavigatorProperties.getMenuIconDelConnection() );
 *
        JMenuItem mnQuery               = new JMenuItem( "Open Query Builder", java.awt.event.KeyEvent.VK_O );
        JMenuItem mnEditRows            = new JMenuItem( "Edit table rows", java.awt.event.KeyEvent.VK_E );
  */
        DnMenuItem mnAddConnection       = new DnMenuItem( "connection.add"     );
        DnMenuItem mnEditConnection      = new DnMenuItem( "connection.edit"    );
        DnMenuItem mnDeleteConnection    = new DnMenuItem( "connection.delete"  );
        
        DnMenuItem mnQuery               = new DnMenuItem( "connection.query_builder" );
        DnMenuItem mnEditRows            = new DnMenuItem( "connection.edit_table" );
                                
        mnAddConnection.addActionListener( new java.awt.event.ActionListener() 
        {
            public void actionPerformed( java.awt.event.ActionEvent ev ) 
            {
                logger.debug( "AddConnection actionPerformd " + ev.toString() ); 
                addConnection();
            }
        });                
                
        mnEditConnection.addActionListener( new java.awt.event.ActionListener() 
        {
            public void actionPerformed( java.awt.event.ActionEvent ev ) 
            {
                logger.debug( "EditConnection actionPerformd " + ev.toString() ); 
                editConnection();
            }
        });
            
        mnDeleteConnection.addActionListener( new java.awt.event.ActionListener() 
        {
            public void actionPerformed( java.awt.event.ActionEvent ev ) 
            {
                logger.debug( "DeleteConnection actionPerformd " + ev.toString()  ); 
                deleteConnection();
            }
        });
                
        mnQuery.addActionListener( new java.awt.event.ActionListener() 
        {
            public void actionPerformed( java.awt.event.ActionEvent ev ) 
            {
                logger.debug( "Query actionPerformd " + ev.toString()  ); 
                openQuery();
            }
        });
            
        mnEditRows.addActionListener( new java.awt.event.ActionListener() 
        {
            public void actionPerformed( java.awt.event.ActionEvent ev ) 
            {
                logger.debug( "EditRows actionPerformd " + ev.toString()  ); 
                editTable();
            }
        });
                
        popConnections.add( mnAddConnection    );                
        popDatabase.add(    mnEditConnection   );
        popDatabase.add(    mnDeleteConnection );
        popDatabase.add(    new JSeparator()   );
        popDatabase.add(    mnQuery            );
                
        popTable.add(       mnEditRows);
    }
    //----------------------------------------------------------------------
    //----------------------------------------------------------------------
    /**
     * @param window
     */    
    public void setMainWindow( DiversityNavigator window )
    {
        mainWindow = window;
    }
    /**
     * @return
     */    
    public DiversityNavigator getMainWindow() 
    {
        return mainWindow;
    }
    //----------------------------------------------------------------------
    /**
     * @return
     */    
    public ConnectionInfo getConnectionInfo() 
    {
        if( databaseTree.getSelectionPath() == null ) 
        {
            return null;
        }
        DBNode Sel = ( DBNode ) databaseTree.getSelectionPath().getLastPathComponent();
        return Sel.getConnectionInfo();
    }

    /**
     * @return
     */    
    public java.sql.Connection getConnection() 
    {
        if( databaseTree.getSelectionPath() == null ) 
        {
            return null;
        }
        DBNode Sel = ( DBNode ) databaseTree.getSelectionPath().getLastPathComponent();
        return Sel.getConnection();
    }

    /**
     * @return
     */    
    public String getTable() 
    {
        if( databaseTree.getSelectionPath() == null ) 
        {
            return null;
        }
        DBNode Sel = (DBNode)databaseTree.getSelectionPath().getLastPathComponent();
        return Sel.getTable();
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    private void rightClick(int xx,int yy) 
    {
        // logger.debug( "rightClick( " + xx + "," + yy +" )"  );
	if( databaseTree.getSelectionPath() == null ) 
        {
            return;
        }
	int x = xx - sp.getHorizontalScrollBar().getValue();
	int y = yy - sp.getVerticalScrollBar().getValue();
	DBNode Sel = ( DBNode ) databaseTree.getSelectionPath().getLastPathComponent();
        
	if( Sel == null ) 
        {
            return;
        }
	if( Sel.getNodeType() == DBNode.NODE_TYPE_CAPTION_CONNECTIONS ) popConnections.show( this, x,y );
	if( Sel.getNodeType() == DBNode.NODE_TYPE_DATABASE            ) popDatabase.show( this, x,y );
	if( Sel.getNodeType() == DBNode.NODE_TYPE_TABLE               ) popTable.show( this, x,y );
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public void addConnection() 
    {
	ConnectionDialog conDialog = new ConnectionDialog(null);
	conDialog.setModal(true);
	conDialog.setVisible( true );
	if( conDialog.getOK() ) 
        {
            try 
            {
		ConnectionsManager.addConnection( conDialog.getName(), conDialog.getDescription(), conDialog.getDriver(), conDialog.getUrl(), conDialog.getUser(), conDialog.getPwd() );
            } 
            catch( Exception ex ) 
            {
                logger.error( ex.getMessage(), ex.fillInStackTrace() );
            }
            dbTreeModel.reload();
	}
    }
    
    public void editConnection() 
    {
        ConnectionInfo ci = getConnectionInfo();
        if (ci == null) return;
        ConnectionDialog conDialog = new ConnectionDialog(ci);
        conDialog.setModal(true);
        conDialog.setVisible( true );
        if( conDialog.getOK() ) 
        {
            try                         
            {
                ConnectionsManager.changeConnection( conDialog.getName(), conDialog.getDescription(), conDialog.getDriver(), conDialog.getUrl(), conDialog.getUser(), conDialog.getPwd() );
            } 
            catch( Exception ex ) 
            {
                logger.error( ex.getMessage(), ex.fillInStackTrace() );
            }
            dbTreeModel.reloadSubTree((DBNode)databaseTree.getSelectionPath().getLastPathComponent());
        }
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public void deleteConnection() 
    {
        ConnectionInfo ci = getConnectionInfo();
        if( ci == null ) return;
        if( DnOptionPane.showConfirmDialog( null, "Do you really want to delete this connection: " + ci.getName(), "Confirmation", DnOptionPane.YES_NO_OPTION ) == DnOptionPane.OK_OPTION )
        {
            try 
            {
                    ConnectionsManager.deleteConnection( ci.getName() );
            } 
            catch( Exception ex ) 
            {
                    logger.error( ex.getMessage(), ex.fillInStackTrace() );
            }
            dbTreeModel.reloadSubTree((DBNode)databaseTree.getSelectionPath().getLastPathComponent());
        }
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    private void openQuery() 
    {
        ConnectionInfo ci = getConnectionInfo();
        if( ci == null ) 
        {
            return;
        }
        java.sql.Connection con = getConnection();
        if( con == null ) 
        {
            return;
        }
        getMainWindow().openQuery( ci, con );
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    private void editTable() 
    {
        String TableName = getTable();
        if( TableName == null )
        {
            return;
        }
        ConnectionInfo ci = getConnectionInfo();
        if( ci == null ) 
        {
            return;
        }
        java.sql.Connection con = getConnection();
        if( con == null ) 
        {    
            return;
        }
        getMainWindow().openTable( ci, con, TableName );
    }
}