/*
 * TaxonomySynonymy.java
 *
 * Created on 2. Juni 2004, 17:49
 */

package net.metadiversity.diversity.navigator.db.diversity_names_lias;

import java.util.Date;

/**
 *
 * @author  didi
 */
public class TaxonomySynonymy
{
    private long    SynID;          // Autonum Unique ID.
    private long    TaxonID;        // Synonym name. Refers currently directly to a NomID rather than to a Taxon (-concept)-ID.
    private long    DisplayOrder;   // Original order in synonymization reference. Number defining the sequence within an accepted name.
                                    // Default value: 0
    private String  OriOrganismName;// Name exactly as it appear in the synonymization source.
    private String  OriNote;        // A note of the responsible person concerning this synonymization that will be output in a report, e.g. 'fide Author 1999'.
    private long    AcceptedTaxonID;// ID of accepted name for the current name. Refers currently directly to a NomID rather than to a Taxon (-concept)-ID, use identical SynRef to convert.
    private String  SynRefID;       // ReferenceID: Source publication where synonymization is published (not publication of name!).
    private String  SynRefCitation; // Free citation, esp. where a RefID is missing. Source publication where synonymization is published (not publication of name!).
    private String  SynRefDetail;   // esp. page number on which the synonymization is published.
    private String  TypistsNotes;   // An internal note of the responsible person concerning this synonymization. This information is NOT included in any report.
    private long    LogCreatedBy;   // Name of user who first entered (typed or imported) the data. This is the operator (or typist) name, which may be different from the person responsible.
    private Date    LogCreatedWhen; // Date and time when record was first entered (typed or imported) into this system.
                                    // Default value: Now()
    private long    LogUpdatedBy;   // Name of user who last updated the data. This is the operator (or typist) name, which may be different from the person responsible.
    private Date    LogUpdatedWhen; // Date and time when record was last updated.
                                    // Default value: Now()

    /*
    Index name:
    Attributes & index properties
    AcceptedTaxonID:
    AcceptedTaxonID (Duplicates OK)
    LogCreatedBy:
    LogCreatedBy (Duplicates OK)
    LogUpdatedBy:
    LogUpdatedBy (Duplicates OK)
    NomID:
    TaxonID (Duplicates OK)
    PrimaryKey:
    SynID (Primary key; Unique values)
    RefID:
    SynRefID (Duplicates OK)
    SynRefCitation:
    SynRefCitation (Duplicates OK)
    Relation type:
    Fields involved
    Referential integrity
    TaxonomyName.NameID  TaxonomySynonymy.TaxonID
    Referential integrity
    TaxonomyName.NameID  TaxonomySynonymy.AcceptedTaxonID
    Updates cascade
    TaxonomySynonymyRefs.SynRefID  TaxonomySynonymy.SynRefID
    */  
    /** Creates a new instance of TaxonomySynonymy */
    public TaxonomySynonymy()
    {
    }
    
}
