/*
 * UbtCollectionMainFrame.java
 *
 * Created on 15. Januar 2003, 19:58
 */

package net.metadiversity.diversity.navigator.db.ub;

import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.connection.ConnectionInfo;

import net.metadiversity.diversity.navigator.db.CollectionBayreuthHibernate;
import net.metadiversity.diversity.navigator.gui.DnOptionPane;
/**
 * UBT Diversity Collection Forms (Luciana Version 98)
 *
 * Top      Header ( Informations ans image properties (zoom) )
 *          Image ( if avalible ) ScrollPane
 * Botton   component the form TabSheets
 *          component the selector for the ColletionSpecimen Entries
 *
 * @author  didi
 */
public class UbtCollectionMainFrame extends javax.swing.JPanel // javax.swing.JInternalFrame //javax.swing.JFrame // 
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3977866167757254964L;

    static Logger logger = Logger.getLogger( UbtCollectionMainFrame.class );
    
    UbtCollectionHeader     header;
    javax.swing.JPanel      image;
    UbtCollectionTabs_096   tabs;
    DnDataRecordSelector    records;

    private javax.swing.JPanel      bottonPanel;
    private javax.swing.JPanel      topPanel;    
    private javax.swing.JSplitPane  splitPane;

    net.metadiversity.diversity.navigator.db.CollectionBayreuthHibernate collection;
    
    static final boolean USE_HIBERNATE = true;
    
    /** Creates a new instance of UbtCollectionMainFrame */
    public UbtCollectionMainFrame( ConnectionInfo ci )
    {        
        try
        {
            if( USE_HIBERNATE )
            {
                collection = new CollectionBayreuthHibernate( ci, this );                
            }
        }
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
            DnOptionPane.showMessageDialog( null, "Can't connect to " + ci.getUrl(), "Error" , DnOptionPane.ERROR_MESSAGE );
            return;
        }    
        initComponents();
        try
        {
            long count = collection.getCollectionSpecimenCount();
            System.out.println( "Entries : " +  count );
            records.setRecordMaxValue( count );
            setVisible( true );
        }
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
            DnOptionPane.showMessageDialog( null, "Hibernate error while using " + ci.getUrl(), "Error" , DnOptionPane.ERROR_MESSAGE );
            return;
        }    
    }
    //--------------------------------------------------------------------------
    private void initComponents() 
    {        
        // Header
        header = new UbtCollectionHeader();        
        // image ---------------------------------------------------------------
        // image = new UbtCollectionImage();
        
        java.net.URL imageUrl = null;
        imageUrl = getClass().getResource( "/net/metadiversity/diversity/navigator/images/dn.gif" );

//            String file = "./dn-cvs-096/dncode/net/metadiversity/diversity/navigator/images/dn.gif";
//            iv = new ImageViewer( new java.net.URL( "file:" + file ) );
        
/*        
        try
        {
        }
        catch( java.net.MalformedURLException ex )
        {
            logger.error( ex );
        }
 */
        image = new net.metadiversity.diversity.navigator.gui.ImageViewer( imageUrl );
        
        
        topPanel = new javax.swing.JPanel();
        
        topPanel.setLayout( new java.awt.BorderLayout() );
        topPanel.add( header, java.awt.BorderLayout.NORTH );        
        topPanel.add( image, java.awt.BorderLayout.CENTER );        
        // add( topPanel, java.awt.BorderLayout.NORTH );
        
        // bottom --------------------------------------------------------------
        records = new DnDataRecordSelector();
        tabs    = new UbtCollectionTabs_096( records, collection, header );
        
        bottonPanel = new javax.swing.JPanel();
        // bottonPanel.setPreferredSize( new java.awt.Dimension( 640, 300 ) );
        bottonPanel.setLayout( new java.awt.BorderLayout() );
        bottonPanel.add( tabs, java.awt.BorderLayout.CENTER );
        bottonPanel.add( records, java.awt.BorderLayout.SOUTH );
        // add( bottonPanel, java.awt.BorderLayout.SOUTH );
                        
        splitPane = new javax.swing.JSplitPane();
        
        splitPane.setOrientation( javax.swing.JSplitPane.VERTICAL_SPLIT );
        splitPane.setResizeWeight( 0.5 );
        splitPane.setOneTouchExpandable( true );
        splitPane.setLeftComponent(  topPanel    );
        splitPane.setRightComponent( bottonPanel );
        // splitPane.setContinuousLayout( true );
        // We neat a BorderLayout, so the component can be resized
        setLayout( new java.awt.BorderLayout() );
        add( splitPane, java.awt.BorderLayout.CENTER );

    }
    //--------------------------------------------------------------------------
    
    /**
     * Only for delopment Software test.
     *
     * Not used in the DieversityNavigator
     *
     * @param args the command line arguments
     */
    public static void main(String args[]) 
    {
        javax.swing.JFrame frame = new javax.swing.JFrame();

        net.metadiversity.diversity.navigator.connection.ConnectionInfo ci;
        
        ci = new ConnectionInfo( "name", "Description", "org.postgresql.Driver", "jdbc:postgresql://192.168.1.12:5432/DiversityCollection_BIOTAlichencoll", "didi", "Zu4K73az" );
        
        UbtCollectionMainFrame cf = new UbtCollectionMainFrame( ci );        
        
        try
        {
            frame.getContentPane().add( cf );
            frame.pack();
            frame.setVisible( true );
        }
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
        }    
    }    
}
