/*
 * CollectionTabIndentification.java
 *
 * Created on 15. September 2004, 11:39
 */

package net.metadiversity.diversity.navigator.gui;

import com.jgoodies.forms.layout.*;
import com.jgoodies.forms.layout.ColumnSpec;

import net.metadiversity.diversity.navigator.db.ub.DnDataRecordSelector;

/**
 *
 * @author  didi
 */
public class CollectionTabImages extends com.jgoodies.forms.builder.PanelBuilder
{
    // form format strings
    String columnFormatString   = "";
    String rowFormatString      = "";
    
    com.jgoodies.forms.builder.PanelBuilder     builder;
    // default format values
    static final String DEFAULT_COLUMNE_FORMAT = "fill:d:grow";
    static final String PAD_COLUMNE_FORMAT     = "fill:3dlu:nogrow";
    static final String DEFAULT_ROW_FORMAT     = "fill:d:nogrow";
    static final String PAD_ROW_FORMAT         = "fill:3dlu:nogrow";    
    // Form parameter
    int xMaxFormPos;
    int yMaxFormPos;
    // debug
    boolean DEBUG_ADD_COMPONENT = false;
    boolean DEBUG_LINE_AND_ROW_NUMBERS = false;
    //
    CellConstraints cc;

    public DnDataRecordSelector        imageRecords;
    
    public void showLineNumbers( boolean b )
    {
        DEBUG_LINE_AND_ROW_NUMBERS = b;
    }
    
    public CollectionTabImages()
    {
        super( new com.jgoodies.forms.layout.FormLayout( "", "" ) );
        showLineNumbers( false );
        cc = new CellConstraints();
        xMaxFormPos = 9;
        yMaxFormPos = 10;
        
        ColumnSpec colPad = new com.jgoodies.forms.layout.ColumnSpec( PAD_COLUMNE_FORMAT );              
        ColumnSpec colDef = new com.jgoodies.forms.layout.ColumnSpec( DEFAULT_COLUMNE_FORMAT );              
        
        RowSpec rowPad = new com.jgoodies.forms.layout.RowSpec( PAD_ROW_FORMAT );              
        RowSpec rowDef = new com.jgoodies.forms.layout.RowSpec( DEFAULT_ROW_FORMAT );              
        
        if( DEBUG_LINE_AND_ROW_NUMBERS )
        {
            appendColumn( colDef );
            appendRow( rowDef );
        }
        else
        {
            appendColumn( colPad );
            appendRow( rowPad );                
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            appendColumn( colDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && col == xMaxFormPos )
            {
                appendColumn( colDef );
            }
            else
            {
                appendColumn( colPad );
            }
        }
        for( int row = 1; row <= yMaxFormPos; row++ )
        {   
            appendRow( rowDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && row == yMaxFormPos )
            {
                appendRow( rowDef );
            }
            else
            {
                appendRow( rowPad );                   
            }
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // Set line numbers 
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l1, cc.xy( 1 , row * 2 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l2, cc.xy( xMaxFormPos * 2 + 1, row * 2 ) );
            }
            else
            {
                javax.swing.JLabel l1 = new javax.swing.JLabel( " " );
                add( l1, cc.xy( 1 , row * 2 ) );                
            }
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // set column numbers
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l1, cc.xy( col * 2, 1 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l2, cc.xy( col * 2, yMaxFormPos * 2 + 1 ) );
            }
        }
        if( ! DEBUG_LINE_AND_ROW_NUMBERS )
        {
        }        
        
        //----------------------------------------------------------------------
        // Add Record selector 
        //----------------------------------------------------------------------
        imageRecords  = new DnDataRecordSelector();
        
        java.awt.GridBagConstraints gridBagConstraints;
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        add( imageRecords, gridBagConstraints );
                
        initComponents();                
        // Scrollbar not avilible for "text/plane"
        // jTextPaneLocalityHabitat.setContentType( "text/html" );
        // jTextPaneLocalityProblems.setContentType( "text/html" );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void debug( int x, int y, int l, int h )
    {
        System.out.println( "x: " + x +  " \ty: " + y + " \tl:" + l );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void setLayout( java.awt.LayoutManager lm )
    {
        
    }
    void add( javax.swing.JComponent c, java.awt.GridBagConstraints gbc )    
    {
        cc = new CellConstraints();
        System.out.println( c );
        // Don't show Lable outside the form
        if( gbc.gridx > xMaxFormPos || gbc.gridy > yMaxFormPos )
        {
            return;
        }
        cc.xywh( ( gbc.gridx + 1 ) * 2, ( gbc.gridy + 1 ) * 2, ( gbc.gridwidth * 2 ) -1, ( gbc.gridheight * 2 ) -1 );
        System.out.println( cc );        
        add( c, cc );
        
    }
    /** This method is called from within the constructor to     
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabelFolder = new javax.swing.JLabel();
        jTextFieldFolder = new javax.swing.JTextField();
        jLabelPath = new javax.swing.JLabel();
        jTextFieldPath = new javax.swing.JTextField();

        setLayout(new java.awt.GridBagLayout());

        jLabelFolder.setText("Folder for all images in this database:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(jLabelFolder, gridBagConstraints);

        jTextFieldFolder.setText("Folder");
        jTextFieldFolder.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jTextFieldFolderActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldFolder, gridBagConstraints);

        jLabelPath.setText("Path and filename within the folder:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelPath, gridBagConstraints);

        jTextFieldPath.setText("Path");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldPath, gridBagConstraints);

    }//GEN-END:initComponents

    private void jTextFieldFolderActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jTextFieldFolderActionPerformed
    {//GEN-HEADEREND:event_jTextFieldFolderActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldFolderActionPerformed
    
    public static void main( String [] args  )
    {
        CollectionTabImages p = new CollectionTabImages();
        javax.swing.JFrame f = new javax.swing.JFrame();        
        f.getContentPane().add( p.getPanel() );
        f.setVisible( true );
        f.setDefaultCloseOperation( javax.swing.JFrame.DISPOSE_ON_CLOSE );
    }
    
    /**
     * Getter for property jLabelPath.
     * @return Value of property jLabelPath.
     */
    public javax.swing.JLabel getJLabelPath()
    {
        return jLabelPath;
    }    
    
    /**
     * Setter for property jLabelPath.
     * @param jLabelPath New value of property jLabelPath.
     */
    public void setJLabelPath(javax.swing.JLabel jLabelPath)
    {
        this.jLabelPath = jLabelPath;
    }
    
    /**
     * Getter for property jTextFieldFolder.
     * @return Value of property jTextFieldFolder.
     */
    public javax.swing.JTextField getJTextFieldFolder()
    {
        return jTextFieldFolder;
    }
    
    /**
     * Setter for property jTextFieldFolder.
     * @param jTextFieldFolder New value of property jTextFieldFolder.
     */
    public void setJTextFieldFolder(javax.swing.JTextField jTextFieldFolder)
    {
        this.jTextFieldFolder = jTextFieldFolder;
    }
    
    /**
     * Getter for property jTextFieldPath.
     * @return Value of property jTextFieldPath.
     */
    public javax.swing.JTextField getJTextFieldPath()
    {
        return jTextFieldPath;
    }
    
    /**
     * Setter for property jTextFieldPath.
     * @param jTextFieldPath New value of property jTextFieldPath.
     */
    public void setJTextFieldPath(javax.swing.JTextField jTextFieldPath)
    {
        this.jTextFieldPath = jTextFieldPath;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabelFolder;
    private javax.swing.JLabel jLabelPath;
    private javax.swing.JTextField jTextFieldFolder;
    private javax.swing.JTextField jTextFieldPath;
    // End of variables declaration//GEN-END:variables
   
}
