/*
 * DeltaEditorChangeListener.java
 *
 * Created on 19. M�rz 2004, 16:02
 */

package net.metadiversity.diversity.navigator.gui.delta_editor;

import net.metadiversity.diversity.navigator.db.delta_editor.DeltaEditorData;
import net.metadiversity.diversity.navigator.db.delta_editor.CharacterStateDescriptionEntry;
// import net.metadiversity.diversity.navigator.db.delta_editor.CharacterStateElement;

import org.apache.log4j.Logger;
/**
 *
 * @author  didi
 */
public class DeltaEditorChangeListener implements javax.swing.event.ChangeListener
{
    static Logger logger = Logger.getLogger( DeltaEditorChangeListener.class.getName() );
    DeltaEditorData ded;
    CharacterStateEditor characterStateEditor;
    int iid;    // Used iid and cid
    int cid;
    
    /** Creates a new instance of DeltaEditorChangeListener */
    public DeltaEditorChangeListener( CharacterStateEditor cse, DeltaEditorData ded, int iid, int cid )
    {
        characterStateEditor = cse;
        this.ded = ded;
        this.iid = iid;
        this.cid = cid;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void stateChanged( javax.swing.event.ChangeEvent changeEvent )
    {
        // logger.debug( "DeltaEditor -stateChanged : " + changeEvent );
        
        DeltaEditorChangeEvent ce = (DeltaEditorChangeEvent) changeEvent;
                
        logger.debug( "Mode : " + ce.getMode() + " row : " + ce.getRow() + " col : " + ce.getColumn() );
        
        Object obj = ce.getSource();
        switch( ce.getMode() )
        {
        case DeltaEditorChangeEvent.ADD_CHARACTER_STATE :            
            if( obj instanceof CharacterStateModel )
            {
                CharacterStateModel csm = (CharacterStateModel) obj;
                if( ce.getColumn() == 0 )
                {    
                    String cs = (String) csm.getValueAt( ce.getRow(), 1 );
                    CharacterStateDescriptionEntry csde = new CharacterStateDescriptionEntry( iid, cid, cs );
                    characterStateEditor.getModel().addCharacterStateDescriptionEntry( csde );
                    characterStateEditor.setVisible( true );
                    
                    // add to database
                    ded.inserCharacterStateDescriptionEntry( csde );
                }
            }            
            break;
            
        case DeltaEditorChangeEvent.REMOVE_CHARACTER_STATE :            
            boolean ret = false;
            if( obj instanceof CharacterStateModel )
            {
                CharacterStateModel csm = (CharacterStateModel) obj;
                if( ce.getColumn() == 0 )
                {    
                    String cs = (String) csm.getValueAt( ce.getRow(), 1 );
                
                    ret = characterStateEditor.getModel().removeCharacterStateDescriptionEntry( cs );
                    if( ret == false )
                    {
                        // can't remove this entry
                        csm.setCaracterStateSeletion( true, cs );
                    }
                    else
                    {
                        // remove from database
                        CharacterStateDescriptionEntry csde = new CharacterStateDescriptionEntry( iid, cid, cs );
                        ded.removeCharacterStateDescriptionEntry( csde );
                    }
                    characterStateEditor.setVisible( true );
                }
            }
            break;
            
        case DeltaEditorChangeEvent.UPDATE_CHARACTER_DESCRIPTION_STATE :
            
            if( obj instanceof CharacterStateEditorModel )
            {
                CharacterStateEditorModel csem = (CharacterStateEditorModel) obj;
                
                if( ce.getColumn() > 0 )
                {
                    CharacterStateDescriptionEntry csde = csem.getCharacterStateDescriptionEntry( ce.getRow() );
                    ded.updateCharacterStateDescriptionEntry( csde );
                }
            }
            break;
        }
    }    
}
