package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import java.util.Set;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="ProjectProxy"
 *     
*/
public class ProjectProxy implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3760558672446568241L;

    /** identifier field */
    private String project;

    /** persistent field */
    private int projectId;

    /** persistent field */
    private Set taxonHierarchies;

    /** persistent field */
    private Set taxonAcceptedNames;

    /** persistent field */
    private Set taxonSynonymies;

    /** full constructor */
    public ProjectProxy(String project, int projectId, Set taxonHierarchies, Set taxonAcceptedNames, Set taxonSynonymies) {
        this.project = project;
        this.projectId = projectId;
        this.taxonHierarchies = taxonHierarchies;
        this.taxonAcceptedNames = taxonAcceptedNames;
        this.taxonSynonymies = taxonSynonymies;
    }

    /** default constructor */
    public ProjectProxy() {
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *             type="java.lang.String"
     *             column="Project"
     *         
     */
    public String getProject() {
        return this.project;
    }

    public void setProject(String project) {
        this.project = project;
    }

    /** 
     *            @hibernate.property
     *             column="ProjectID"
     *             length="10"
     *             not-null="true"
     *         
     */
    public int getProjectId() {
        return this.projectId;
    }

    public void setProjectId(int projectId) {
        this.projectId = projectId;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="Project"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchy"
     *         
     */
    public Set getTaxonHierarchies() {
        return this.taxonHierarchies;
    }

    public void setTaxonHierarchies(Set taxonHierarchies) {
        this.taxonHierarchies = taxonHierarchies;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="Project"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonAcceptedName"
     *         
     */
    public Set getTaxonAcceptedNames() {
        return this.taxonAcceptedNames;
    }

    public void setTaxonAcceptedNames(Set taxonAcceptedNames) {
        this.taxonAcceptedNames = taxonAcceptedNames;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="Project"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonSynonymy"
     *         
     */
    public Set getTaxonSynonymies() {
        return this.taxonSynonymies;
    }

    public void setTaxonSynonymies(Set taxonSynonymies) {
        this.taxonSynonymies = taxonSynonymies;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("project", getProject())
            .toString();
    }

}
