package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import java.util.Set;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="TaxonNameNomenclaturalCode_Enum"
 *     
*/
public class TaxonNameNomenclaturalCodeEnum implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3690476900736972596L;

    /** identifier field */
    private String code;

    /** nullable persistent field */
    private String description;

    /** nullable persistent field */
    private String displayText;

    /** nullable persistent field */
    private Short displayOrder;

    /** nullable persistent field */
    private Boolean displayEnable;

    /** nullable persistent field */
    private String internalNotes;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum taxonNameNomenclaturalCodeEnum;

    /** persistent field */
    private Set taxonNames;

    /** persistent field */
    private Set taxonNameNomenclaturalCodeEnums;

    /** full constructor */
    public TaxonNameNomenclaturalCodeEnum(String code, String description, String displayText, Short displayOrder, Boolean displayEnable, String internalNotes, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum taxonNameNomenclaturalCodeEnum, Set taxonNames, Set taxonNameNomenclaturalCodeEnums) {
        this.code = code;
        this.description = description;
        this.displayText = displayText;
        this.displayOrder = displayOrder;
        this.displayEnable = displayEnable;
        this.internalNotes = internalNotes;
        this.taxonNameNomenclaturalCodeEnum = taxonNameNomenclaturalCodeEnum;
        this.taxonNames = taxonNames;
        this.taxonNameNomenclaturalCodeEnums = taxonNameNomenclaturalCodeEnums;
    }

    /** default constructor */
    public TaxonNameNomenclaturalCodeEnum() {
    }

    /** minimal constructor */
    public TaxonNameNomenclaturalCodeEnum(String code, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum taxonNameNomenclaturalCodeEnum, Set taxonNames, Set taxonNameNomenclaturalCodeEnums) {
        this.code = code;
        this.taxonNameNomenclaturalCodeEnum = taxonNameNomenclaturalCodeEnum;
        this.taxonNames = taxonNames;
        this.taxonNameNomenclaturalCodeEnums = taxonNameNomenclaturalCodeEnums;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *             type="java.lang.String"
     *             column="Code"
     *         
     */
    public String getCode() {
        return this.code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    /** 
     *            @hibernate.property
     *             column="Description"
     *             length="800"
     *         
     */
    public String getDescription() {
        return this.description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    /** 
     *            @hibernate.property
     *             column="DisplayText"
     *             length="50"
     *         
     */
    public String getDisplayText() {
        return this.displayText;
    }

    public void setDisplayText(String displayText) {
        this.displayText = displayText;
    }

    /** 
     *            @hibernate.property
     *             column="DisplayOrder"
     *             length="5"
     *         
     */
    public Short getDisplayOrder() {
        return this.displayOrder;
    }

    public void setDisplayOrder(Short displayOrder) {
        this.displayOrder = displayOrder;
    }

    /** 
     *            @hibernate.property
     *             column="DisplayEnable"
     *             length="1"
     *         
     */
    public Boolean getDisplayEnable() {
        return this.displayEnable;
    }

    public void setDisplayEnable(Boolean displayEnable) {
        this.displayEnable = displayEnable;
    }

    /** 
     *            @hibernate.property
     *             column="InternalNotes"
     *             length="500"
     *         
     */
    public String getInternalNotes() {
        return this.internalNotes;
    }

    public void setInternalNotes(String internalNotes) {
        this.internalNotes = internalNotes;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="ParentCode"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum getTaxonNameNomenclaturalCodeEnum() {
        return this.taxonNameNomenclaturalCodeEnum;
    }

    public void setTaxonNameNomenclaturalCodeEnum(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum taxonNameNomenclaturalCodeEnum) {
        this.taxonNameNomenclaturalCodeEnum = taxonNameNomenclaturalCodeEnum;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="NomenclaturalCode"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName"
     *         
     */
    public Set getTaxonNames() {
        return this.taxonNames;
    }

    public void setTaxonNames(Set taxonNames) {
        this.taxonNames = taxonNames;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="ParentCode"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum"
     *         
     */
    public Set getTaxonNameNomenclaturalCodeEnums() {
        return this.taxonNameNomenclaturalCodeEnums;
    }

    public void setTaxonNameNomenclaturalCodeEnums(Set taxonNameNomenclaturalCodeEnums) {
        this.taxonNameNomenclaturalCodeEnums = taxonNameNomenclaturalCodeEnums;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("code", getCode())
            .toString();
    }

}
