/*
 * FilterTableModel.java
 *
 * Created on 22. Mai 2003, 12:50
 */

package net.metadiversity.diversity.navigator.table;

import javax.swing.table.*;
// import javax.swing.table.TableCellRenderer;
// import javax.swing.DefaultCellEditor;

import org.apache.log4j.Logger;
/**
 *
 * @author  didi
 */
public class FilterTableModel extends AbstractTableModel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 4050769281958295856L;

    static Logger logger = Logger.getLogger( FilterTableModel.class.getName() );
    
    final static String andOr [] = { "AND", "OR" }; 
    final static String ops []   = { "=", "!=", "<", ">", "<=", ">=", "like", "not like", "~", "~*", "!~", "!~*" }; 
    final static String opc[]    = { "ASC", "DESC" };
    
    
    public static final int SELECT_COLUMN    = 0;
    public static final int NAME_COLUMN      = 1;
    public static final int WHERE_COLUMN     = 2;
    public static final int VALUE_COLUMN     = 3;
    public static final int ANDOR_COLUMN     = 4;
    
    String [] colNames =
    {
        "Select", "Name", "Where", "Value", "And/Or"
    };
    
    Class[] colTypes = new Class []
    {
        java.lang.Boolean.class,    // is selected
        java.lang.String.class,
        javax.swing.JComboBox.class,
        java.lang.String.class,
        javax.swing.JComboBox.class
//        AndOrSelector.class
    };
    
    boolean[] colCanEdit = new boolean []
    {
        true, false, true, true, true
    };
    
    //--------------------------------------------------------------------------
    TableTableModel resultModel; 

    public FilterTableModel( TableTableModel resultModel )
    {
        // System.out.println( "DetailsTableModel()" );
        this.resultModel = resultModel;
    }
    
    public int getColumnCount()
    {
        return 5;
    }
    
    public int getRowCount()    
    {
        return resultModel.getTablesDetailsCount();
    }
    
    public Object getValueAt( int row, int col )    
    {
        switch( col )
        {
            case SELECT_COLUMN: // selected  
                return Boolean.valueOf( true );
                
            case NAME_COLUMN: // filed name          
                return resultModel.getTableColumnDetails( row, 0 );
                
            case WHERE_COLUMN: // where                                
//                return new javax.swing.JComboBox( ops );
                return "=";
                
            case VALUE_COLUMN: // Editor                
                return new String() ;
                 
            case ANDOR_COLUMN: // And Or
//                return new AndOrSelector();    
                return "and";
            default :
                return "error";
        }        
        // return  resultModel.getTableColumnDetails( row, col ); 
    }
    
    public Class getColumnClass( int columnIndex )
    {
        return colTypes[ columnIndex ];
    }

    public boolean isCellEditable( int rowIndex, int columnIndex )
    {
        return colCanEdit[ columnIndex ];
    }
    
    public String getColumnName( int i )
    {
        return colNames[ i ];
    }        
}
