/*
 * ImportMsDbTable.java
 *
 * Created on 18. September 2003, 14:59
 */

package net.metadiversity.diversity.navigator.util;

import java.sql.*;
import java.io.*;
import java.util.*;
import java.lang.StringBuffer;
// import javax.xml.parsers.*;
// import org.w3c.dom.*;
// import org.xml.sax.*;
// import org.xml.sax.helpers.*;


// JDOM

import org.jdom.Document;
import org.jdom.Element;
//import org.jdom.Comment;
//import org.jdom.output.XMLOutputter;
import org.jdom.input.SAXBuilder;


// import org.apache.xerces.dom.*;


/**
 *
 * @author  Dieter Neubacher
 */
public class ImportMsDbTable
{    
    java.lang.String db_url     = "jdbc:postgresql://hongkong:5432/bsm-email-list";
    java.lang.String db_user    = "didi";
    java.lang.String db_pwd     = "";
    java.lang.String db_driver  = "org.postgresql.Driver";
    java.lang.String file       = ""; 
    
    java.util.Vector columnType    = null;
    java.util.Vector columnName    = null;
    
    Connection con  = null;
    String importFileName = null;
    
    
    final static boolean setAutoCommit = false;  // AutoCommit not posible whis SuSE 9.1 and Postgresql Version: 7.4
    
    final static boolean debugShowValues = false;
    
    
    final static String DATESTYLE_EUROPEAN_GERMAN = "SET DATESTYLE TO EUROPEAN, GERMAN;";
    final static char optionNumberFormatDotCharacter = ',';
    
    /** Creates a new instance of ImportMsDbTable */
    public ImportMsDbTable( String url, String user, String pwd, String filename )
    {
        db_url  = url;
        db_user = user;
        db_pwd  = pwd;
        file    = filename;
        
        columnType = new java.util.Vector();                
        columnName = new java.util.Vector();                
        
        System.out.println();
        System.out.println( "Import Data from file: " + filename );
        System.out.println();
    }    
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    private int connect()
    {
        // load driver and get DB-Connection
        try
        {
            Class.forName( "org.postgresql.Driver" );
            System.out.println( "Load PostgreSQL Driver..." );
        }
        catch( java.lang.ClassNotFoundException ee )
        {
            System.out.println( "ClassNotFoundException: " );
            System.out.println( ee.getMessage() );
            
            System.exit( 1 );
        }
        try
        {
            con = java.sql.DriverManager.getConnection( db_url, db_user, db_pwd );
        }            
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getMessage() );             
            System.exit( 2 );
        }
        
        return 0;
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
/*    
    public int importTable()
    {
        File f = new File( file );
        if( ! f.canRead() )
        {
            System.out.println( "Can't read input file: " + file );
            return 1;
        }
        try
        {
            connect();
            
            javax.xml.parsers.DocumentBuilderFactory factory = javax.xml.parsers.DocumentBuilderFactory.newInstance();
            // factory.setValidating( true );        // enable Validating with DTD
            javax.xml.parsers.DocumentBuilder docBuilder = factory.newDocumentBuilder();
            docBuilder.setErrorHandler( new XmlSaxErrorHandler() ); 
            org.w3c.dom.Document doc = docBuilder.parse( file );
            
            // get TableName
            
            Element root = doc.getDocumentElement();            
            System.out.println( root.getTagName() );
            NodeList childern = root.getChildNodes();
            
            String tableName = "test";
            System.out.println( "TableName: " + tableName );            
            getTableColumnInfo( tableName );
            for( int i=0; i < childern.getLength(); i++ ) 
            {
                Node child = childern.item( i );
                
                if( child instanceof Element )
                {    
                    Element childElement = (Element) child;
                    Node textNode = childElement.getFirstChild();
                    String text = textNode.getNodeValue().trim();
                    System.out.print( text );
                }    
                if( child instanceof Node )
                {    
                    System.out.print( child.getNodeValue().trim() );
                }    
            }            
        }
        catch( javax.xml.parsers.ParserConfigurationException ex )
        {
            System.out.println( ex.getLocalizedMessage() );
        }
        catch( org.xml.sax.SAXException ex )
        {
            System.out.println( ex.getLocalizedMessage() );
        }
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
        }
        catch( java.io.IOException ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
        }
        return 0;
    }
*/
    public int importTable()
    {
        boolean errorFlag = false;
        
        java.lang.StringBuffer lastInsertString = null;
        
        java.sql.Statement s;
        java.sql.PreparedStatement pstmt;
        
        File f = new File( file );
        if( ! f.canRead() )
        {
            System.out.println( "Can't read input file: " + file );
            return 1;
        }
        try
        {
            connect();
            // Load XML into JDOM Document                
            SAXBuilder builder = new SAXBuilder();
            Document doc = builder.build( file );
            //  List of rows
            // init column infos   
            String tableName = null;
            try
            {
                tableName = ((Element) doc.getRootElement().getChildren().get( 0 ) ).getName(); 
            }
            catch( Exception ex )
            {
                System.out.println( "ERROR: Can't get RootElement from file: " + file );
                return 1;
            }
            if( tableName == null )
            {
                System.out.println( "ERROR: Can't read TabelName from file: " + file );
                return 1;
            }
            System.out.println( "TableName: " + tableName );            
            getTableColumnInfo( tableName );
            //------------------------------------------------------------------
            // prepare SQL Statment's
            //------------------------------------------------------------------
            if( setAutoCommit )
            {
                con.setAutoCommit( false );
            }
            s = con.createStatement();
// ??? don't work whis Postgres 7.4 and SuSE 9.1
//            s.execute( "BEGIN TRANSACTION" );
            // set formats 
            s.execute( DATESTYLE_EUROPEAN_GERMAN );
            s.close();
            
            StringBuffer sqlInsertStatement = new StringBuffer();
            StringBuffer sqlFields = new StringBuffer();
            StringBuffer sqlValues = new StringBuffer();
            
            sqlInsertStatement.append( "INSERT INTO " + "\"" + tableName + "\" ( " );
            // add fields
            for( int i = 0; i < columnName.size(); i++ )
            {   
                if( i > 0 )
                {
                    sqlFields.append( ", ");
                    sqlValues.append( ", ");
                }
                sqlFields.append( "\"" + columnName.get( i ) + "\"" );
                sqlValues.append( "?");
            }
            String sql =  sqlInsertStatement.toString() + sqlFields.toString() + ") VALUES ( " + sqlValues.toString() +" );";
            System.out.println( sql );
            pstmt = con.prepareStatement( sql );            
           
            // Import from Microsoft XML file
            java.util.List rows = doc.getRootElement().getChildren();
            for( Iterator i = rows.iterator(); i.hasNext(); )
            {
                pstmt.clearParameters();                
                Element rowNode = (Element) i.next();                
                if( rowNode != null )
                {
                    lastInsertString = new StringBuffer();
                    
                    Vector row = new Vector();
                    for( int c = 0; c < columnType.size(); c++ ) 
                    {
                        // get Data Type for this collumn   
                        int type = ((Short) columnType.get( c )).intValue();
                        String  name = ((String) columnName.get( c ));

                        String value = (String) rowNode.getChildTextNormalize( name );
                        lastInsertString.append( "[" + value + "]" );
                        if( debugShowValues )
                        {    
                            System.out.println( "Type: " + type + " Name: " + name + " " + value );
                        }
                        if( value == null )
                        {   
                            // set NULL into DataBaseField
                            pstmt.setNull( c + 1, type );                            
                            continue;
                        }                            
                        switch( type )
                        {
                        // BOOLEAN
                        case java.sql.Types.BIT :                                        
                            if( value.compareTo( "0" ) == 0 || value.compareTo( "f" ) == 0 )
                            {
                                pstmt.setBoolean( c + 1, false );
                            }
                            if( value.compareTo( "1" ) == 0 || value.compareTo( "t" ) == 0 )
                            {
                                pstmt.setBoolean( c + 1, true  );
                            }
                            break;
                        // NUMERIC VALUES    
                        case java.sql.Types.DECIMAL :
                        case java.sql.Types.DOUBLE :
                        case java.sql.Types.FLOAT :                                
                        case java.sql.Types.REAL:
                                value = value.replace( optionNumberFormatDotCharacter, '.' );
                                pstmt.setDouble( c + 1, java.lang.Double.parseDouble( value ) );
                                break;
/*                            
                        case java.sql.Types.BIGINT :
                                pstmt.setLong( c + 1, java.lang.Long.parseLong( value ) );
                                break;
                        case java.sql.Types.INTEGER :        
                                pstmt.setInt( c + 1, java.lang.Integer.parseInt( value ) );
                                break;
                        case java.sql.Types.TINYINT : 
                        case java.sql.Types.SMALLINT :
                                pstmt.setShort( c + 1, java.lang.Short.parseShort( value ) );
                                break;
                                
                        // DATE, TIME, TIMESTAMP    
                        case java.sql.Types.DATE :
                                // s - date in format "yyyy-mm-dd" 
                                pstmt.setDate( c + 1, java.sql.Date.valueOf( value ) );
                                break;
                        case java.sql.Types.TIME :
                                // s - time in format "hh:mm:ss" 
                                pstmt.setTime( c + 1, java.sql.Time.valueOf( value ) );;
                                break;
                        case java.sql.Types.TIMESTAMP :
                                // s - timestamp in format yyyy-mm-dd hh:mm:ss.fffffffff 
                                if( value != null ) value = value.replace( 'T', ' ' );
                                //pstmt.setTimestamp( c, java.sql.Timestamp.valueOf( value ) );
                                pstmt.setString( c + 1, value );
                            break;
                        // STRINGS    
                        case java.sql.Types.VARCHAR :        
                                pstmt.setString( c + 1, value );
                                break;               
*/                                
                        default :
                                pstmt.setString( c + 1, value );
                            break;
                        }    
                    }
                }
                pstmt.execute();
            }        
        }
        catch( org.jdom.JDOMException ex )
        {
            System.out.println( ex.getLocalizedMessage() );
            System.out.println( lastInsertString.toString() );
            errorFlag = true;
        }
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
            System.out.println( lastInsertString.toString() );
            errorFlag = true;
        }
        catch( java.io.IOException ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
            System.out.println( lastInsertString.toString() );
            ex.printStackTrace();
            errorFlag = true;
        }
        catch( java.lang.Exception ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
            System.out.println( lastInsertString.toString() );
            ex.printStackTrace();
            errorFlag = true;
        }
        finally
        {
            try
            {
                if( errorFlag )
                {    
// ??? don't work whis Postgres 7.4 and SuSE 9.1
                    con.rollback();
                    System.out.println( "Rollback Data" );
                }
                else
                {
// ??? don't work whis Postgres 7.4 and SuSE 9.1
                    con.commit();
                    System.out.println( "Commit Data" );
                 }    
                con.close();
            }
            catch(  java.sql.SQLException ex )
            {
                System.out.println( ex.getLocalizedMessage() );             
            }
        }
            
        return 0;
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    private int importData()
    {
        return 0;
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    private void getTableColumnInfo( String tableName ) throws java.sql.SQLException
    {
            DatabaseMetaData dbmd = con.getMetaData();
            ResultSet columnResultSet;

            //columnResultSet = dbmd.getColumns( null, null, "\"" + tableName + "\"", null );
            columnResultSet = dbmd.getColumns( null, null, tableName, null );
            
            System.out.println( "Get tabel infos for table : >" + tableName + "<"  ); 
            
            boolean no_columns_flag = true;
            
            while( columnResultSet.next() ) 
            {
                no_columns_flag = false;
                
                String name         = columnResultSet.getString(    "COLUMN_NAME" );
                short dataType      = columnResultSet.getShort(     "DATA_TYPE"   );
                // String typeName     = columnResultSet.getString(    "TYPE_NAME"   );
                // int size            = columnResultSet.getInt(       "COLUMN_SIZE" );
                // int decimals        = columnResultSet.getInt(       "DECIMAL_DIGITS");
                // int nullable        = columnResultSet.getInt(       "NULLABLE"    );
                // String defaultVal   = columnResultSet.getString(    "COLUMN_DEF"  );
                // boolean nulls       = ( nullable == DatabaseMetaData.columnNullable );

                columnType.add( new java.lang.Short( dataType ) );
                columnName.add( new java.lang.String( name ) );

                System.out.println( name + ": " + dataType );
            }
            
            if( no_columns_flag )
            {
                System.out.println( "!!! Can't read table infos. !!! Table don't exist. !!!" ); 
            }
            columnResultSet.close();        
    }
    
    //--------------------------------------------------------------------------
    // Errorhandler
    //--------------------------------------------------------------------------
    public static class XmlSaxErrorHandler implements org.xml.sax.ErrorHandler
    {        
        
        public void warning( org.xml.sax.SAXParseException ex ) throws org.xml.sax.SAXException 
        {
            System.out.println( ex.toString() );
        }
        public void error( org.xml.sax.SAXParseException ex ) throws org.xml.sax.SAXException 
        {
            System.out.println( ex.toString() );
        }
        public void fatalError( org.xml.sax.SAXParseException ex ) throws org.xml.sax.SAXException
        {
            System.out.println( ex.toString() );
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        if( args.length == 0 || args.length > 4 )
        {
            System.out.println( "usage: java net.metadiversity.diversity.navigator.util url user password file" );
            System.out.println( "" );
            System.out.println( "url:       \"jdbc:postgresql://hongkong:5432/db-name\"" );
            System.out.println( "user:      username" );
            System.out.println( "password   password" );
            System.out.println( "file:      Microsoft-XML-Export-File-Name" );
            
            ImportMsDbTable importTable = null;
            // test
            // ImportMsDbTable importTable = new ImportMsDbTable( "jdbc:postgresql://hongkong:5432/ubt-collection-94", "didi", "", "/home/didi/export-ubt-xml-2003.10.02/xColl_TypeStatus_Enum.xml" );
            // ImportMsDbTable importTable = new ImportMsDbTable( "jdbc:postgresql://hongkong:5432/ubt-description-94", "didi", "", "/home/didi/export-ubt-xml-2003.10.02/BIOTA_S04_DESCR.xml" );
            // ImportMsDbTable importTable = new ImportMsDbTable( "jdbc:postgresql://hongkong:5432/ubt-collection-94", "didi", "", "/home/didi/export-ubt-xml-2003.10.02/xColl_TypeStatus_Enum.xml" );
            //
            // Liaslight
            //
            // java -cp .\jar\diversity_navigator.jar;.\jar\jdom-b9.jar;.\jar\pg73jdbc3.jar net.metadiversity.diversity.navigator.util.ImportMsDbTable jdbc:postgresql://127.0.0.1:5432/DiversityTaxonNames_OnlyTables didi ******** dbo_ApplicationSearchSelectionStrings.xml
            importTable = new ImportMsDbTable( "jdbc:postgresql://127.0.0.1:5432/DiversityTaxonNames_OnlyTables", "didi", "********", "/dbo_ApplicationSearchSelectionStrings.xml" );
            importTable.importTable();
            
//  			importTable = new ImportMsDbTable( "jdbc:postgresql://hongkong:5432/DiversityDescriptions_LIASlight", "didi", "", "/DBUpload/DiversityDescriptions_LIASlight/XML/LIASlight_CHAR.xml" );
//            importTable.importTable();
            
//            importTable = new ImportMsDbTable( "jdbc:postgresql://hongkong:5432/DiversityDescriptions_LIASlight", "didi", "", "/DBUpload/DiversityDescriptions_LIASlight/XML/LIASlight_DESCR.xml" );
//            importTable.importTable();
        }
        else
        {
            // get paramms
            
            ImportMsDbTable importTable = new ImportMsDbTable( args[ 0 ], args[ 1 ], args[ 2 ], args[ 3 ] );
            importTable.importTable();
        }
        System.exit( 0 );
    }    
}
