package net.metadiversity.diversity.navikey.bo;

import java.net.URL;

/**
 * Resource.java
 * resources will be displays of useful information (ie. images/sounds/urls)
 * @author Michael Bartley
 * 7/16/98
 */

public abstract class Resource
{
    public    String defaultLocation;
    
    protected String mimeType = null;
    protected URL location =  null;
    protected String file = null;
    protected String notes = null;
    protected String title = null;
    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    protected Resource()
    {
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    protected Resource(URL url, String s)
    {
        location = url;
        mimeType = s;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public abstract void display();
    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setMimeType(String s)
    {
        mimeType = s;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setLocation(URL url)
    {
        location = url;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setNotes(String s)
    {
        notes = s;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setTitle(String s)
    {
        title = s;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setLocation(String url)
    {
        try
        {
            location = new URL(url);
        }
        catch(Exception e)
        {
            System.out.println(e+"\nPassed bad url for location: "+url);
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public void setFile(String fname)
    {
        file = fname;
        setLocation(defaultLocation + file);
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public URL getLocation()
    {
        return location;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public String getMimeType()
    {
        return mimeType;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public String getFile()
    {
        return file;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public String getNotes()
    {
        return notes;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public String getTitle()
    {
        return title;
    }
}
