package net.metadiversity.diversity.navikey.resource;

import java.awt.Button;
import java.awt.Event;

import net.metadiversity.diversity.navikey.bo.Resource;


/**
 * ResourceButton.java
 * extends Button
 * holds a Resource, which will be fired upon the buttons selection
 * @author Michael Bartley
 * 7/17/98
 */

public class ResourceButton extends Button
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3762813796632115509L;
    
    private Resource resource;
    
    public ResourceButton(Resource r)
    {
        super();
        resource = r;
        setLabel(resource.getMimeType());
    }
    
    public void setResource(Resource r)
    {
        resource = r;
    }
    public Resource getResource()
    {
        return resource;
    }
    
    public boolean action(Event e, Object arg)
    {
        if(e.id == Event.ACTION_EVENT)
        {
            resource.display();
            return true;
        }
        return false;
    }
}
